define(["@jupyter-widgets/base"],(t=>(()=>{"use strict";var e={146:e=>{e.exports=t},147:t=>{t.exports=JSON.parse('{"name":"pdpilot","version":"0.4.0","description":"A Jupyter widget for exploring partial dependence plots.","keywords":["jupyter","jupyterlab","jupyterlab-extension","widgets"],"files":["lib/**/*.js","dist/*.js","css/*.css"],"homepage":"https://github.com/DanielKerrigan/PDPilot","bugs":{"url":"https://github.com/DanielKerrigan/PDPilot/issues"},"license":"BSD-3-Clause","author":{"name":"Daniel Kerrigan","email":"kerrigan.d@northeastern.edu"},"main":"lib/index.js","types":"./lib/index.d.ts","repository":{"type":"git","url":"https://github.com/DanielKerrigan/PDPilot"},"scripts":{"build":"webpack --mode=development && jupyter labextension build --development=True .","build:prod":"webpack --mode=production && jupyter labextension build .","clean":"yarn run clean:lib && yarn run clean:nbextension && yarn run clean:labextension","clean:lib":"rimraf lib","clean:labextension":"rimraf pdpilot/labextension","clean:nbextension":"rimraf pdpilot/nbextension/static/index.js","fix":"prettier --plugin-search-dir . --write src && eslint . --ext .ts,.tsx,.svelte --fix","check":"prettier --plugin-search-dir . --check src && eslint . --ext .ts,.tsx,.svelte","prepack":"yarn run build:prod","watch":"yarn run watch:nbextension","watch:nbextension":"webpack --watch --mode=development","watch:labextension":"jupyter labextension watch .","test":"uvu -r tsm tests"},"dependencies":{"@jupyter-widgets/base":"^1.1.10 || ^2 || ^3 || ^4 || ^5 || ^6","d3":"^7.4.4","simple-statistics":"^7.8.0"},"devDependencies":{"@babel/core":"^7.5.0","@babel/preset-env":"^7.5.0","@jupyterlab/builder":"^3.0.0","@lumino/application":"^1.6.0","@lumino/widgets":"^1.6.0","@tsconfig/svelte":"^3.0.0","@types/d3":"^7.4.0","@types/webpack-env":"^1.13.6","@typescript-eslint/eslint-plugin":"^5.45.0","@typescript-eslint/parser":"^5.45.0","acorn":"^7.2.0","css-loader":"^6.7.0","eslint":"^8.28.0","eslint-config-prettier":"^8.5.0","eslint-plugin-svelte3":"^4.0.0","fs-extra":"^7.0.0","identity-obj-proxy":"^3.0.0","mkdirp":"^0.5.1","npm-run-all":"^4.1.3","prettier":"^2.8.0","prettier-plugin-svelte":"^2.8.1","rimraf":"^2.6.2","source-map-loader":"^1.1.3","style-loader":"^3.0.0","svelte":"^3.54.0","svelte-loader":"^3.1.5","svelte-preprocess":"5.0.0","ts-loader":"^9.0.0","tsm":"^2.2.1","typescript":"^4.9.3","tslib":"^2.4.1","uvu":"^0.5.3","webpack":"^5.0.0","webpack-cli":"^4.0.0"},"jupyterlab":{"extension":true,"outputDir":"pdpilot/labextension/"}}')}},n={};function r(t){var i=n[t];if(void 0!==i)return i.exports;var o=n[t]={exports:{}};return e[t](o,o.exports,r),o.exports}r.d=(t,e)=>{for(var n in e)r.o(e,n)&&!r.o(t,n)&&Object.defineProperty(t,n,{enumerable:!0,get:e[n]})},r.o=(t,e)=>Object.prototype.hasOwnProperty.call(t,e),r.r=t=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})};var i={};return(()=>{r.r(i),r.d(i,{MODULE_NAME:()=>n,MODULE_VERSION:()=>e,PDPilotModel:()=>Th,PDPilotView:()=>Oh});const t=r(147),e=t.version,n=t.name;var o=r(146);function l(){}function a(t){return t()}function s(){return Object.create(null)}function c(t){t.forEach(a)}function u(t){return"function"==typeof t}function h(t,e){return t!=t?e==e:t!==e||t&&"object"==typeof t||"function"==typeof t}function d(t){return 0===Object.keys(t).length}function f(t,...e){if(null==t)return l;const n=t.subscribe(...e);return n.unsubscribe?()=>n.unsubscribe():n}function p(t,e,n){t.$$.on_destroy.push(f(e,n))}function g(t,e,n,r){return t[1]&&r?function(t,e){for(const n in e)t[n]=e[n];return t}(n.ctx.slice(),t[1](r(e))):n.ctx}function m(t,e,n){return t.set(n),e}new Set;let v,y=!1;function w(t,e){t.appendChild(e)}function b(t,e,n){const r=function(t){if(!t)return document;const e=t.getRootNode?t.getRootNode():t.ownerDocument;return e&&e.host?e:t.ownerDocument}(t);if(!r.getElementById(e)){const t=k("style");t.id=e,t.textContent=n,function(t,e){w(t.head||t,e),e.sheet}(r,t)}}function $(t,e,n){t.insertBefore(e,n||null)}function x(t){t.parentNode&&t.parentNode.removeChild(t)}function _(t,e){for(let n=0;n<t.length;n+=1)t[n]&&t[n].d(e)}function k(t){return document.createElement(t)}function M(t){return document.createElementNS("http://www.w3.org/2000/svg",t)}function L(t){return document.createTextNode(t)}function A(){return L(" ")}function z(){return L("")}function S(t,e,n,r){return t.addEventListener(e,n,r),()=>t.removeEventListener(e,n,r)}function N(t,e,n){null==n?t.removeAttribute(e):t.getAttribute(e)!==n&&t.setAttribute(e,n)}function C(t,e,n){const r=new Set;for(let e=0;e<t.length;e+=1)t[e].checked&&r.add(t[e].__value);return n||r.delete(e),Array.from(r)}function T(t,e){e=""+e,t.wholeText!==e&&(t.data=e)}function O(t,e){t.value=null==e?"":e}function E(t,e,n,r){null===n?t.style.removeProperty(e):t.style.setProperty(e,n,r?"important":"")}function D(t,e){for(let n=0;n<t.options.length;n+=1){const r=t.options[n];if(r.__value===e)return void(r.selected=!0)}t.selectedIndex=-1}function R(t){const e=t.querySelector(":checked")||t.options[0];return e&&e.__value}function B(t,e,n){t.classList[n?"add":"remove"](e)}function j(t){v=t}function q(){if(!v)throw new Error("Function called outside component initialization");return v}function P(t){q().$$.on_mount.push(t)}function I(){const t=q();return(e,n,{cancelable:r=!1}={})=>{const i=t.$$.callbacks[e];if(i){const o=function(t,e,{bubbles:n=!1,cancelable:r=!1}={}){const i=document.createEvent("CustomEvent");return i.initCustomEvent(t,n,r,e),i}(e,n,{cancelable:r});return i.slice().forEach((e=>{e.call(t,o)})),!o.defaultPrevented}return!0}}new Map;const H=[],F=[],V=[],X=[],W=Promise.resolve();let Y=!1;function K(t){V.push(t)}function U(t){X.push(t)}const G=new Set;let Z=0;function J(){const t=v;do{for(;Z<H.length;){const t=H[Z];Z++,j(t),Q(t.$$)}for(j(null),H.length=0,Z=0;F.length;)F.pop()();for(let t=0;t<V.length;t+=1){const e=V[t];G.has(e)||(G.add(e),e())}V.length=0}while(H.length);for(;X.length;)X.pop()();Y=!1,G.clear(),j(t)}function Q(t){if(null!==t.fragment){t.update(),c(t.before_update);const e=t.dirty;t.dirty=[-1],t.fragment&&t.fragment.p(t.ctx,e),t.after_update.forEach(K)}}const tt=new Set;let et,nt;function rt(){et={r:0,c:[],p:et}}function it(){et.r||c(et.c),et=et.p}function ot(t,e){t&&t.i&&(tt.delete(t),t.i(e))}function lt(t,e,n,r){if(t&&t.o){if(tt.has(t))return;tt.add(t),et.c.push((()=>{tt.delete(t),r&&(n&&t.d(1),r())})),t.o(e)}else r&&r()}function at(t,e){t.d(1),e.delete(t.key)}function st(t,e){lt(t,1,1,(()=>{e.delete(t.key)}))}function ct(t,e,n,r,i,o,l,a,s,c,u,h){let d=t.length,f=o.length,p=d;const g={};for(;p--;)g[t[p].key]=p;const m=[],v=new Map,y=new Map;for(p=f;p--;){const t=h(i,o,p),a=n(t);let s=l.get(a);s?r&&s.p(t,e):(s=c(a,t),s.c()),v.set(a,m[p]=s),a in g&&y.set(a,Math.abs(p-g[a]))}const w=new Set,b=new Set;function $(t){ot(t,1),t.m(a,u),l.set(t.key,t),u=t.first,f--}for(;d&&f;){const e=m[f-1],n=t[d-1],r=e.key,i=n.key;e===n?(u=e.first,d--,f--):v.has(i)?!l.has(r)||w.has(r)?$(e):b.has(i)?d--:y.get(r)>y.get(i)?(b.add(r),$(e)):(w.add(i),d--):(s(n,l),d--)}for(;d--;){const e=t[d];v.has(e.key)||s(e,l)}for(;f;)$(m[f-1]);return m}function ut(t,e,n,r){const i=t.$$.props[e];void 0!==i&&(t.$$.bound[i]=n,void 0===r&&n(t.$$.ctx[i]))}function ht(t){t&&t.c()}function dt(t,e,n,r){const{fragment:i,after_update:o}=t.$$;i&&i.m(e,n),r||K((()=>{const e=t.$$.on_mount.map(a).filter(u);t.$$.on_destroy?t.$$.on_destroy.push(...e):c(e),t.$$.on_mount=[]})),o.forEach(K)}function ft(t,e){const n=t.$$;null!==n.fragment&&(c(n.on_destroy),n.fragment&&n.fragment.d(e),n.on_destroy=n.fragment=null,n.ctx=[])}function pt(t,e,n,r,i,o,a,u=[-1]){const h=v;j(t);const d=t.$$={fragment:null,ctx:[],props:o,update:l,not_equal:i,bound:s(),on_mount:[],on_destroy:[],on_disconnect:[],before_update:[],after_update:[],context:new Map(e.context||(h?h.$$.context:[])),callbacks:s(),dirty:u,skip_bound:!1,root:e.target||h.$$.root};a&&a(d.root);let f=!1;if(d.ctx=n?n(t,e.props||{},((e,n,...r)=>{const o=r.length?r[0]:n;return d.ctx&&i(d.ctx[e],d.ctx[e]=o)&&(!d.skip_bound&&d.bound[e]&&d.bound[e](o),f&&function(t,e){-1===t.$$.dirty[0]&&(H.push(t),Y||(Y=!0,W.then(J)),t.$$.dirty.fill(0)),t.$$.dirty[e/31|0]|=1<<e%31}(t,e)),n})):[],d.update(),f=!0,c(d.before_update),d.fragment=!!r&&r(d.ctx),e.target){if(e.hydrate){y=!0;const t=(p=e.target,Array.from(p.childNodes));d.fragment&&d.fragment.l(t),t.forEach(x)}else d.fragment&&d.fragment.c();e.intro&&ot(t.$$.fragment),dt(t,e.target,e.anchor,e.customElement),y=!1,J()}var p;j(h)}"undefined"!=typeof window?window:"undefined"!=typeof globalThis?globalThis:global,new Set(["allowfullscreen","allowpaymentrequest","async","autofocus","autoplay","checked","controls","default","defer","disabled","formnovalidate","hidden","inert","ismap","itemscope","loop","multiple","muted","nomodule","novalidate","open","playsinline","readonly","required","reversed","selected"]),"function"==typeof HTMLElement&&(nt=class extends HTMLElement{constructor(){super(),this.attachShadow({mode:"open"})}connectedCallback(){const{on_mount:t}=this.$$;this.$$.on_disconnect=t.map(a).filter(u);for(const t in this.$$.slotted)this.appendChild(this.$$.slotted[t])}attributeChangedCallback(t,e,n){this[t]=n}disconnectedCallback(){c(this.$$.on_disconnect)}$destroy(){ft(this,1),this.$destroy=l}$on(t,e){if(!u(e))return l;const n=this.$$.callbacks[t]||(this.$$.callbacks[t]=[]);return n.push(e),()=>{const t=n.indexOf(e);-1!==t&&n.splice(t,1)}}$set(t){this.$$set&&!d(t)&&(this.$$.skip_bound=!0,this.$$set(t),this.$$.skip_bound=!1)}});class gt{$destroy(){ft(this,1),this.$destroy=l}$on(t,e){if(!u(e))return l;const n=this.$$.callbacks[t]||(this.$$.callbacks[t]=[]);return n.push(e),()=>{const t=n.indexOf(e);-1!==t&&n.splice(t,1)}}$set(t){this.$$set&&!d(t)&&(this.$$.skip_bound=!0,this.$$set(t),this.$$.skip_bound=!1)}}const mt=[];function vt(t,e=l){let n;const r=new Set;function i(e){if(h(t,e)&&(t=e,n)){const e=!mt.length;for(const e of r)e[1](),mt.push(e,t);if(e){for(let t=0;t<mt.length;t+=2)mt[t][0](mt[t+1]);mt.length=0}}}return{set:i,update:function(e){i(e(t))},subscribe:function(o,a=l){const s=[o,a];return r.add(s),1===r.size&&(n=e(i)||l),o(t),()=>{r.delete(s),0===r.size&&(n(),n=null)}}}}function yt(t,e,n){const r=!Array.isArray(t),i=r?[t]:t,o=e.length<2;return function(t,n){return{subscribe:vt(t,(t=>{let n=!1;const a=[];let s=0,h=l;const d=()=>{if(s)return;h();const n=e(r?a[0]:a,t);o?t(n):h=u(n)?n:l},p=i.map(((t,e)=>f(t,(t=>{a[e]=t,s&=~(1<<e),n&&d()}),(()=>{s|=1<<e}))));return n=!0,d(),function(){c(p),h()}})).subscribe}}(n)}function wt(t,e,n){t.prototype=e.prototype=n,n.constructor=t}function bt(t,e){var n=Object.create(t.prototype);for(var r in e)n[r]=e[r];return n}function $t(){}var xt=.7,_t=1/xt,kt="\\s*([+-]?\\d+)\\s*",Mt="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)\\s*",Lt="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)%\\s*",At=/^#([0-9a-f]{3,8})$/,zt=new RegExp(`^rgb\\(${kt},${kt},${kt}\\)$`),St=new RegExp(`^rgb\\(${Lt},${Lt},${Lt}\\)$`),Nt=new RegExp(`^rgba\\(${kt},${kt},${kt},${Mt}\\)$`),Ct=new RegExp(`^rgba\\(${Lt},${Lt},${Lt},${Mt}\\)$`),Tt=new RegExp(`^hsl\\(${Mt},${Lt},${Lt}\\)$`),Ot=new RegExp(`^hsla\\(${Mt},${Lt},${Lt},${Mt}\\)$`),Et={aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074};function Dt(){return this.rgb().formatHex()}function Rt(){return this.rgb().formatRgb()}function Bt(t){var e,n;return t=(t+"").trim().toLowerCase(),(e=At.exec(t))?(n=e[1].length,e=parseInt(e[1],16),6===n?jt(e):3===n?new Ht(e>>8&15|e>>4&240,e>>4&15|240&e,(15&e)<<4|15&e,1):8===n?qt(e>>24&255,e>>16&255,e>>8&255,(255&e)/255):4===n?qt(e>>12&15|e>>8&240,e>>8&15|e>>4&240,e>>4&15|240&e,((15&e)<<4|15&e)/255):null):(e=zt.exec(t))?new Ht(e[1],e[2],e[3],1):(e=St.exec(t))?new Ht(255*e[1]/100,255*e[2]/100,255*e[3]/100,1):(e=Nt.exec(t))?qt(e[1],e[2],e[3],e[4]):(e=Ct.exec(t))?qt(255*e[1]/100,255*e[2]/100,255*e[3]/100,e[4]):(e=Tt.exec(t))?Kt(e[1],e[2]/100,e[3]/100,1):(e=Ot.exec(t))?Kt(e[1],e[2]/100,e[3]/100,e[4]):Et.hasOwnProperty(t)?jt(Et[t]):"transparent"===t?new Ht(NaN,NaN,NaN,0):null}function jt(t){return new Ht(t>>16&255,t>>8&255,255&t,1)}function qt(t,e,n,r){return r<=0&&(t=e=n=NaN),new Ht(t,e,n,r)}function Pt(t){return t instanceof $t||(t=Bt(t)),t?new Ht((t=t.rgb()).r,t.g,t.b,t.opacity):new Ht}function It(t,e,n,r){return 1===arguments.length?Pt(t):new Ht(t,e,n,null==r?1:r)}function Ht(t,e,n,r){this.r=+t,this.g=+e,this.b=+n,this.opacity=+r}function Ft(){return`#${Yt(this.r)}${Yt(this.g)}${Yt(this.b)}`}function Vt(){const t=Xt(this.opacity);return`${1===t?"rgb(":"rgba("}${Wt(this.r)}, ${Wt(this.g)}, ${Wt(this.b)}${1===t?")":`, ${t})`}`}function Xt(t){return isNaN(t)?1:Math.max(0,Math.min(1,t))}function Wt(t){return Math.max(0,Math.min(255,Math.round(t)||0))}function Yt(t){return((t=Wt(t))<16?"0":"")+t.toString(16)}function Kt(t,e,n,r){return r<=0?t=e=n=NaN:n<=0||n>=1?t=e=NaN:e<=0&&(t=NaN),new Gt(t,e,n,r)}function Ut(t){if(t instanceof Gt)return new Gt(t.h,t.s,t.l,t.opacity);if(t instanceof $t||(t=Bt(t)),!t)return new Gt;if(t instanceof Gt)return t;var e=(t=t.rgb()).r/255,n=t.g/255,r=t.b/255,i=Math.min(e,n,r),o=Math.max(e,n,r),l=NaN,a=o-i,s=(o+i)/2;return a?(l=e===o?(n-r)/a+6*(n<r):n===o?(r-e)/a+2:(e-n)/a+4,a/=s<.5?o+i:2-o-i,l*=60):a=s>0&&s<1?0:l,new Gt(l,a,s,t.opacity)}function Gt(t,e,n,r){this.h=+t,this.s=+e,this.l=+n,this.opacity=+r}function Zt(t){return(t=(t||0)%360)<0?t+360:t}function Jt(t){return Math.max(0,Math.min(1,t||0))}function Qt(t,e,n){return 255*(t<60?e+(n-e)*t/60:t<180?n:t<240?e+(n-e)*(240-t)/60:e)}function te(t,e,n,r,i){var o=t*t,l=o*t;return((1-3*t+3*o-l)*e+(4-6*o+3*l)*n+(1+3*t+3*o-3*l)*r+l*i)/6}wt($t,Bt,{copy(t){return Object.assign(new this.constructor,this,t)},displayable(){return this.rgb().displayable()},hex:Dt,formatHex:Dt,formatHex8:function(){return this.rgb().formatHex8()},formatHsl:function(){return Ut(this).formatHsl()},formatRgb:Rt,toString:Rt}),wt(Ht,It,bt($t,{brighter(t){return t=null==t?_t:Math.pow(_t,t),new Ht(this.r*t,this.g*t,this.b*t,this.opacity)},darker(t){return t=null==t?xt:Math.pow(xt,t),new Ht(this.r*t,this.g*t,this.b*t,this.opacity)},rgb(){return this},clamp(){return new Ht(Wt(this.r),Wt(this.g),Wt(this.b),Xt(this.opacity))},displayable(){return-.5<=this.r&&this.r<255.5&&-.5<=this.g&&this.g<255.5&&-.5<=this.b&&this.b<255.5&&0<=this.opacity&&this.opacity<=1},hex:Ft,formatHex:Ft,formatHex8:function(){return`#${Yt(this.r)}${Yt(this.g)}${Yt(this.b)}${Yt(255*(isNaN(this.opacity)?1:this.opacity))}`},formatRgb:Vt,toString:Vt})),wt(Gt,(function(t,e,n,r){return 1===arguments.length?Ut(t):new Gt(t,e,n,null==r?1:r)}),bt($t,{brighter(t){return t=null==t?_t:Math.pow(_t,t),new Gt(this.h,this.s,this.l*t,this.opacity)},darker(t){return t=null==t?xt:Math.pow(xt,t),new Gt(this.h,this.s,this.l*t,this.opacity)},rgb(){var t=this.h%360+360*(this.h<0),e=isNaN(t)||isNaN(this.s)?0:this.s,n=this.l,r=n+(n<.5?n:1-n)*e,i=2*n-r;return new Ht(Qt(t>=240?t-240:t+120,i,r),Qt(t,i,r),Qt(t<120?t+240:t-120,i,r),this.opacity)},clamp(){return new Gt(Zt(this.h),Jt(this.s),Jt(this.l),Xt(this.opacity))},displayable(){return(0<=this.s&&this.s<=1||isNaN(this.s))&&0<=this.l&&this.l<=1&&0<=this.opacity&&this.opacity<=1},formatHsl(){const t=Xt(this.opacity);return`${1===t?"hsl(":"hsla("}${Zt(this.h)}, ${100*Jt(this.s)}%, ${100*Jt(this.l)}%${1===t?")":`, ${t})`}`}}));const ee=t=>()=>t;function ne(t,e){var n=e-t;return n?function(t,e){return function(n){return t+n*e}}(t,n):ee(isNaN(t)?e:t)}const re=function t(e){var n=function(t){return 1==(t=+t)?ne:function(e,n){return n-e?function(t,e,n){return t=Math.pow(t,n),e=Math.pow(e,n)-t,n=1/n,function(r){return Math.pow(t+r*e,n)}}(e,n,t):ee(isNaN(e)?n:e)}}(e);function r(t,e){var r=n((t=It(t)).r,(e=It(e)).r),i=n(t.g,e.g),o=n(t.b,e.b),l=ne(t.opacity,e.opacity);return function(e){return t.r=r(e),t.g=i(e),t.b=o(e),t.opacity=l(e),t+""}}return r.gamma=t,r}(1);function ie(t){return function(e){var n,r,i=e.length,o=new Array(i),l=new Array(i),a=new Array(i);for(n=0;n<i;++n)r=It(e[n]),o[n]=r.r||0,l[n]=r.g||0,a[n]=r.b||0;return o=t(o),l=t(l),a=t(a),r.opacity=1,function(t){return r.r=o(t),r.g=l(t),r.b=a(t),r+""}}}var oe=ie((function(t){var e=t.length-1;return function(n){var r=n<=0?n=0:n>=1?(n=1,e-1):Math.floor(n*e),i=t[r],o=t[r+1],l=r>0?t[r-1]:2*i-o,a=r<e-1?t[r+2]:2*o-i;return te((n-r/e)*e,l,i,o,a)}}));function le(t,e){var n,r=e?e.length:0,i=t?Math.min(r,t.length):0,o=new Array(i),l=new Array(r);for(n=0;n<i;++n)o[n]=pe(t[n],e[n]);for(;n<r;++n)l[n]=e[n];return function(t){for(n=0;n<i;++n)l[n]=o[n](t);return l}}function ae(t,e){var n=new Date;return t=+t,e=+e,function(r){return n.setTime(t*(1-r)+e*r),n}}function se(t,e){return t=+t,e=+e,function(n){return t*(1-n)+e*n}}function ce(t,e){var n,r={},i={};for(n in null!==t&&"object"==typeof t||(t={}),null!==e&&"object"==typeof e||(e={}),e)n in t?r[n]=pe(t[n],e[n]):i[n]=e[n];return function(t){for(n in r)i[n]=r[n](t);return i}}ie((function(t){var e=t.length;return function(n){var r=Math.floor(((n%=1)<0?++n:n)*e),i=t[(r+e-1)%e],o=t[r%e],l=t[(r+1)%e],a=t[(r+2)%e];return te((n-r/e)*e,i,o,l,a)}}));var ue=/[-+]?(?:\d+\.?\d*|\.?\d+)(?:[eE][-+]?\d+)?/g,he=new RegExp(ue.source,"g");function de(t,e){var n,r,i,o=ue.lastIndex=he.lastIndex=0,l=-1,a=[],s=[];for(t+="",e+="";(n=ue.exec(t))&&(r=he.exec(e));)(i=r.index)>o&&(i=e.slice(o,i),a[l]?a[l]+=i:a[++l]=i),(n=n[0])===(r=r[0])?a[l]?a[l]+=r:a[++l]=r:(a[++l]=null,s.push({i:l,x:se(n,r)})),o=he.lastIndex;return o<e.length&&(i=e.slice(o),a[l]?a[l]+=i:a[++l]=i),a.length<2?s[0]?function(t){return function(e){return t(e)+""}}(s[0].x):function(t){return function(){return t}}(e):(e=s.length,function(t){for(var n,r=0;r<e;++r)a[(n=s[r]).i]=n.x(t);return a.join("")})}function fe(t,e){e||(e=[]);var n,r=t?Math.min(e.length,t.length):0,i=e.slice();return function(o){for(n=0;n<r;++n)i[n]=t[n]*(1-o)+e[n]*o;return i}}function pe(t,e){var n,r,i=typeof e;return null==e||"boolean"===i?ee(e):("number"===i?se:"string"===i?(n=Bt(e))?(e=n,re):de:e instanceof Bt?re:e instanceof Date?ae:(r=e,!ArrayBuffer.isView(r)||r instanceof DataView?Array.isArray(e)?le:"function"!=typeof e.valueOf&&"function"!=typeof e.toString||isNaN(e)?ce:se:fe))(t,e)}function ge(t,e){return t=+t,e=+e,function(n){return Math.round(t*(1-n)+e*n)}}function me(t,e){return null==t||null==e?NaN:t<e?-1:t>e?1:t>=e?0:NaN}function ve(t,e){return null==t||null==e?NaN:e<t?-1:e>t?1:e>=t?0:NaN}function ye(t){let e,n,r;function i(t,r,i=0,o=t.length){if(i<o){if(0!==e(r,r))return o;do{const e=i+o>>>1;n(t[e],r)<0?i=e+1:o=e}while(i<o)}return i}return 2!==t.length?(e=me,n=(e,n)=>me(t(e),n),r=(e,n)=>t(e)-n):(e=t===me||t===ve?t:we,n=t,r=t),{left:i,center:function(t,e,n=0,o=t.length){const l=i(t,e,n,o-1);return l>n&&r(t[l-1],e)>-r(t[l],e)?l-1:l},right:function(t,r,i=0,o=t.length){if(i<o){if(0!==e(r,r))return o;do{const e=i+o>>>1;n(t[e],r)<=0?i=e+1:o=e}while(i<o)}return i}}}function we(){return 0}function be(t){return null===t?NaN:+t}const $e=ye(me),xe=$e.right,_e=($e.left,ye(be).center,xe);function ke(t){return+t}var Me=[0,1];function Le(t){return t}function Ae(t,e){return(e-=t=+t)?function(n){return(n-t)/e}:(n=isNaN(e)?NaN:.5,function(){return n});var n}function ze(t,e,n){var r=t[0],i=t[1],o=e[0],l=e[1];return i<r?(r=Ae(i,r),o=n(l,o)):(r=Ae(r,i),o=n(o,l)),function(t){return o(r(t))}}function Se(t,e,n){var r=Math.min(t.length,e.length)-1,i=new Array(r),o=new Array(r),l=-1;for(t[r]<t[0]&&(t=t.slice().reverse(),e=e.slice().reverse());++l<r;)i[l]=Ae(t[l],t[l+1]),o[l]=n(e[l],e[l+1]);return function(e){var n=_e(t,e,1,r)-1;return o[n](i[n](e))}}function Ne(t,e){return e.domain(t.domain()).range(t.range()).interpolate(t.interpolate()).clamp(t.clamp()).unknown(t.unknown())}function Ce(){return function(){var t,e,n,r,i,o,l=Me,a=Me,s=pe,c=Le;function u(){var t,e,n,s=Math.min(l.length,a.length);return c!==Le&&(t=l[0],e=l[s-1],t>e&&(n=t,t=e,e=n),c=function(n){return Math.max(t,Math.min(e,n))}),r=s>2?Se:ze,i=o=null,h}function h(e){return null==e||isNaN(e=+e)?n:(i||(i=r(l.map(t),a,s)))(t(c(e)))}return h.invert=function(n){return c(e((o||(o=r(a,l.map(t),se)))(n)))},h.domain=function(t){return arguments.length?(l=Array.from(t,ke),u()):l.slice()},h.range=function(t){return arguments.length?(a=Array.from(t),u()):a.slice()},h.rangeRound=function(t){return a=Array.from(t),s=ge,u()},h.clamp=function(t){return arguments.length?(c=!!t||Le,u()):c!==Le},h.interpolate=function(t){return arguments.length?(s=t,u()):s},h.unknown=function(t){return arguments.length?(n=t,h):n},function(n,r){return t=n,e=r,u()}}()(Le,Le)}function Te(t,e){switch(arguments.length){case 0:break;case 1:this.range(t);break;default:this.range(e).domain(t)}return this}function Oe(t,e){switch(arguments.length){case 0:break;case 1:"function"==typeof t?this.interpolator(t):this.range(t);break;default:this.domain(t),"function"==typeof e?this.interpolator(e):this.range(e)}return this}var Ee=Math.sqrt(50),De=Math.sqrt(10),Re=Math.sqrt(2);function Be(t,e,n){var r,i,o,l,a=-1;if(n=+n,(t=+t)==(e=+e)&&n>0)return[t];if((r=e<t)&&(i=t,t=e,e=i),0===(l=je(t,e,n))||!isFinite(l))return[];if(l>0){let n=Math.round(t/l),r=Math.round(e/l);for(n*l<t&&++n,r*l>e&&--r,o=new Array(i=r-n+1);++a<i;)o[a]=(n+a)*l}else{l=-l;let n=Math.round(t*l),r=Math.round(e*l);for(n/l<t&&++n,r/l>e&&--r,o=new Array(i=r-n+1);++a<i;)o[a]=(n+a)/l}return r&&o.reverse(),o}function je(t,e,n){var r=(e-t)/Math.max(0,n),i=Math.floor(Math.log(r)/Math.LN10),o=r/Math.pow(10,i);return i>=0?(o>=Ee?10:o>=De?5:o>=Re?2:1)*Math.pow(10,i):-Math.pow(10,-i)/(o>=Ee?10:o>=De?5:o>=Re?2:1)}var qe,Pe=/^(?:(.)?([<>=^]))?([+\-( ])?([$#])?(0)?(\d+)?(,)?(\.\d+)?(~)?([a-z%])?$/i;function Ie(t){if(!(e=Pe.exec(t)))throw new Error("invalid format: "+t);var e;return new He({fill:e[1],align:e[2],sign:e[3],symbol:e[4],zero:e[5],width:e[6],comma:e[7],precision:e[8]&&e[8].slice(1),trim:e[9],type:e[10]})}function He(t){this.fill=void 0===t.fill?" ":t.fill+"",this.align=void 0===t.align?">":t.align+"",this.sign=void 0===t.sign?"-":t.sign+"",this.symbol=void 0===t.symbol?"":t.symbol+"",this.zero=!!t.zero,this.width=void 0===t.width?void 0:+t.width,this.comma=!!t.comma,this.precision=void 0===t.precision?void 0:+t.precision,this.trim=!!t.trim,this.type=void 0===t.type?"":t.type+""}function Fe(t,e){if((n=(t=e?t.toExponential(e-1):t.toExponential()).indexOf("e"))<0)return null;var n,r=t.slice(0,n);return[r.length>1?r[0]+r.slice(2):r,+t.slice(n+1)]}function Ve(t){return(t=Fe(Math.abs(t)))?t[1]:NaN}function Xe(t,e){var n=Fe(t,e);if(!n)return t+"";var r=n[0],i=n[1];return i<0?"0."+new Array(-i).join("0")+r:r.length>i+1?r.slice(0,i+1)+"."+r.slice(i+1):r+new Array(i-r.length+2).join("0")}Ie.prototype=He.prototype,He.prototype.toString=function(){return this.fill+this.align+this.sign+this.symbol+(this.zero?"0":"")+(void 0===this.width?"":Math.max(1,0|this.width))+(this.comma?",":"")+(void 0===this.precision?"":"."+Math.max(0,0|this.precision))+(this.trim?"~":"")+this.type};const We={"%":(t,e)=>(100*t).toFixed(e),b:t=>Math.round(t).toString(2),c:t=>t+"",d:function(t){return Math.abs(t=Math.round(t))>=1e21?t.toLocaleString("en").replace(/,/g,""):t.toString(10)},e:(t,e)=>t.toExponential(e),f:(t,e)=>t.toFixed(e),g:(t,e)=>t.toPrecision(e),o:t=>Math.round(t).toString(8),p:(t,e)=>Xe(100*t,e),r:Xe,s:function(t,e){var n=Fe(t,e);if(!n)return t+"";var r=n[0],i=n[1],o=i-(qe=3*Math.max(-8,Math.min(8,Math.floor(i/3))))+1,l=r.length;return o===l?r:o>l?r+new Array(o-l+1).join("0"):o>0?r.slice(0,o)+"."+r.slice(o):"0."+new Array(1-o).join("0")+Fe(t,Math.max(0,e+o-1))[0]},X:t=>Math.round(t).toString(16).toUpperCase(),x:t=>Math.round(t).toString(16)};function Ye(t){return t}var Ke,Ue,Ge,Ze=Array.prototype.map,Je=["y","z","a","f","p","n","µ","m","","k","M","G","T","P","E","Z","Y"];function Qe(t){var e=t.domain;return t.ticks=function(t){var n=e();return Be(n[0],n[n.length-1],null==t?10:t)},t.tickFormat=function(t,n){var r=e();return function(t,e,n,r){var i,o=function(t,e,n){var r=Math.abs(e-t)/Math.max(0,n),i=Math.pow(10,Math.floor(Math.log(r)/Math.LN10)),o=r/i;return o>=Ee?i*=10:o>=De?i*=5:o>=Re&&(i*=2),e<t?-i:i}(t,e,n);switch((r=Ie(null==r?",f":r)).type){case"s":var l=Math.max(Math.abs(t),Math.abs(e));return null!=r.precision||isNaN(i=function(t,e){return Math.max(0,3*Math.max(-8,Math.min(8,Math.floor(Ve(e)/3)))-Ve(Math.abs(t)))}(o,l))||(r.precision=i),Ge(r,l);case"":case"e":case"g":case"p":case"r":null!=r.precision||isNaN(i=function(t,e){return t=Math.abs(t),e=Math.abs(e)-t,Math.max(0,Ve(e)-Ve(t))+1}(o,Math.max(Math.abs(t),Math.abs(e))))||(r.precision=i-("e"===r.type));break;case"f":case"%":null!=r.precision||isNaN(i=function(t){return Math.max(0,-Ve(Math.abs(t)))}(o))||(r.precision=i-2*("%"===r.type))}return Ue(r)}(r[0],r[r.length-1],null==t?10:t,n)},t.nice=function(n){null==n&&(n=10);var r,i,o=e(),l=0,a=o.length-1,s=o[l],c=o[a],u=10;for(c<s&&(i=s,s=c,c=i,i=l,l=a,a=i);u-- >0;){if((i=je(s,c,n))===r)return o[l]=s,o[a]=c,e(o);if(i>0)s=Math.floor(s/i)*i,c=Math.ceil(c/i)*i;else{if(!(i<0))break;s=Math.ceil(s*i)/i,c=Math.floor(c*i)/i}r=i}return t},t}function tn(){var t=Ce();return t.copy=function(){return Ne(t,tn())},Te.apply(t,arguments),Qe(t)}function en(){var t,e,n,r,i,o=0,l=1,a=Le,s=!1;function c(e){return null==e||isNaN(e=+e)?i:a(0===n?.5:(e=(r(e)-t)*n,s?Math.max(0,Math.min(1,e)):e))}function u(t){return function(e){var n,r;return arguments.length?([n,r]=e,a=t(n,r),c):[a(0),a(1)]}}return c.domain=function(i){return arguments.length?([o,l]=i,t=r(o=+o),e=r(l=+l),n=t===e?0:1/(e-t),c):[o,l]},c.clamp=function(t){return arguments.length?(s=!!t,c):s},c.interpolator=function(t){return arguments.length?(a=t,c):a},c.range=u(pe),c.rangeRound=u(ge),c.unknown=function(t){return arguments.length?(i=t,c):i},function(i){return r=i,t=i(o),e=i(l),n=t===e?0:1/(e-t),c}}function nn(t,e){return e.domain(t.domain()).interpolator(t.interpolator()).clamp(t.clamp()).unknown(t.unknown())}function rn(){var t=Qe(en()(Le));return t.copy=function(){return nn(t,rn())},Oe.apply(t,arguments)}function on(t,e){void 0===e&&(e=t,t=pe);for(var n=0,r=e.length-1,i=e[0],o=new Array(r<0?0:r);n<r;)o[n]=t(i,i=e[++n]);return function(t){var e=Math.max(0,Math.min(r-1,Math.floor(t*=r)));return o[e](t-e)}}function ln(){var t,e,n,r,i,o,l,a=0,s=.5,c=1,u=1,h=Le,d=!1;function f(t){return isNaN(t=+t)?l:(t=.5+((t=+o(t))-e)*(u*t<u*e?r:i),h(d?Math.max(0,Math.min(1,t)):t))}function p(t){return function(e){var n,r,i;return arguments.length?([n,r,i]=e,h=on(t,[n,r,i]),f):[h(0),h(.5),h(1)]}}return f.domain=function(l){return arguments.length?([a,s,c]=l,t=o(a=+a),e=o(s=+s),n=o(c=+c),r=t===e?0:.5/(e-t),i=e===n?0:.5/(n-e),u=e<t?-1:1,f):[a,s,c]},f.clamp=function(t){return arguments.length?(d=!!t,f):d},f.interpolator=function(t){return arguments.length?(h=t,f):h},f.range=p(pe),f.rangeRound=p(ge),f.unknown=function(t){return arguments.length?(l=t,f):l},function(l){return o=l,t=l(a),e=l(s),n=l(c),r=t===e?0:.5/(e-t),i=e===n?0:.5/(n-e),u=e<t?-1:1,f}}function an(){var t=Qe(ln()(Le));return t.copy=function(){return nn(t,an())},Oe.apply(t,arguments)}function sn(t){for(var e=t.length/6|0,n=new Array(e),r=0;r<e;)n[r]="#"+t.slice(6*r,6*++r);return n}Ke=function(t){var e,n,r=void 0===t.grouping||void 0===t.thousands?Ye:(e=Ze.call(t.grouping,Number),n=t.thousands+"",function(t,r){for(var i=t.length,o=[],l=0,a=e[0],s=0;i>0&&a>0&&(s+a+1>r&&(a=Math.max(1,r-s)),o.push(t.substring(i-=a,i+a)),!((s+=a+1)>r));)a=e[l=(l+1)%e.length];return o.reverse().join(n)}),i=void 0===t.currency?"":t.currency[0]+"",o=void 0===t.currency?"":t.currency[1]+"",l=void 0===t.decimal?".":t.decimal+"",a=void 0===t.numerals?Ye:function(t){return function(e){return e.replace(/[0-9]/g,(function(e){return t[+e]}))}}(Ze.call(t.numerals,String)),s=void 0===t.percent?"%":t.percent+"",c=void 0===t.minus?"−":t.minus+"",u=void 0===t.nan?"NaN":t.nan+"";function h(t){var e=(t=Ie(t)).fill,n=t.align,h=t.sign,d=t.symbol,f=t.zero,p=t.width,g=t.comma,m=t.precision,v=t.trim,y=t.type;"n"===y?(g=!0,y="g"):We[y]||(void 0===m&&(m=12),v=!0,y="g"),(f||"0"===e&&"="===n)&&(f=!0,e="0",n="=");var w="$"===d?i:"#"===d&&/[boxX]/.test(y)?"0"+y.toLowerCase():"",b="$"===d?o:/[%p]/.test(y)?s:"",$=We[y],x=/[defgprs%]/.test(y);function _(t){var i,o,s,d=w,_=b;if("c"===y)_=$(t)+_,t="";else{var k=(t=+t)<0||1/t<0;if(t=isNaN(t)?u:$(Math.abs(t),m),v&&(t=function(t){t:for(var e,n=t.length,r=1,i=-1;r<n;++r)switch(t[r]){case".":i=e=r;break;case"0":0===i&&(i=r),e=r;break;default:if(!+t[r])break t;i>0&&(i=0)}return i>0?t.slice(0,i)+t.slice(e+1):t}(t)),k&&0==+t&&"+"!==h&&(k=!1),d=(k?"("===h?h:c:"-"===h||"("===h?"":h)+d,_=("s"===y?Je[8+qe/3]:"")+_+(k&&"("===h?")":""),x)for(i=-1,o=t.length;++i<o;)if(48>(s=t.charCodeAt(i))||s>57){_=(46===s?l+t.slice(i+1):t.slice(i))+_,t=t.slice(0,i);break}}g&&!f&&(t=r(t,1/0));var M=d.length+t.length+_.length,L=M<p?new Array(p-M+1).join(e):"";switch(g&&f&&(t=r(L+t,L.length?p-_.length:1/0),L=""),n){case"<":t=d+t+_+L;break;case"=":t=d+L+t+_;break;case"^":t=L.slice(0,M=L.length>>1)+d+t+_+L.slice(M);break;default:t=L+d+t+_}return a(t)}return m=void 0===m?6:/[gprs]/.test(y)?Math.max(1,Math.min(21,m)):Math.max(0,Math.min(20,m)),_.toString=function(){return t+""},_}return{format:h,formatPrefix:function(t,e){var n=h(((t=Ie(t)).type="f",t)),r=3*Math.max(-8,Math.min(8,Math.floor(Ve(e)/3))),i=Math.pow(10,-r),o=Je[8+r/3];return function(t){return n(i*t)+o}}}}({thousands:",",grouping:[3],currency:["$",""]}),Ue=Ke.format,Ge=Ke.formatPrefix;const cn=t=>oe(t[t.length-1]),un=cn(new Array(3).concat("edf8b17fcdbb2c7fb8","ffffcca1dab441b6c4225ea8","ffffcca1dab441b6c42c7fb8253494","ffffccc7e9b47fcdbb41b6c42c7fb8253494","ffffccc7e9b47fcdbb41b6c41d91c0225ea80c2c84","ffffd9edf8b1c7e9b47fcdbb41b6c41d91c0225ea80c2c84","ffffd9edf8b1c7e9b47fcdbb41b6c41d91c0225ea8253494081d58").map(sn)),hn=cn(new Array(3).concat("d8b365f5f5f55ab4ac","a6611adfc27d80cdc1018571","a6611adfc27df5f5f580cdc1018571","8c510ad8b365f6e8c3c7eae55ab4ac01665e","8c510ad8b365f6e8c3f5f5f5c7eae55ab4ac01665e","8c510abf812ddfc27df6e8c3c7eae580cdc135978f01665e","8c510abf812ddfc27df6e8c3f5f5f5c7eae580cdc135978f01665e","5430058c510abf812ddfc27df6e8c3c7eae580cdc135978f01665e003c30","5430058c510abf812ddfc27df6e8c3f5f5f5c7eae580cdc135978f01665e003c30").map(sn));class dn extends Map{constructor(t,e=vn){if(super(),Object.defineProperties(this,{_intern:{value:new Map},_key:{value:e}}),null!=t)for(const[e,n]of t)this.set(e,n)}get(t){return super.get(pn(this,t))}has(t){return super.has(pn(this,t))}set(t,e){return super.set(gn(this,t),e)}delete(t){return super.delete(mn(this,t))}}class fn extends Set{constructor(t,e=vn){if(super(),Object.defineProperties(this,{_intern:{value:new Map},_key:{value:e}}),null!=t)for(const e of t)this.add(e)}has(t){return super.has(pn(this,t))}add(t){return super.add(gn(this,t))}delete(t){return super.delete(mn(this,t))}}function pn({_intern:t,_key:e},n){const r=e(n);return t.has(r)?t.get(r):n}function gn({_intern:t,_key:e},n){const r=e(n);return t.has(r)?t.get(r):(t.set(r,n),n)}function mn({_intern:t,_key:e},n){const r=e(n);return t.has(r)&&(n=t.get(r),t.delete(r)),n}function vn(t){return null!==t&&"object"==typeof t?t.valueOf():t}function yn(t){return t}function wn(t,e,...n){return function(t,e,n,r){return function t(i,o){if(o>=r.length)return n(i);const l=new dn,a=r[o++];let s=-1;for(const t of i){const e=a(t,++s,i),n=l.get(e);n?n.push(t):l.set(e,[t])}for(const[e,n]of l)l.set(e,t(n,o));return e(l)}(t,0)}(t,yn,e,n)}function bn(t,e,n){t=+t,e=+e,n=(i=arguments.length)<2?(e=t,t=0,1):i<3?1:+n;for(var r=-1,i=0|Math.max(0,Math.ceil((e-t)/n)),o=new Array(i);++r<i;)o[r]=t+r*n;return o}function $n(t,e,n,r){const i=window.devicePixelRatio||1;t.width=n*i,t.height=r*i,t.style.width=n+"px",t.style.height=r+"px",e.scale(i,i)}function xn(t){return t>=.001&&t<=1||t>=-1&&t<=.001?Ue(".3~f")(t):Ue("~s")(t)}function _n(t,e,n,r,i,o,l,a,s,c){return i?"lines"===r?tn().domain([t.ice.ice_min,t.ice.ice_max]).nice().range([e-c.bottom,c.top]):"cluster-centers"===r?tn().domain([t.ice.centered_mean_min,t.ice.centered_mean_max]).nice().range([e-c.bottom,c.top]):"cluster-bands"===r?tn().domain([t.ice.p10_min,t.ice.p90_max]).nice().range([n-c.bottom,c.top]):tn().domain([t.ice.centered_ice_min,t.ice.centered_ice_max]).nice().range([n-c.bottom,c.top]):"lines"===r?tn().domain(o).nice().range([e-c.bottom,c.top]):"cluster-centers"===r?tn().domain(l).nice().range([e-c.bottom,c.top]):"cluster-bands"===r?tn().domain(a).nice().range([n-c.bottom,c.top]):tn().domain(s).nice().range([n-c.bottom,c.top])}function kn(t,e,n){const r=n.map((t=>e[t]));if("categorical"===t.kind){const e=wn(r,(t=>t.length),(t=>t)),n=t.distribution.bins.map((t=>{var n;return null!==(n=e.get(t))&&void 0!==n?n:0}));return{bins:t.distribution.bins,counts:n}}{const e=wn(r,(t=>t.length),(e=>xe(t.distribution.bins,e,0,t.distribution.bins.length-1)-1)),n=bn(t.distribution.counts.length).map((t=>{var n;return null!==(n=e.get(t))&&void 0!==n?n:0}));return{bins:t.distribution.bins,counts:n}}}const Mn=["#1f77b4","#ff7f0e","#2ca02c","#d62728","#9467bd","#8c564b","#e377c2","#7f7f7f","#bcbd22","#17becf"],Ln=["#5da6e6","#ffb048","#65d25c","#ff6151","#c696f0","#be8377","#ffa8f5","#aeaeae","#f1ef5a","#66f1ff"],An=["#92d7ff","#ffe479","#9aff8c","#ff967e","#fac7ff","#f2b3a6","#ffdcff","#e0e0e0","#ffff8d","#9fffff"];function zn(t,e,n){const r=t,i=vt(e),o=n.get(r);return void 0!==o&&i.set(o),n.on("change:"+r,(()=>i.set(n.get(r))),null),{set:t=>{i.set(t),n&&(n.set(r,t),n.save_changes())},subscribe:i.subscribe,update:t=>{i.update((e=>{const i=t(e);return n&&(n.set(r,i),n.save_changes()),i}))}}}let Sn,Nn,Cn,Tn,On,En,Dn,Rn,Bn,jn,qn,Pn,In,Hn,Fn,Vn,Xn,Wn,Yn,Kn,Un,Gn,Zn;function Jn(t){Sn=zn("feature_names",[],t),Nn=zn("feature_info",{},t),Cn=zn("dataset",{},t),Tn=zn("num_instances",0,t),On=zn("one_way_pds",[],t),En=zn("two_way_pds",[],t),Dn=zn("two_way_pdp_extent",[0,0],t),Rn=zn("two_way_interaction_extent",[0,0],t),Bn=zn("ice_line_extent",[0,0],t),jn=zn("ice_cluster_center_extent",[0,0],t),qn=zn("ice_cluster_band_extent",[0,0],t),Pn=zn("ice_cluster_line_extent",[0,0],t),In=zn("height",600,t),Hn=zn("highlighted_indices",[],t),Fn=zn("two_way_to_calculate",[],t),Vn=vt("one-way-plots");const e=t.get("one_way_pds"),n=e&&e.length>0?e[0].x_feature:"";Xn=vt(n),Wn=vt(""),Yn=vt(!1),Kn=yt(Dn,(t=>rn().domain(t).interpolator(un).unknown("black"))),Un=yt(Rn,(t=>an().domain([t[0],0,t[1]]).interpolator(hn).unknown("black"))),Gn=yt(On,(t=>new Map(t.map((t=>[t.x_feature,t]))))),Zn=yt([Nn,Cn,Hn],(([t,e,n])=>new Map(Object.entries(t).map((([t,r])=>[t,kn(r,e[t],n)])))))}function Qn(t){b(t,"svelte-a3do9k","div.svelte-a3do9k.svelte-a3do9k{display:flex;padding:0.25em;background-color:var(--gray-1)}button.svelte-a3do9k.svelte-a3do9k{border:none;border-radius:0;background-color:transparent}button.tab-selected.svelte-a3do9k.svelte-a3do9k{border-bottom:1px solid black}ul.svelte-a3do9k.svelte-a3do9k{list-style:none}li.svelte-a3do9k.svelte-a3do9k{display:inline-flex}li.svelte-a3do9k+li.svelte-a3do9k{margin-left:0.5em}")}function tr(t,e,n){const r=t.slice();return r[4]=e[n].value,r[5]=e[n].title,r}function er(t){let e,n,r,i,o,l,a=t[5]+"";function s(){return t[3](t[4])}return{c(){e=k("li"),n=k("button"),r=L(a),i=A(),N(n,"class","svelte-a3do9k"),B(n,"tab-selected",t[4]===t[0]),N(e,"class","svelte-a3do9k")},m(t,a){$(t,e,a),w(e,n),w(n,r),w(e,i),o||(l=S(n,"click",s),o=!0)},p(e,r){t=e,3&r&&B(n,"tab-selected",t[4]===t[0])},d(t){t&&x(e),o=!1,l()}}}function nr(t){let e,n,r=t[1],i=[];for(let e=0;e<r.length;e+=1)i[e]=er(tr(t,r,e));return{c(){e=k("div"),n=k("ul");for(let t=0;t<i.length;t+=1)i[t].c();N(n,"class","svelte-a3do9k"),N(e,"class","svelte-a3do9k")},m(t,r){$(t,e,r),w(e,n);for(let t=0;t<i.length;t+=1)i[t].m(n,null)},p(t,[e]){if(7&e){let o;for(r=t[1],o=0;o<r.length;o+=1){const l=tr(t,r,o);i[o]?i[o].p(l,e):(i[o]=er(l),i[o].c(),i[o].m(n,null))}for(;o<i.length;o+=1)i[o].d(1);i.length=r.length}},i:l,o:l,d(t){t&&x(e),_(i,t)}}}function rr(t,e,n){let r;function i(t){m(Vn,r=t,r)}return p(t,Vn,(t=>n(0,r=t))),[r,[{value:"one-way-plots",title:"One-way Plots"},{value:"two-way-plots",title:"Two-way Plots"},{value:"detailed-plot",title:"Detailed Plot"}],i,t=>i(t)]}const ir=class extends gt{constructor(t){super(),pt(this,t,rr,nr,h,{},Qn)}},or=Symbol("implicit");function lr(){var t=new dn,e=[],n=[],r=or;function i(i){let o=t.get(i);if(void 0===o){if(r!==or)return r;t.set(i,o=e.push(i)-1)}return n[o%n.length]}return i.domain=function(n){if(!arguments.length)return e.slice();e=[],t=new dn;for(const r of n)t.has(r)||t.set(r,e.push(r)-1);return i},i.range=function(t){return arguments.length?(n=Array.from(t),i):n.slice()},i.unknown=function(t){return arguments.length?(r=t,i):r},i.copy=function(){return lr(e,n).unknown(r)},Te.apply(i,arguments),i}function ar(){var t,e,n=lr().unknown(void 0),r=n.domain,i=n.range,o=0,l=1,a=!1,s=0,c=0,u=.5;function h(){var n=r().length,h=l<o,d=h?l:o,f=h?o:l;t=(f-d)/Math.max(1,n-s+2*c),a&&(t=Math.floor(t)),d+=(f-d-t*(n-s))*u,e=t*(1-s),a&&(d=Math.round(d),e=Math.round(e));var p=bn(n).map((function(e){return d+t*e}));return i(h?p.reverse():p)}return delete n.unknown,n.domain=function(t){return arguments.length?(r(t),h()):r()},n.range=function(t){return arguments.length?([o,l]=t,o=+o,l=+l,h()):[o,l]},n.rangeRound=function(t){return[o,l]=t,o=+o,l=+l,a=!0,h()},n.bandwidth=function(){return e},n.step=function(){return t},n.round=function(t){return arguments.length?(a=!!t,h()):a},n.padding=function(t){return arguments.length?(s=Math.min(1,c=+t),h()):s},n.paddingInner=function(t){return arguments.length?(s=Math.min(1,t),h()):s},n.paddingOuter=function(t){return arguments.length?(c=+t,h()):c},n.align=function(t){return arguments.length?(u=Math.max(0,Math.min(1,t)),h()):u},n.copy=function(){return ar(r(),[o,l]).round(a).paddingInner(s).paddingOuter(c).align(u)},Te.apply(h(),arguments)}function sr(t){var e=t.copy;return t.padding=t.paddingOuter,delete t.paddingInner,delete t.paddingOuter,t.copy=function(){return sr(e())},t}function cr(){return sr(ar.apply(null,arguments).paddingInner(1))}const ur=Math.PI,hr=2*ur,dr=1e-6,fr=hr-dr;function pr(){this._x0=this._y0=this._x1=this._y1=null,this._=""}function gr(){return new pr}pr.prototype=gr.prototype={constructor:pr,moveTo:function(t,e){this._+="M"+(this._x0=this._x1=+t)+","+(this._y0=this._y1=+e)},closePath:function(){null!==this._x1&&(this._x1=this._x0,this._y1=this._y0,this._+="Z")},lineTo:function(t,e){this._+="L"+(this._x1=+t)+","+(this._y1=+e)},quadraticCurveTo:function(t,e,n,r){this._+="Q"+ +t+","+ +e+","+(this._x1=+n)+","+(this._y1=+r)},bezierCurveTo:function(t,e,n,r,i,o){this._+="C"+ +t+","+ +e+","+ +n+","+ +r+","+(this._x1=+i)+","+(this._y1=+o)},arcTo:function(t,e,n,r,i){t=+t,e=+e,n=+n,r=+r,i=+i;var o=this._x1,l=this._y1,a=n-t,s=r-e,c=o-t,u=l-e,h=c*c+u*u;if(i<0)throw new Error("negative radius: "+i);if(null===this._x1)this._+="M"+(this._x1=t)+","+(this._y1=e);else if(h>dr)if(Math.abs(u*a-s*c)>dr&&i){var d=n-o,f=r-l,p=a*a+s*s,g=d*d+f*f,m=Math.sqrt(p),v=Math.sqrt(h),y=i*Math.tan((ur-Math.acos((p+h-g)/(2*m*v)))/2),w=y/v,b=y/m;Math.abs(w-1)>dr&&(this._+="L"+(t+w*c)+","+(e+w*u)),this._+="A"+i+","+i+",0,0,"+ +(u*d>c*f)+","+(this._x1=t+b*a)+","+(this._y1=e+b*s)}else this._+="L"+(this._x1=t)+","+(this._y1=e)},arc:function(t,e,n,r,i,o){t=+t,e=+e,o=!!o;var l=(n=+n)*Math.cos(r),a=n*Math.sin(r),s=t+l,c=e+a,u=1^o,h=o?r-i:i-r;if(n<0)throw new Error("negative radius: "+n);null===this._x1?this._+="M"+s+","+c:(Math.abs(this._x1-s)>dr||Math.abs(this._y1-c)>dr)&&(this._+="L"+s+","+c),n&&(h<0&&(h=h%hr+hr),h>fr?this._+="A"+n+","+n+",0,1,"+u+","+(t-l)+","+(e-a)+"A"+n+","+n+",0,1,"+u+","+(this._x1=s)+","+(this._y1=c):h>dr&&(this._+="A"+n+","+n+",0,"+ +(h>=ur)+","+u+","+(this._x1=t+n*Math.cos(i))+","+(this._y1=e+n*Math.sin(i))))},rect:function(t,e,n,r){this._+="M"+(this._x0=this._x1=+t)+","+(this._y0=this._y1=+e)+"h"+ +n+"v"+ +r+"h"+-n+"Z"},toString:function(){return this._}};const mr=gr;function vr(t){return"object"==typeof t&&"length"in t?t:Array.from(t)}function yr(t){return function(){return t}}function wr(t){this._context=t}function br(t){return new wr(t)}function $r(t){return t[0]}function xr(t){return t[1]}function _r(t,e){var n=yr(!0),r=null,i=br,o=null;function l(l){var a,s,c,u=(l=vr(l)).length,h=!1;for(null==r&&(o=i(c=mr())),a=0;a<=u;++a)!(a<u&&n(s=l[a],a,l))===h&&((h=!h)?o.lineStart():o.lineEnd()),h&&o.point(+t(s,a,l),+e(s,a,l));if(c)return o=null,c+""||null}return t="function"==typeof t?t:void 0===t?$r:yr(t),e="function"==typeof e?e:void 0===e?xr:yr(e),l.x=function(e){return arguments.length?(t="function"==typeof e?e:yr(+e),l):t},l.y=function(t){return arguments.length?(e="function"==typeof t?t:yr(+t),l):e},l.defined=function(t){return arguments.length?(n="function"==typeof t?t:yr(!!t),l):n},l.curve=function(t){return arguments.length?(i=t,null!=r&&(o=i(r)),l):i},l.context=function(t){return arguments.length?(null==t?r=o=null:o=i(r=t),l):r},l}function kr(t,e,n){var r=null,i=yr(!0),o=null,l=br,a=null;function s(s){var c,u,h,d,f,p=(s=vr(s)).length,g=!1,m=new Array(p),v=new Array(p);for(null==o&&(a=l(f=mr())),c=0;c<=p;++c){if(!(c<p&&i(d=s[c],c,s))===g)if(g=!g)u=c,a.areaStart(),a.lineStart();else{for(a.lineEnd(),a.lineStart(),h=c-1;h>=u;--h)a.point(m[h],v[h]);a.lineEnd(),a.areaEnd()}g&&(m[c]=+t(d,c,s),v[c]=+e(d,c,s),a.point(r?+r(d,c,s):m[c],n?+n(d,c,s):v[c]))}if(f)return a=null,f+""||null}function c(){return _r().defined(i).curve(l).context(o)}return t="function"==typeof t?t:void 0===t?$r:yr(+t),e="function"==typeof e?e:yr(void 0===e?0:+e),n="function"==typeof n?n:void 0===n?xr:yr(+n),s.x=function(e){return arguments.length?(t="function"==typeof e?e:yr(+e),r=null,s):t},s.x0=function(e){return arguments.length?(t="function"==typeof e?e:yr(+e),s):t},s.x1=function(t){return arguments.length?(r=null==t?null:"function"==typeof t?t:yr(+t),s):r},s.y=function(t){return arguments.length?(e="function"==typeof t?t:yr(+t),n=null,s):e},s.y0=function(t){return arguments.length?(e="function"==typeof t?t:yr(+t),s):e},s.y1=function(t){return arguments.length?(n=null==t?null:"function"==typeof t?t:yr(+t),s):n},s.lineX0=s.lineY0=function(){return c().x(t).y(e)},s.lineY1=function(){return c().x(t).y(n)},s.lineX1=function(){return c().x(r).y(e)},s.defined=function(t){return arguments.length?(i="function"==typeof t?t:yr(!!t),s):i},s.curve=function(t){return arguments.length?(l=t,null!=o&&(a=l(o)),s):l},s.context=function(t){return arguments.length?(null==t?o=a=null:a=l(o=t),s):o},s}function Mr(t,e){let n;if(void 0===e)for(const e of t)null!=e&&(n>e||void 0===n&&e>=e)&&(n=e);else{let r=-1;for(let i of t)null!=(i=e(i,++r,t))&&(n>i||void 0===n&&i>=i)&&(n=i)}return n}function Lr(t){if(!(i=t.length))return[];for(var e=-1,n=Mr(t,Ar),r=new Array(n);++e<n;)for(var i,o=-1,l=r[e]=new Array(i);++o<i;)l[o]=t[o][e];return r}function Ar(t){return t.length}function zr(){return Lr(arguments)}function Sr(t){b(t,"svelte-1rnhcs",".label-container.svelte-1rnhcs{width:100%;height:100%;display:flex;justify-content:center;align-items:center}.label-content.svelte-1rnhcs{display:flex;justify-content:center;align-items:center;position:fixed}.outlineText.svelte-1rnhcs{--outline-size-pos:1px;--outline-size-neg:-1px;text-shadow:var(--outline-size-neg) var(--outline-size-neg) 0\n        var(--outlineColor),\n      0 var(--outline-size-neg) 0 var(--outlineColor),\n      var(--outline-size-pos) var(--outline-size-neg) 0 var(--outlineColor),\n      var(--outline-size-pos) 0 0 var(--outlineColor),\n      var(--outline-size-pos) var(--outline-size-pos) 0 var(--outlineColor),\n      0 var(--outline-size-pos) 0 var(--outlineColor),\n      var(--outline-size-neg) var(--outline-size-pos) 0 var(--outlineColor),\n      var(--outline-size-neg) 0 0 var(--outlineColor)}.rotate.svelte-1rnhcs{transform:rotate(270deg)}")}function Nr(t){let e,n,r,i,o,a,s,c=`${t[0]}px`,u=`${t[1]}px`;return{c(){e=M("foreignObject"),n=k("div"),r=k("div"),i=k("div"),o=L(t[6]),N(i,"class","cutoff"),E(i,"font-size",t[7]+"px"),E(i,"line-height","normal"),N(i,"title",t[6]),B(i,"bold",t[4]),N(r,"class","label-content svelte-1rnhcs"),E(r,"width",t[0]+"px"),E(r,"height",t[1]+"px"),B(r,"rotate",t[5]),B(r,"outlineText","transparent"!==t[8]),E(r,"width",c),E(r,"height",u),E(r,"--outlineColor",t[8]),N(n,"class","label-container svelte-1rnhcs"),N(e,"x",t[2]),N(e,"y",t[3]),N(e,"width",a=t[5]?t[1]:t[0]),N(e,"height",s=t[5]?t[0]:t[1])},m(t,l){$(t,e,l),w(e,n),w(n,r),w(r,i),w(i,o)},p(t,[n]){64&n&&T(o,t[6]),128&n&&E(i,"font-size",t[7]+"px"),64&n&&N(i,"title",t[6]),16&n&&B(i,"bold",t[4]),1&n&&E(r,"width",t[0]+"px"),2&n&&E(r,"height",t[1]+"px"),32&n&&B(r,"rotate",t[5]),256&n&&B(r,"outlineText","transparent"!==t[8]),1&n&&c!==(c=`${t[0]}px`)&&E(r,"width",c),2&n&&u!==(u=`${t[1]}px`)&&E(r,"height",u),256&n&&E(r,"--outlineColor",t[8]),4&n&&N(e,"x",t[2]),8&n&&N(e,"y",t[3]),35&n&&a!==(a=t[5]?t[1]:t[0])&&N(e,"width",a),35&n&&s!==(s=t[5]?t[0]:t[1])&&N(e,"height",s)},i:l,o:l,d(t){t&&x(e)}}}function Cr(t,e,n){let{width:r=0}=e,{height:i=0}=e,{x:o=0}=e,{y:l=0}=e,{bold:a=!1}=e,{rotate:s=!1}=e,{label:c=""}=e,{fontSize:u=14}=e,{outlineColor:h="transparent"}=e;return t.$$set=t=>{"width"in t&&n(0,r=t.width),"height"in t&&n(1,i=t.height),"x"in t&&n(2,o=t.x),"y"in t&&n(3,l=t.y),"bold"in t&&n(4,a=t.bold),"rotate"in t&&n(5,s=t.rotate),"label"in t&&n(6,c=t.label),"fontSize"in t&&n(7,u=t.fontSize),"outlineColor"in t&&n(8,h=t.outlineColor)},[r,i,o,l,a,s,c,u,h]}Array.prototype.slice,wr.prototype={areaStart:function(){this._line=0},areaEnd:function(){this._line=NaN},lineStart:function(){this._point=0},lineEnd:function(){(this._line||0!==this._line&&1===this._point)&&this._context.closePath(),this._line=1-this._line},point:function(t,e){switch(t=+t,e=+e,this._point){case 0:this._point=1,this._line?this._context.lineTo(t,e):this._context.moveTo(t,e);break;case 1:this._point=2;default:this._context.lineTo(t,e)}}};const Tr=class extends gt{constructor(t){super(),pt(this,t,Cr,Nr,h,{width:0,height:1,x:2,y:3,bold:4,rotate:5,label:6,fontSize:7,outlineColor:8},Sr)}};function Or(t,e,n){const r=t.slice();return r[21]=e[n],r}function Er(t,e,n){const r=t.slice();return r[21]=e[n],r}function Dr(t){let e,n,r;return{c(){e=M("line"),N(e,"x1",n=t[0].range()[0]),N(e,"x2",r=t[0].range()[1]),N(e,"stroke",t[11])},m(t,n){$(t,e,n)},p(t,i){1&i&&n!==(n=t[0].range()[0])&&N(e,"x1",n),1&i&&r!==(r=t[0].range()[1])&&N(e,"x2",r),2048&i&&N(e,"stroke",t[11])},d(t){t&&x(e)}}}function Rr(t){let e,n=t[19](t[0],t[18],t[15]),r=[];for(let e=0;e<n.length;e+=1)r[e]=qr(Or(t,n,e));return{c(){for(let t=0;t<r.length;t+=1)r[t].c();e=z()},m(t,n){for(let e=0;e<r.length;e+=1)r[e].m(t,n);$(t,e,n)},p(t,i){if(849585&i){let o;for(n=t[19](t[0],t[18],t[15]),o=0;o<n.length;o+=1){const l=Or(t,n,o);r[o]?r[o].p(l,i):(r[o]=qr(l),r[o].c(),r[o].m(e.parentNode,e))}for(;o<r.length;o+=1)r[o].d(1);r.length=n.length}},i:l,o:l,d(t){_(r,t),t&&x(e)}}}function Br(t){let e,n,r=t[0].domain(),i=[];for(let e=0;e<r.length;e+=1)i[e]=Hr(Er(t,r,e));const o=t=>lt(i[t],1,1,(()=>{i[t]=null}));return{c(){for(let t=0;t<i.length;t+=1)i[t].c();e=z()},m(t,r){for(let e=0;e<i.length;e+=1)i[e].m(t,r);$(t,e,r),n=!0},p(t,n){if(95905&n){let l;for(r=t[0].domain(),l=0;l<r.length;l+=1){const o=Er(t,r,l);i[l]?(i[l].p(o,n),ot(i[l],1)):(i[l]=Hr(o),i[l].c(),ot(i[l],1),i[l].m(e.parentNode,e))}for(rt(),l=r.length;l<i.length;l+=1)o(l);it()}},i(t){if(!n){for(let t=0;t<r.length;t+=1)ot(i[t]);n=!0}},o(t){i=i.filter(Boolean);for(let t=0;t<i.length;t+=1)lt(i[t]);n=!1},d(t){_(i,t),t&&x(e)}}}function jr(t){let e,n,r,i,o=t[4](t[21])+"";return{c(){e=M("text"),n=L(o),N(e,"y",r=t[13]+t[14]),N(e,"text-anchor","middle"),N(e,"dominant-baseline","hanging"),N(e,"font-size",t[12]),N(e,"stroke",t[9]),N(e,"fill","black"),N(e,"stroke-width",i=2),N(e,"paint-order","stroke")},m(t,r){$(t,e,r),w(e,n)},p(t,i){294929&i&&o!==(o=t[4](t[21])+"")&&T(n,o),24576&i&&r!==(r=t[13]+t[14])&&N(e,"y",r),4096&i&&N(e,"font-size",t[12]),512&i&&N(e,"stroke",t[9])},d(t){t&&x(e)}}}function qr(t){let e,n,r,i=t[7]&&jr(t);return{c(){e=M("g"),n=M("line"),i&&i.c(),N(n,"y1",t[5]),N(n,"y2",t[13]),N(n,"stroke",t[10]),N(e,"transform",r="translate("+t[0](t[21])+")")},m(t,r){$(t,e,r),w(e,n),i&&i.m(e,null)},p(t,o){32&o&&N(n,"y1",t[5]),8192&o&&N(n,"y2",t[13]),1024&o&&N(n,"stroke",t[10]),t[7]?i?i.p(t,o):(i=jr(t),i.c(),i.m(e,null)):i&&(i.d(1),i=null),294913&o&&r!==(r="translate("+t[0](t[21])+")")&&N(e,"transform",r)},d(t){t&&x(e),i&&i.d()}}}function Pr(t){let e,n,r;return{c(){e=M("line"),N(e,"y1",t[5]),N(e,"y2",t[13]),N(e,"x1",n=t[0].bandwidth()/2),N(e,"x2",r=t[0].bandwidth()/2),N(e,"stroke",t[10])},m(t,n){$(t,e,n)},p(t,i){32&i&&N(e,"y1",t[5]),8192&i&&N(e,"y2",t[13]),1&i&&n!==(n=t[0].bandwidth()/2)&&N(e,"x1",n),1&i&&r!==(r=t[0].bandwidth()/2)&&N(e,"x2",r),1024&i&&N(e,"stroke",t[10])},d(t){t&&x(e)}}}function Ir(t){let e,n;return e=new Tr({props:{width:t[0].bandwidth()||t[0].step(),height:t[12]*Wr,x:0===t[0].bandwidth()?-t[0].step()/2:0,y:t[13]+t[14],bold:!1,label:t[16][t[21]]??t[21],outlineColor:t[9],fontSize:t[12]}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};1&n&&(r.width=t[0].bandwidth()||t[0].step()),4096&n&&(r.height=t[12]*Wr),1&n&&(r.x=0===t[0].bandwidth()?-t[0].step()/2:0),24576&n&&(r.y=t[13]+t[14]),65537&n&&(r.label=t[16][t[21]]??t[21]),512&n&&(r.outlineColor=t[9]),4096&n&&(r.fontSize=t[12]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Hr(t){let e,n,r,i,o=t[13]>0&&Pr(t),l=t[7]&&Ir(t);return{c(){e=M("g"),o&&o.c(),n=z(),l&&l.c(),N(e,"transform",r="translate("+t[0](t[21])+")")},m(t,r){$(t,e,r),o&&o.m(e,null),w(e,n),l&&l.m(e,null),i=!0},p(t,a){t[13]>0?o?o.p(t,a):(o=Pr(t),o.c(),o.m(e,n)):o&&(o.d(1),o=null),t[7]?l?(l.p(t,a),128&a&&ot(l,1)):(l=Ir(t),l.c(),ot(l,1),l.m(e,null)):l&&(rt(),lt(l,1,1,(()=>{l=null})),it()),(!i||1&a&&r!==(r="translate("+t[0](t[21])+")"))&&N(e,"transform",r)},i(t){i||(ot(l),i=!0)},o(t){lt(l),i=!1},d(t){t&&x(e),o&&o.d(),l&&l.d()}}}function Fr(t){let e,n;return e=new Tr({props:{width:t[18],height:t[12]*Wr,x:t[17],y:t[13]+t[14]+t[12]+Xr,bold:!0,label:t[1],fontSize:t[12]}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};262144&n&&(r.width=t[18]),4096&n&&(r.height=t[12]*Wr),131072&n&&(r.x=t[17]),28672&n&&(r.y=t[13]+t[14]+t[12]+Xr),2&n&&(r.label=t[1]),4096&n&&(r.fontSize=t[12]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Vr(t){let e,n,r,i,o,l,a,s=t[8]&&Dr(t);const c=[Br,Rr],u=[];function h(t,e){return"bandwidth"in t[0]?0:1}i=h(t),o=u[i]=c[i](t);let d=t[6]&&Fr(t);return{c(){e=M("g"),n=M("g"),s&&s.c(),r=z(),o.c(),d&&d.c(),N(e,"transform",l="translate("+t[2]+","+t[3]+")")},m(t,o){$(t,e,o),w(e,n),s&&s.m(n,null),w(n,r),u[i].m(n,null),d&&d.m(e,null),a=!0},p(t,[f]){t[8]?s?s.p(t,f):(s=Dr(t),s.c(),s.m(n,r)):s&&(s.d(1),s=null);let p=i;i=h(t),i===p?u[i].p(t,f):(rt(),lt(u[p],1,1,(()=>{u[p]=null})),it(),o=u[i],o?o.p(t,f):(o=u[i]=c[i](t),o.c()),ot(o,1),o.m(n,null)),t[6]?d?(d.p(t,f),64&f&&ot(d,1)):(d=Fr(t),d.c(),ot(d,1),d.m(e,null)):d&&(rt(),lt(d,1,1,(()=>{d=null})),it()),(!a||12&f&&l!==(l="translate("+t[2]+","+t[3]+")"))&&N(e,"transform",l)},i(t){a||(ot(o),ot(d),a=!0)},o(t){lt(o),lt(d),a=!1},d(t){t&&x(e),s&&s.d(),u[i].d(),d&&d.d()}}}const Xr=2,Wr=1.2;function Yr(t,e,n){let r,i,o,{scale:l}=e,{label:a=""}=e,{x:s=0}=e,{y:c=0}=e,{format:u=xn}=e,{gridHeight:h=0}=e,{showAxisLabel:d=!0}=e,{showTickLabels:f=!0}=e,{showBaseline:p=!1}=e,{tickLabelOutlineColor:g="transparent"}=e,{tickColor:m="black"}=e,{baselineColor:v="black"}=e,{fontSize:y=10}=e,{tickSize:w=5}=e,{gapBetweenTickAndTickLabel:b=2}=e,{integerOnly:$=!1}=e,{value_map:x={}}=e;return t.$$set=t=>{"scale"in t&&n(0,l=t.scale),"label"in t&&n(1,a=t.label),"x"in t&&n(2,s=t.x),"y"in t&&n(3,c=t.y),"format"in t&&n(4,u=t.format),"gridHeight"in t&&n(5,h=t.gridHeight),"showAxisLabel"in t&&n(6,d=t.showAxisLabel),"showTickLabels"in t&&n(7,f=t.showTickLabels),"showBaseline"in t&&n(8,p=t.showBaseline),"tickLabelOutlineColor"in t&&n(9,g=t.tickLabelOutlineColor),"tickColor"in t&&n(10,m=t.tickColor),"baselineColor"in t&&n(11,v=t.baselineColor),"fontSize"in t&&n(12,y=t.fontSize),"tickSize"in t&&n(13,w=t.tickSize),"gapBetweenTickAndTickLabel"in t&&n(14,b=t.gapBetweenTickAndTickLabel),"integerOnly"in t&&n(15,$=t.integerOnly),"value_map"in t&&n(16,x=t.value_map)},t.$$.update=()=>{1&t.$$.dirty&&n(17,r=l.range()[0]),1&t.$$.dirty&&n(20,i=l.range()[l.range().length-1]),1179648&t.$$.dirty&&n(18,o=i-r)},[l,a,s,c,u,h,d,f,p,g,m,v,y,w,b,$,x,r,o,function(t,e,n){const r=t.ticks(e/80);return n?r.filter(Number.isInteger):r},i]}const Kr=class extends gt{constructor(t){super(),pt(this,t,Yr,Vr,h,{scale:0,label:1,x:2,y:3,format:4,gridHeight:5,showAxisLabel:6,showTickLabels:7,showBaseline:8,tickLabelOutlineColor:9,tickColor:10,baselineColor:11,fontSize:12,tickSize:13,gapBetweenTickAndTickLabel:14,integerOnly:15,value_map:16})}};function Ur(t,e,n){const r=t.slice();return r[21]=e[n],r}function Gr(t,e,n){const r=t.slice();return r[21]=e[n],r}function Zr(t){let e,n,r;return{c(){e=M("line"),N(e,"y1",n=t[0].range()[0]),N(e,"y2",r=t[0].range()[1]),N(e,"stroke",t[11])},m(t,n){$(t,e,n)},p(t,i){1&i&&n!==(n=t[0].range()[0])&&N(e,"y1",n),1&i&&r!==(r=t[0].range()[1])&&N(e,"y2",r),2048&i&&N(e,"stroke",t[11])},d(t){t&&x(e)}}}function Jr(t){let e,n=t[19](t[0],t[18],t[15]),r=[];for(let e=0;e<n.length;e+=1)r[e]=ei(Ur(t,n,e));return{c(){for(let t=0;t<r.length;t+=1)r[t].c();e=z()},m(t,n){for(let e=0;e<r.length;e+=1)r[e].m(t,n);$(t,e,n)},p(t,i){if(849585&i){let o;for(n=t[19](t[0],t[18],t[15]),o=0;o<n.length;o+=1){const l=Ur(t,n,o);r[o]?r[o].p(l,i):(r[o]=ei(l),r[o].c(),r[o].m(e.parentNode,e))}for(;o<r.length;o+=1)r[o].d(1);r.length=n.length}},i:l,o:l,d(t){_(r,t),t&&x(e)}}}function Qr(t){let e,n,r=[],i=new Map,o=t[0].domain();const l=t=>t[21];for(let e=0;e<o.length;e+=1){let n=Gr(t,o,e),a=l(n);i.set(a,r[e]=ii(a,n))}return{c(){for(let t=0;t<r.length;t+=1)r[t].c();e=z()},m(t,i){for(let e=0;e<r.length;e+=1)r[e].m(t,i);$(t,e,i),n=!0},p(t,n){95905&n&&(o=t[0].domain(),rt(),r=ct(r,n,l,1,t,o,i,e.parentNode,st,ii,e,Gr),it())},i(t){if(!n){for(let t=0;t<o.length;t+=1)ot(r[t]);n=!0}},o(t){for(let t=0;t<r.length;t+=1)lt(r[t]);n=!1},d(t){for(let e=0;e<r.length;e+=1)r[e].d(t);t&&x(e)}}}function ti(t){let e,n,r,i,o=t[4](t[21])+"";return{c(){e=M("text"),n=L(o),N(e,"x",r=-t[13]-t[14]),N(e,"text-anchor","end"),N(e,"dominant-baseline","middle"),N(e,"font-size",t[12]),N(e,"stroke",t[9]),N(e,"fill","black"),N(e,"stroke-width",i=2),N(e,"paint-order","stroke")},m(t,r){$(t,e,r),w(e,n)},p(t,i){294929&i&&o!==(o=t[4](t[21])+"")&&T(n,o),24576&i&&r!==(r=-t[13]-t[14])&&N(e,"x",r),4096&i&&N(e,"font-size",t[12]),512&i&&N(e,"stroke",t[9])},d(t){t&&x(e)}}}function ei(t){let e,n,r,i,o=t[7]&&ti(t);return{c(){e=M("g"),n=M("line"),o&&o.c(),N(n,"x1",r=-t[13]),N(n,"x2",t[5]),N(n,"stroke",t[10]),N(e,"transform",i="translate(0,"+t[0](t[21])+")")},m(t,r){$(t,e,r),w(e,n),o&&o.m(e,null)},p(t,l){8192&l&&r!==(r=-t[13])&&N(n,"x1",r),32&l&&N(n,"x2",t[5]),1024&l&&N(n,"stroke",t[10]),t[7]?o?o.p(t,l):(o=ti(t),o.c(),o.m(e,null)):o&&(o.d(1),o=null),294913&l&&i!==(i="translate(0,"+t[0](t[21])+")")&&N(e,"transform",i)},d(t){t&&x(e),o&&o.d()}}}function ni(t){let e,n,r,i;return{c(){e=M("line"),N(e,"y1",n=t[0].bandwidth()/2),N(e,"y2",r=t[0].bandwidth()/2),N(e,"x1",i=-t[13]),N(e,"x2",t[5]),N(e,"stroke",t[10])},m(t,n){$(t,e,n)},p(t,o){1&o&&n!==(n=t[0].bandwidth()/2)&&N(e,"y1",n),1&o&&r!==(r=t[0].bandwidth()/2)&&N(e,"y2",r),8192&o&&i!==(i=-t[13])&&N(e,"x1",i),32&o&&N(e,"x2",t[5]),1024&o&&N(e,"stroke",t[10])},d(t){t&&x(e)}}}function ri(t){let e,n;return e=new Tr({props:{width:t[0].bandwidth()||t[0].step(),height:t[12]*si,x:-(t[13]+t[12]+t[14]),y:0===t[0].bandwidth()?-t[0].step()/2:0,bold:!1,label:t[16][t[21]]??t[21],fontSize:t[12],outlineColor:t[9],rotate:!0}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};1&n&&(r.width=t[0].bandwidth()||t[0].step()),4096&n&&(r.height=t[12]*si),28672&n&&(r.x=-(t[13]+t[12]+t[14])),1&n&&(r.y=0===t[0].bandwidth()?-t[0].step()/2:0),65537&n&&(r.label=t[16][t[21]]??t[21]),4096&n&&(r.fontSize=t[12]),512&n&&(r.outlineColor=t[9]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function ii(t,e){let n,r,i,o,l=e[13]>0&&ni(e),a=e[7]&&ri(e);return{key:t,first:null,c(){n=M("g"),l&&l.c(),r=z(),a&&a.c(),N(n,"transform",i="translate(0,"+e[0](e[21])+")"),this.first=n},m(t,e){$(t,n,e),l&&l.m(n,null),w(n,r),a&&a.m(n,null),o=!0},p(t,s){(e=t)[13]>0?l?l.p(e,s):(l=ni(e),l.c(),l.m(n,r)):l&&(l.d(1),l=null),e[7]?a?(a.p(e,s),128&s&&ot(a,1)):(a=ri(e),a.c(),ot(a,1),a.m(n,null)):a&&(rt(),lt(a,1,1,(()=>{a=null})),it()),(!o||1&s&&i!==(i="translate(0,"+e[0](e[21])+")"))&&N(n,"transform",i)},i(t){o||(ot(a),o=!0)},o(t){lt(a),o=!1},d(t){t&&x(n),l&&l.d(),a&&a.d()}}}function oi(t){let e,n;return e=new Tr({props:{width:t[18],height:t[12]*si,x:-(t[13]+t[14]+t[12]+ai),y:t[17],bold:!0,label:t[1],rotate:!0,fontSize:t[12]}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};262144&n&&(r.width=t[18]),4096&n&&(r.height=t[12]*si),28672&n&&(r.x=-(t[13]+t[14]+t[12]+ai)),131072&n&&(r.y=t[17]),2&n&&(r.label=t[1]),4096&n&&(r.fontSize=t[12]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function li(t){let e,n,r,i,o,l,a,s=t[8]&&Zr(t);const c=[Qr,Jr],u=[];function h(t,e){return"bandwidth"in t[0]?0:1}i=h(t),o=u[i]=c[i](t);let d=t[6]&&oi(t);return{c(){e=M("g"),n=M("g"),s&&s.c(),r=z(),o.c(),d&&d.c(),N(e,"transform",l="translate("+t[2]+","+t[3]+")")},m(t,o){$(t,e,o),w(e,n),s&&s.m(n,null),w(n,r),u[i].m(n,null),d&&d.m(e,null),a=!0},p(t,[f]){t[8]?s?s.p(t,f):(s=Zr(t),s.c(),s.m(n,r)):s&&(s.d(1),s=null);let p=i;i=h(t),i===p?u[i].p(t,f):(rt(),lt(u[p],1,1,(()=>{u[p]=null})),it(),o=u[i],o?o.p(t,f):(o=u[i]=c[i](t),o.c()),ot(o,1),o.m(n,null)),t[6]?d?(d.p(t,f),64&f&&ot(d,1)):(d=oi(t),d.c(),ot(d,1),d.m(e,null)):d&&(rt(),lt(d,1,1,(()=>{d=null})),it()),(!a||12&f&&l!==(l="translate("+t[2]+","+t[3]+")"))&&N(e,"transform",l)},i(t){a||(ot(o),ot(d),a=!0)},o(t){lt(o),lt(d),a=!1},d(t){t&&x(e),s&&s.d(),u[i].d(),d&&d.d()}}}const ai=30,si=1.2;function ci(t,e,n){let r,i,o,{scale:l}=e,{label:a=""}=e,{x:s=0}=e,{y:c=0}=e,{format:u=xn}=e,{gridWidth:h=0}=e,{showAxisLabel:d=!0}=e,{showTickLabels:f=!0}=e,{showBaseline:p=!1}=e,{tickLabelOutlineColor:g="transparent"}=e,{tickColor:m="black"}=e,{baselineColor:v="black"}=e,{fontSize:y=10}=e,{tickSize:w=5}=e,{gapBetweenTickAndTickLabel:b=2}=e,{integerOnly:$=!1}=e,{value_map:x={}}=e;return t.$$set=t=>{"scale"in t&&n(0,l=t.scale),"label"in t&&n(1,a=t.label),"x"in t&&n(2,s=t.x),"y"in t&&n(3,c=t.y),"format"in t&&n(4,u=t.format),"gridWidth"in t&&n(5,h=t.gridWidth),"showAxisLabel"in t&&n(6,d=t.showAxisLabel),"showTickLabels"in t&&n(7,f=t.showTickLabels),"showBaseline"in t&&n(8,p=t.showBaseline),"tickLabelOutlineColor"in t&&n(9,g=t.tickLabelOutlineColor),"tickColor"in t&&n(10,m=t.tickColor),"baselineColor"in t&&n(11,v=t.baselineColor),"fontSize"in t&&n(12,y=t.fontSize),"tickSize"in t&&n(13,w=t.tickSize),"gapBetweenTickAndTickLabel"in t&&n(14,b=t.gapBetweenTickAndTickLabel),"integerOnly"in t&&n(15,$=t.integerOnly),"value_map"in t&&n(16,x=t.value_map)},t.$$.update=()=>{1&t.$$.dirty&&n(17,r=Math.min(l.range()[0],l.range()[l.range().length-1])),1&t.$$.dirty&&n(20,i=Math.max(l.range()[0],l.range()[l.range().length-1])),1179648&t.$$.dirty&&n(18,o=i-r)},[l,a,s,c,u,h,d,f,p,g,m,v,y,w,b,$,x,r,o,function(t,e,n){const r=t.ticks(Math.min(e/30,10));return n?r.filter(Number.isInteger):r},i]}const ui=class extends gt{constructor(t){super(),pt(this,t,ci,li,h,{scale:0,label:1,x:2,y:3,format:4,gridWidth:5,showAxisLabel:6,showTickLabels:7,showBaseline:8,tickLabelOutlineColor:9,tickColor:10,baselineColor:11,fontSize:12,tickSize:13,gapBetweenTickAndTickLabel:14,integerOnly:15,value_map:16})}};function hi(t,e,n){const r=t.slice();return r[8]=e[n],r}function di(t,e,n){const r=t.slice();return r[8]=e[n],r}function fi(t){let e,n,r,i,o,l=t[7],a=[];for(let e=0;e<l.length;e+=1)a[e]=gi(hi(t,l,e));return{c(){for(let t=0;t<a.length;t+=1)a[t].c();e=M("line"),N(e,"x1",n=0),N(e,"x2",r=0),N(e,"y1",i=t[3].range()[0]),N(e,"y2",o=t[3].range()[1]),N(e,"stroke","var(--gray-1)")},m(t,n){for(let e=0;e<a.length;e+=1)a[e].m(t,n);$(t,e,n)},p(t,n){if(233&n){let r;for(l=t[7],r=0;r<l.length;r+=1){const i=hi(t,l,r);a[r]?a[r].p(i,n):(a[r]=gi(i),a[r].c(),a[r].m(e.parentNode,e))}for(;r<a.length;r+=1)a[r].d(1);a.length=l.length}8&n&&i!==(i=t[3].range()[0])&&N(e,"y1",i),8&n&&o!==(o=t[3].range()[1])&&N(e,"y2",o)},d(t){_(a,t),t&&x(e)}}}function pi(t){let e,n,r,i=t[7],o=[];for(let e=0;e<i.length;e+=1)o[e]=mi(di(t,i,e));return{c(){for(let t=0;t<o.length;t+=1)o[t].c();e=M("line"),N(e,"x1",n=t[3].range()[0]),N(e,"x2",r=t[3].range()[1]),N(e,"y1",t[1]),N(e,"y2",t[1]),N(e,"stroke","var(--gray-1)")},m(t,n){for(let e=0;e<o.length;e+=1)o[e].m(t,n);$(t,e,n)},p(t,l){if(233&l){let n;for(i=t[7],n=0;n<i.length;n+=1){const r=di(t,i,n);o[n]?o[n].p(r,l):(o[n]=mi(r),o[n].c(),o[n].m(e.parentNode,e))}for(;n<o.length;n+=1)o[n].d(1);o.length=i.length}8&l&&n!==(n=t[3].range()[0])&&N(e,"x1",n),8&l&&r!==(r=t[3].range()[1])&&N(e,"x2",r),2&l&&N(e,"y1",t[1]),2&l&&N(e,"y2",t[1])},d(t){_(o,t),t&&x(e)}}}function gi(t){let e,n,r,i,o;return{c(){e=M("rect"),N(e,"x",n=0),N(e,"y",r=t[3](t[0].bins[t[8]+1])+1),N(e,"width",i=t[6](t[0].counts[t[8]])),N(e,"height",o=t[3](t[0].bins[t[8]])-t[3](t[0].bins[t[8]+1])-2),N(e,"fill",t[5])},m(t,n){$(t,e,n)},p(t,n){137&n&&r!==(r=t[3](t[0].bins[t[8]+1])+1)&&N(e,"y",r),193&n&&i!==(i=t[6](t[0].counts[t[8]]))&&N(e,"width",i),137&n&&o!==(o=t[3](t[0].bins[t[8]])-t[3](t[0].bins[t[8]+1])-2)&&N(e,"height",o),32&n&&N(e,"fill",t[5])},d(t){t&&x(e)}}}function mi(t){let e,n,r,i,o;return{c(){e=M("rect"),N(e,"x",n=t[3](t[0].bins[t[8]])+1),N(e,"y",r=t[6](t[0].counts[t[8]])),N(e,"width",i=t[3](t[0].bins[t[8]+1])-t[3](t[0].bins[t[8]])-2),N(e,"height",o=t[6](0)-t[6](t[0].counts[t[8]])),N(e,"fill",t[5])},m(t,n){$(t,e,n)},p(t,l){137&l&&n!==(n=t[3](t[0].bins[t[8]])+1)&&N(e,"x",n),193&l&&r!==(r=t[6](t[0].counts[t[8]]))&&N(e,"y",r),137&l&&i!==(i=t[3](t[0].bins[t[8]+1])-t[3](t[0].bins[t[8]])-2)&&N(e,"width",i),193&l&&o!==(o=t[6](0)-t[6](t[0].counts[t[8]]))&&N(e,"height",o),32&l&&N(e,"fill",t[5])},d(t){t&&x(e)}}}function vi(t){let e,n;function r(t,e){return"horizontal"===t[2]?pi:fi}let i=r(t),o=i(t);return{c(){e=M("g"),o.c(),N(e,"transform",n="translate("+t[4]+")")},m(t,n){$(t,e,n),o.m(e,null)},p(t,[l]){i===(i=r(t))&&o?o.p(t,l):(o.d(1),o=i(t),o&&(o.c(),o.m(e,null))),16&l&&n!==(n="translate("+t[4]+")")&&N(e,"transform",n)},i:l,o:l,d(t){t&&x(e),o.d()}}}function yi(t,e,n){let r,i,{data:o}=e,{height:l}=e,{direction:a}=e,{x:s}=e,{translate:c=[0,0]}=e,{fill:u="var(--gray-3)"}=e;return t.$$set=t=>{"data"in t&&n(0,o=t.data),"height"in t&&n(1,l=t.height),"direction"in t&&n(2,a=t.direction),"x"in t&&n(3,s=t.x),"translate"in t&&n(4,c=t.translate),"fill"in t&&n(5,u=t.fill)},t.$$.update=()=>{1&t.$$.dirty&&n(7,r=bn(o.counts.length)),7&t.$$.dirty&&n(6,i=tn().domain([0,Math.max(...o.counts)]).range("horizontal"===a?[l,0]:[0,l]))},[o,l,a,s,c,u,i,r]}const wi=class extends gt{constructor(t){super(),pt(this,t,yi,vi,h,{data:0,height:1,direction:2,x:3,translate:4,fill:5})}};function bi(t,e,n){const r=t.slice();return r[10]=e[n],r}function $i(t,e,n){const r=t.slice();return r[10]=e[n],r}function xi(t){let e,n,r,i,o,l=t[9],a=[];for(let e=0;e<l.length;e+=1)a[e]=ki(bi(t,l,e));return{c(){for(let t=0;t<a.length;t+=1)a[t].c();e=M("line"),N(e,"x1",n=0),N(e,"x2",r=0),N(e,"y1",i=t[3].range()[0]),N(e,"y2",o=t[3].range()[1]),N(e,"stroke","var(--gray-1)")},m(t,n){for(let e=0;e<a.length;e+=1)a[e].m(t,n);$(t,e,n)},p(t,n){if(1001&n){let r;for(l=t[9],r=0;r<l.length;r+=1){const i=bi(t,l,r);a[r]?a[r].p(i,n):(a[r]=ki(i),a[r].c(),a[r].m(e.parentNode,e))}for(;r<a.length;r+=1)a[r].d(1);a.length=l.length}8&n&&i!==(i=t[3].range()[0])&&N(e,"y1",i),8&n&&o!==(o=t[3].range()[1])&&N(e,"y2",o)},d(t){_(a,t),t&&x(e)}}}function _i(t){let e,n,r,i=t[9],o=[];for(let e=0;e<i.length;e+=1)o[e]=Mi($i(t,i,e));return{c(){for(let t=0;t<o.length;t+=1)o[t].c();e=M("line"),N(e,"x1",n=t[3].range()[0]),N(e,"x2",r=t[3].range()[1]),N(e,"y1",t[1]),N(e,"y2",t[1]),N(e,"stroke","var(--gray-1)")},m(t,n){for(let e=0;e<o.length;e+=1)o[e].m(t,n);$(t,e,n)},p(t,l){if(1001&l){let n;for(i=t[9],n=0;n<i.length;n+=1){const r=$i(t,i,n);o[n]?o[n].p(r,l):(o[n]=Mi(r),o[n].c(),o[n].m(e.parentNode,e))}for(;n<o.length;n+=1)o[n].d(1);o.length=i.length}8&l&&n!==(n=t[3].range()[0])&&N(e,"x1",n),8&l&&r!==(r=t[3].range()[1])&&N(e,"x2",r),2&l&&N(e,"y1",t[1]),2&l&&N(e,"y2",t[1])},d(t){_(o,t),t&&x(e)}}}function ki(t){let e,n,r,i;return{c(){e=M("rect"),N(e,"x",n=0),N(e,"y",r=(t[3](t[0].bins[t[10]])??0)-t[7]),N(e,"width",i=t[8](t[0].counts[t[10]])),N(e,"height",t[6]),N(e,"fill",t[5])},m(t,n){$(t,e,n)},p(t,n){649&n&&r!==(r=(t[3](t[0].bins[t[10]])??0)-t[7])&&N(e,"y",r),769&n&&i!==(i=t[8](t[0].counts[t[10]]))&&N(e,"width",i),64&n&&N(e,"height",t[6]),32&n&&N(e,"fill",t[5])},d(t){t&&x(e)}}}function Mi(t){let e,n,r,i;return{c(){e=M("rect"),N(e,"x",n=(t[3](t[0].bins[t[10]])??0)-t[7]),N(e,"y",r=t[8](t[0].counts[t[10]])),N(e,"width",t[6]),N(e,"height",i=t[8](0)-t[8](t[0].counts[t[10]])),N(e,"fill",t[5])},m(t,n){$(t,e,n)},p(t,o){649&o&&n!==(n=(t[3](t[0].bins[t[10]])??0)-t[7])&&N(e,"x",n),769&o&&r!==(r=t[8](t[0].counts[t[10]]))&&N(e,"y",r),64&o&&N(e,"width",t[6]),769&o&&i!==(i=t[8](0)-t[8](t[0].counts[t[10]]))&&N(e,"height",i),32&o&&N(e,"fill",t[5])},d(t){t&&x(e)}}}function Li(t){let e,n;function r(t,e){return"horizontal"===t[2]?_i:xi}let i=r(t),o=i(t);return{c(){e=M("g"),o.c(),N(e,"transform",n="translate("+t[4]+")")},m(t,n){$(t,e,n),o.m(e,null)},p(t,[l]){i===(i=r(t))&&o?o.p(t,l):(o.d(1),o=i(t),o&&(o.c(),o.m(e,null))),16&l&&n!==(n="translate("+t[4]+")")&&N(e,"transform",n)},i:l,o:l,d(t){t&&x(e),o.d()}}}function Ai(t,e,n){let r,i,o,l,{data:a}=e,{height:s}=e,{direction:c}=e,{x:u}=e,{translate:h=[0,0]}=e,{fill:d="var(--gray-3)"}=e;return t.$$set=t=>{"data"in t&&n(0,a=t.data),"height"in t&&n(1,s=t.height),"direction"in t&&n(2,c=t.direction),"x"in t&&n(3,u=t.x),"translate"in t&&n(4,h=t.translate),"fill"in t&&n(5,d=t.fill)},t.$$.update=()=>{1&t.$$.dirty&&n(9,r=bn(a.counts.length)),7&t.$$.dirty&&n(8,i=tn().domain([0,Math.max(...a.counts)]).range("horizontal"===c?[s,0]:[0,s])),8&t.$$.dirty&&n(6,o=(u.bandwidth()||u.step()*u.padding())-2),72&t.$$.dirty&&n(7,l=(0===u.bandwidth()?o/2:0)-1)},[a,s,c,u,h,d,o,l,i,r]}const zi=class extends gt{constructor(t){super(),pt(this,t,Ai,Li,h,{data:0,height:1,direction:2,x:3,translate:4,fill:5})}};function Si(t){b(t,"svelte-1snd3gs",".ice-cluster-container.svelte-1snd3gs{width:100%;height:100%}.ice-cluster.svelte-1snd3gs{display:flex}")}function Ni(t,e,n){const r=t.slice();return r[24]=e[n],r}function Ci(t){let e,n,r,i;const o=[Oi,Ti],l=[];function a(t,e){return"bandwidth"in t[5]?0:1}return n=a(t),r=l[n]=o[n](t),{c(){e=M("svg"),r.c(),N(e,"width",t[1]),N(e,"height",t[3])},m(t,r){$(t,e,r),l[n].m(e,null),i=!0},p(t,s){let c=n;n=a(t),n===c?l[n].p(t,s):(rt(),lt(l[c],1,1,(()=>{l[c]=null})),it(),r=l[n],r?r.p(t,s):(r=l[n]=o[n](t),r.c()),ot(r,1),r.m(e,null)),(!i||2&s)&&N(e,"width",t[1]),(!i||8&s)&&N(e,"height",t[3])},i(t){i||(ot(r),i=!0)},o(t){lt(r),i=!1},d(t){t&&x(e),l[n].d()}}}function Ti(t){let e,n;return e=new wi({props:{data:t[9][t[0].x_feature].distribution,x:t[5],height:t[3],direction:"horizontal"}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};513&n&&(r.data=t[9][t[0].x_feature].distribution),32&n&&(r.x=t[5]),8&n&&(r.height=t[3]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Oi(t){let e,n;return e=new zi({props:{data:t[9][t[0].x_feature].distribution,x:t[5],height:t[3],direction:"horizontal"}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};513&n&&(r.data=t[9][t[0].x_feature].distribution),32&n&&(r.x=t[5]),8&n&&(r.height=t[3]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Ei(t){let e,n,r,i,o,l,a,s,c,u,h,d,f,p,g,m,v;return p=new ui({props:{scale:t[4],x:t[6].left,label:"centered prediction"}}),g=new Kr({props:{scale:t[5],y:t[7]-t[6].bottom,showTickLabels:t[24].id===t[0].ice.clusters.length-1,showAxisLabel:t[24].id===t[0].ice.clusters.length-1,label:t[0].x_feature,integerOnly:"discrete"===t[8].subkind,value_map:"value_map"in t[8]?t[8].value_map:{}}}),{c(){e=k("div"),n=M("svg"),r=M("path"),l=M("path"),c=M("path"),d=M("path"),ht(p.$$.fragment),ht(g.$$.fragment),m=A(),N(r,"d",i=t[10](zr(t[24].p10,t[24].p90))),N(r,"fill",o=t[12](t[24].id)),N(l,"d",a=t[10](zr(t[24].p25,t[24].p75))),N(l,"fill",s=t[13](t[24].id)),N(c,"d",u=t[11](t[24].centered_mean)),N(c,"stroke",h=t[14](t[24].id)),N(c,"stroke-opacity","1"),N(c,"fill","none"),N(c,"stroke-width","2"),N(d,"d",f=t[11](t[0].ice.centered_pdp)),N(d,"stroke","var(--black)"),N(d,"stroke-opacity","1"),N(d,"fill","none"),N(d,"stroke-width","2"),N(n,"class","ice-cluster-chart"),E(n,"height",t[7]),E(n,"width",t[1]),N(e,"class","ice-cluster svelte-1snd3gs")},m(t,i){$(t,e,i),w(e,n),w(n,r),w(n,l),w(n,c),w(n,d),dt(p,n,null),dt(g,n,null),w(e,m),v=!0},p(t,e){(!v||1025&e&&i!==(i=t[10](zr(t[24].p10,t[24].p90))))&&N(r,"d",i),(!v||4097&e&&o!==(o=t[12](t[24].id)))&&N(r,"fill",o),(!v||1025&e&&a!==(a=t[10](zr(t[24].p25,t[24].p75))))&&N(l,"d",a),(!v||8193&e&&s!==(s=t[13](t[24].id)))&&N(l,"fill",s),(!v||2049&e&&u!==(u=t[11](t[24].centered_mean)))&&N(c,"d",u),(!v||16385&e&&h!==(h=t[14](t[24].id)))&&N(c,"stroke",h),(!v||2049&e&&f!==(f=t[11](t[0].ice.centered_pdp)))&&N(d,"d",f);const m={};16&e&&(m.scale=t[4]),64&e&&(m.x=t[6].left),p.$set(m);const y={};32&e&&(y.scale=t[5]),192&e&&(y.y=t[7]-t[6].bottom),1&e&&(y.showTickLabels=t[24].id===t[0].ice.clusters.length-1),1&e&&(y.showAxisLabel=t[24].id===t[0].ice.clusters.length-1),1&e&&(y.label=t[0].x_feature),256&e&&(y.integerOnly="discrete"===t[8].subkind),256&e&&(y.value_map="value_map"in t[8]?t[8].value_map:{}),g.$set(y),128&e&&E(n,"height",t[7]),2&e&&E(n,"width",t[1])},i(t){v||(ot(p.$$.fragment,t),ot(g.$$.fragment,t),v=!0)},o(t){lt(p.$$.fragment,t),lt(g.$$.fragment,t),v=!1},d(t){t&&x(e),ft(p),ft(g)}}}function Di(t){let e,n,r,i=t[2]&&Ci(t),o=t[0].ice.clusters,l=[];for(let e=0;e<o.length;e+=1)l[e]=Ei(Ni(t,o,e));const a=t=>lt(l[t],1,1,(()=>{l[t]=null}));return{c(){i&&i.c(),e=A(),n=k("div");for(let t=0;t<l.length;t+=1)l[t].c();N(n,"class","ice-cluster-container svelte-1snd3gs")},m(t,o){i&&i.m(t,o),$(t,e,o),$(t,n,o);for(let t=0;t<l.length;t+=1)l[t].m(n,null);r=!0},p(t,[r]){if(t[2]?i?(i.p(t,r),4&r&&ot(i,1)):(i=Ci(t),i.c(),ot(i,1),i.m(e.parentNode,e)):i&&(rt(),lt(i,1,1,(()=>{i=null})),it()),32243&r){let e;for(o=t[0].ice.clusters,e=0;e<o.length;e+=1){const i=Ni(t,o,e);l[e]?(l[e].p(i,r),ot(l[e],1)):(l[e]=Ei(i),l[e].c(),ot(l[e],1),l[e].m(n,null))}for(rt(),e=o.length;e<l.length;e+=1)a(e);it()}},i(t){if(!r){ot(i);for(let t=0;t<o.length;t+=1)ot(l[t]);r=!0}},o(t){lt(i),l=l.filter(Boolean);for(let t=0;t<l.length;t+=1)lt(l[t]);r=!1},d(t){i&&i.d(t),t&&x(e),t&&x(n),_(l,t)}}}function Ri(t,e,n){let r,i,o,l,a,s,c,u,h,d,f,g,m,v,y,w,b;p(t,Pn,(t=>n(20,m=t))),p(t,qn,(t=>n(21,v=t))),p(t,jn,(t=>n(22,y=t))),p(t,Bn,(t=>n(23,w=t))),p(t,Nn,(t=>n(9,b=t)));let{pd:$}=e,{width:x}=e,{height:_}=e,{scaleLocally:k}=e,{showMarginalDistribution:M}=e,{marginTop:L}=e,{marginRight:A}=e;return t.$$set=t=>{"pd"in t&&n(0,$=t.pd),"width"in t&&n(1,x=t.width),"height"in t&&n(15,_=t.height),"scaleLocally"in t&&n(16,k=t.scaleLocally),"showMarginalDistribution"in t&&n(2,M=t.showMarginalDistribution),"marginTop"in t&&n(3,L=t.marginTop),"marginRight"in t&&n(17,A=t.marginRight)},t.$$.update=()=>{513&t.$$.dirty&&n(8,r=b[$.x_feature]),131072&t.$$.dirty&&n(6,i={top:5,right:A,bottom:35,left:50}),32776&t.$$.dirty&&n(19,o=_-L),524289&t.$$.dirty&&n(7,l=o/$.ice.clusters.length),323&t.$$.dirty&&n(5,a="quantitative"===r.kind?tn().domain([$.x_values[0],$.x_values[$.x_values.length-1]]).range([i.left,x-i.right]):cr().domain($.x_values).range([i.left,x-i.right]).padding(.5)),16318657&t.$$.dirty&&n(4,s=_n($,o,l,"cluster-bands",k,w,y,v,m,i)),1&t.$$.dirty&&n(18,c=$.ice.clusters.map((t=>t.id))),262144&t.$$.dirty&&n(14,u=lr().domain(c).range(Mn)),262144&t.$$.dirty&&n(13,h=lr().domain(c).range(Ln)),262144&t.$$.dirty&&n(12,d=lr().domain(c).range(An)),49&t.$$.dirty&&n(11,f=_r().x(((t,e)=>{var n;return null!==(n=a($.x_values[e]))&&void 0!==n?n:0})).y((t=>s(t)))),49&t.$$.dirty&&n(10,g=kr().x(((t,e)=>{var n;return null!==(n=a($.x_values[e]))&&void 0!==n?n:0})).y1((t=>s(t[1]))).y0((t=>s(t[0]))))},[$,x,M,L,s,a,i,l,r,b,g,f,d,h,u,_,k,A,c,o,m,v,y,w]}const Bi=class extends gt{constructor(t){super(),pt(this,t,Ri,Di,h,{pd:0,width:1,height:15,scaleLocally:16,showMarginalDistribution:2,marginTop:3,marginRight:17},Si)}};function ji(t){b(t,"svelte-1pymoqc","div.svelte-1pymoqc{position:relative;width:100%;height:100%}.svg-for-clusters.svelte-1pymoqc,canvas.svelte-1pymoqc{position:absolute;top:0;left:0}")}function qi(t,e,n){const r=t.slice();return r[29]=e[n],r}function Pi(t){let e,n,r,i;const o=[Hi,Ii],l=[];function a(t,e){return"bandwidth"in t[8]?0:1}return n=a(t),r=l[n]=o[n](t),{c(){e=M("svg"),r.c(),N(e,"width",t[1]),N(e,"height",t[3])},m(t,r){$(t,e,r),l[n].m(e,null),i=!0},p(t,s){let c=n;n=a(t),n===c?l[n].p(t,s):(rt(),lt(l[c],1,1,(()=>{l[c]=null})),it(),r=l[n],r?r.p(t,s):(r=l[n]=o[n](t),r.c()),ot(r,1),r.m(e,null)),(!i||2&s[0])&&N(e,"width",t[1]),(!i||8&s[0])&&N(e,"height",t[3])},i(t){i||(ot(r),i=!0)},o(t){lt(r),i=!1},d(t){t&&x(e),l[n].d()}}}function Ii(t){let e,n;return e=new wi({props:{data:t[13][t[0].x_feature].distribution,x:t[8],height:t[3],direction:"horizontal"}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};8193&n[0]&&(r.data=t[13][t[0].x_feature].distribution),256&n[0]&&(r.x=t[8]),8&n[0]&&(r.height=t[3]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Hi(t){let e,n;return e=new zi({props:{data:t[13][t[0].x_feature].distribution,x:t[8],height:t[3],direction:"horizontal"}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};8193&n[0]&&(r.data=t[13][t[0].x_feature].distribution),256&n[0]&&(r.x=t[8]),8&n[0]&&(r.height=t[3]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Fi(t){let e,n,r,i,o;return n=new ui({props:{scale:t[7],x:t[10].left,label:"centered prediction"}}),r=new Kr({props:{scale:t[8],y:t[11]-t[10].bottom,showTickLabels:t[29].id===t[9][t[9].length-1],showAxisLabel:t[29].id===t[9][t[9].length-1],label:t[0].x_feature,integerOnly:"discrete"===t[12].subkind,value_map:"value_map"in t[12]?t[12].value_map:{}}}),{c(){e=M("g"),ht(n.$$.fragment),ht(r.$$.fragment),N(e,"transform",i="translate(0,"+(t[6](t[29].id)??0)+")")},m(t,i){$(t,e,i),dt(n,e,null),dt(r,e,null),o=!0},p(t,l){const a={};128&l[0]&&(a.scale=t[7]),1024&l[0]&&(a.x=t[10].left),n.$set(a);const s={};256&l[0]&&(s.scale=t[8]),3072&l[0]&&(s.y=t[11]-t[10].bottom),513&l[0]&&(s.showTickLabels=t[29].id===t[9][t[9].length-1]),513&l[0]&&(s.showAxisLabel=t[29].id===t[9][t[9].length-1]),1&l[0]&&(s.label=t[0].x_feature),4096&l[0]&&(s.integerOnly="discrete"===t[12].subkind),4096&l[0]&&(s.value_map="value_map"in t[12]?t[12].value_map:{}),r.$set(s),(!o||65&l[0]&&i!==(i="translate(0,"+(t[6](t[29].id)??0)+")"))&&N(e,"transform",i)},i(t){o||(ot(n.$$.fragment,t),ot(r.$$.fragment,t),o=!0)},o(t){lt(n.$$.fragment,t),lt(r.$$.fragment,t),o=!1},d(t){t&&x(e),ft(n),ft(r)}}}function Vi(t){let e,n,r,i,o,l,a=t[2]&&Pi(t),s=t[0].ice.clusters,c=[];for(let e=0;e<s.length;e+=1)c[e]=Fi(qi(t,s,e));const u=t=>lt(c[t],1,1,(()=>{c[t]=null}));return{c(){a&&a.c(),e=A(),n=k("div"),r=k("canvas"),i=A(),o=M("svg");for(let t=0;t<c.length;t+=1)c[t].c();N(r,"class","svelte-1pymoqc"),N(o,"class","svg-for-clusters svelte-1pymoqc"),N(o,"height",t[5]),N(o,"width",t[1]),N(n,"class","svelte-1pymoqc")},m(s,u){a&&a.m(s,u),$(s,e,u),$(s,n,u),w(n,r),t[24](r),w(n,i),w(n,o);for(let t=0;t<c.length;t+=1)c[t].m(o,null);l=!0},p(t,n){if(t[2]?a?(a.p(t,n),4&n[0]&&ot(a,1)):(a=Pi(t),a.c(),ot(a,1),a.m(e.parentNode,e)):a&&(rt(),lt(a,1,1,(()=>{a=null})),it()),8129&n[0]){let e;for(s=t[0].ice.clusters,e=0;e<s.length;e+=1){const r=qi(t,s,e);c[e]?(c[e].p(r,n),ot(c[e],1)):(c[e]=Fi(r),c[e].c(),ot(c[e],1),c[e].m(o,null))}for(rt(),e=s.length;e<c.length;e+=1)u(e);it()}(!l||32&n[0])&&N(o,"height",t[5]),(!l||2&n[0])&&N(o,"width",t[1])},i(t){if(!l){ot(a);for(let t=0;t<s.length;t+=1)ot(c[t]);l=!0}},o(t){lt(a),c=c.filter(Boolean);for(let t=0;t<c.length;t+=1)lt(c[t]);l=!1},d(r){a&&a.d(r),r&&x(e),r&&x(n),t[24](null),_(c,r)}}}function Xi(t,e,n){let r,i,o,l,a,s,c,u,h,d,f,g,m,v,y,w;p(t,Pn,(t=>n(20,g=t))),p(t,qn,(t=>n(21,m=t))),p(t,jn,(t=>n(22,v=t))),p(t,Bn,(t=>n(23,y=t))),p(t,Nn,(t=>n(13,w=t)));let b,$,{pd:x}=e,{width:_}=e,{height:k}=e,{scaleLocally:M}=e,{showMarginalDistribution:L}=e,{indices:A}=e,{marginTop:z}=e,{marginRight:S}=e;function N(t,e,n,r,i,o,l){null!=e&&null!=n&&(e.save(),e.clearRect(0,0,o,l),t.ice.clusters.forEach((o=>{var l,a;e.translate(0,null!==(l=i(o.id))&&void 0!==l?l:0),e.lineWidth=1,e.strokeStyle=d(o.id),e.globalAlpha=.25,o.centered_ice_lines.forEach(((t,i)=>{(null===r||r.includes(o.indices[i]))&&(e.beginPath(),n(t),e.stroke())})),e.lineWidth=2,e.strokeStyle=h(o.id),e.globalAlpha=1,e.beginPath(),n(o.centered_mean),e.stroke(),e.lineWidth=2,e.strokeStyle="black",e.globalAlpha=1,e.beginPath(),n(t.ice.centered_pdp),e.stroke(),e.translate(0,-(null!==(a=i(o.id))&&void 0!==a?a:0))})),e.restore())}return P((()=>{n(18,$=b.getContext("2d"))})),t.$$set=t=>{"pd"in t&&n(0,x=t.pd),"width"in t&&n(1,_=t.width),"height"in t&&n(14,k=t.height),"scaleLocally"in t&&n(15,M=t.scaleLocally),"showMarginalDistribution"in t&&n(2,L=t.showMarginalDistribution),"indices"in t&&n(16,A=t.indices),"marginTop"in t&&n(3,z=t.marginTop),"marginRight"in t&&n(17,S=t.marginRight)},t.$$.update=()=>{8193&t.$$.dirty[0]&&n(12,r=w[x.x_feature]),131072&t.$$.dirty[0]&&n(10,i={top:5,right:S,bottom:35,left:50}),16392&t.$$.dirty[0]&&n(5,o=k-z),1&t.$$.dirty[0]&&n(9,l=x.ice.clusters.map((t=>t.id))),544&t.$$.dirty[0]&&n(6,a=ar().domain(l).range([0,o])),64&t.$$.dirty[0]&&n(11,s=a.bandwidth()),5123&t.$$.dirty[0]&&n(8,c="quantitative"===r.kind?tn().domain([x.x_values[0],x.x_values[x.x_values.length-1]]).range([i.left,_-i.right]):cr().domain(x.x_values).range([i.left,_-i.right]).padding(.5)),15764513&t.$$.dirty[0]&&n(7,u=_n(x,o,s,"cluster-lines",M,y,v,m,g,i)),512&t.$$.dirty[0]&&(h=lr().domain(l).range(Mn)),512&t.$$.dirty[0]&&(d=lr().domain(l).range(Ln)),262529&t.$$.dirty[0]&&n(19,f=_r().x(((t,e)=>{var n;return null!==(n=c(x.x_values[e]))&&void 0!==n?n:0})).y((t=>u(t))).context($)),262194&t.$$.dirty[0]&&$&&($n(b,$,_,o),N(x,$,f,A,a,_,o)),852067&t.$$.dirty[0]&&N(x,$,f,A,a,_,o)},[x,_,L,z,b,o,a,u,c,l,i,s,r,w,k,M,A,S,$,f,g,m,v,y,function(t){F[t?"unshift":"push"]((()=>{b=t,n(4,b)}))}]}const Wi=class extends gt{constructor(t){super(),pt(this,t,Xi,Vi,h,{pd:0,width:1,height:14,scaleLocally:15,showMarginalDistribution:2,indices:16,marginTop:3,marginRight:17},ji,[-1,-1])}};function Yi(t,e,n){const r=t.slice();return r[21]=e[n],r}function Ki(t,e,n){const r=t.slice();return r[24]=e[n],r}function Ui(t,e,n){const r=t.slice();return r[21]=e[n],r}function Gi(t){let e,n=t[11],r=[];for(let e=0;e<n.length;e+=1)r[e]=Zi(Ui(t,n,e));return{c(){e=M("g");for(let t=0;t<r.length;t+=1)r[t].c()},m(t,n){$(t,e,n);for(let t=0;t<r.length;t+=1)r[t].m(e,null)},p(t,i){if(6193&i){let o;for(n=t[11],o=0;o<n.length;o+=1){const l=Ui(t,n,o);r[o]?r[o].p(l,i):(r[o]=Zi(l),r[o].c(),r[o].m(e,null))}for(;o<r.length;o+=1)r[o].d(1);r.length=n.length}},d(t){t&&x(e),_(r,t)}}}function Zi(t){let e,n,r,i;return{c(){e=M("circle"),N(e,"cx",n=t[5](t[0].x_values[t[21]])),N(e,"cy",r=t[4](t[24].centered_mean[t[21]])),N(e,"r",t[12]),N(e,"fill",i="var(--gray-2)")},m(t,n){$(t,e,n)},p(t,i){2081&i&&n!==(n=t[5](t[0].x_values[t[21]]))&&N(e,"cx",n),2065&i&&r!==(r=t[4](t[24].centered_mean[t[21]]))&&N(e,"cy",r),4096&i&&N(e,"r",t[12])},d(t){t&&x(e)}}}function Ji(t){let e,n,r,i,o="categorical"===t[8].kind&&Gi(t);return{c(){e=M("path"),o&&o.c(),i=z(),N(e,"d",n=t[10](t[24].centered_mean)),N(e,"stroke",r="var(--gray-2)"),N(e,"stroke-width","2"),N(e,"fill","none")},m(t,n){$(t,e,n),o&&o.m(t,n),$(t,i,n)},p(t,r){1025&r&&n!==(n=t[10](t[24].centered_mean))&&N(e,"d",n),"categorical"===t[8].kind?o?o.p(t,r):(o=Gi(t),o.c(),o.m(i.parentNode,i)):o&&(o.d(1),o=null)},d(t){t&&x(e),o&&o.d(t),t&&x(i)}}}function Qi(t){let e,n=t[11],r=[];for(let e=0;e<n.length;e+=1)r[e]=to(Yi(t,n,e));return{c(){for(let t=0;t<r.length;t+=1)r[t].c();e=z()},m(t,n){for(let e=0;e<r.length;e+=1)r[e].m(t,n);$(t,e,n)},p(t,i){if(6193&i){let o;for(n=t[11],o=0;o<n.length;o+=1){const l=Yi(t,n,o);r[o]?r[o].p(l,i):(r[o]=to(l),r[o].c(),r[o].m(e.parentNode,e))}for(;o<r.length;o+=1)r[o].d(1);r.length=n.length}},d(t){_(r,t),t&&x(e)}}}function to(t){let e,n,r;return{c(){e=M("circle"),N(e,"cx",n=t[5](t[0].x_values[t[21]])),N(e,"cy",r=t[4](t[0].ice.centered_pdp[t[21]])),N(e,"r",t[12]),N(e,"fill","var(--black)")},m(t,n){$(t,e,n)},p(t,i){2081&i&&n!==(n=t[5](t[0].x_values[t[21]]))&&N(e,"cx",n),2065&i&&r!==(r=t[4](t[0].ice.centered_pdp[t[21]]))&&N(e,"cy",r),4096&i&&N(e,"r",t[12])},d(t){t&&x(e)}}}function eo(t){let e,n,r,i;const o=[ro,no],l=[];function a(t,e){return"bandwidth"in t[5]?0:1}return e=a(t),n=l[e]=o[e](t),{c(){n.c(),r=z()},m(t,n){l[e].m(t,n),$(t,r,n),i=!0},p(t,i){let s=e;e=a(t),e===s?l[e].p(t,i):(rt(),lt(l[s],1,1,(()=>{l[s]=null})),it(),n=l[e],n?n.p(t,i):(n=l[e]=o[e](t),n.c()),ot(n,1),n.m(r.parentNode,r))},i(t){i||(ot(n),i=!0)},o(t){lt(n),i=!1},d(t){l[e].d(t),t&&x(r)}}}function no(t){let e,n;return e=new wi({props:{data:t[9][t[0].x_feature].distribution,x:t[5],height:t[6].top,direction:"horizontal"}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};513&n&&(r.data=t[9][t[0].x_feature].distribution),32&n&&(r.x=t[5]),64&n&&(r.height=t[6].top),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function ro(t){let e,n;return e=new zi({props:{data:t[9][t[0].x_feature].distribution,x:t[5],height:t[6].top,direction:"horizontal"}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};513&n&&(r.data=t[9][t[0].x_feature].distribution),32&n&&(r.x=t[5]),64&n&&(r.height=t[6].top),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function io(t){let e,n,r,i,o,l,a,s,c=t[0].ice.clusters,u=[];for(let e=0;e<c.length;e+=1)u[e]=Ji(Ki(t,c,e));let h="categorical"===t[8].kind&&Qi(t);l=new Kr({props:{scale:t[5],y:t[7]-t[6].bottom,label:t[0].x_feature,integerOnly:"discrete"===t[8].subkind,value_map:"value_map"in t[8]?t[8].value_map:{}}}),a=new ui({props:{scale:t[4],x:t[6].left,label:"centered avg. prediction"}});let d=t[3]&&eo(t);return{c(){e=M("svg"),n=M("g");for(let t=0;t<u.length;t+=1)u[t].c();r=M("path"),h&&h.c(),o=z(),ht(l.$$.fragment),ht(a.$$.fragment),d&&d.c(),N(r,"d",i=t[10](t[0].ice.centered_pdp)),N(r,"stroke","var(--black)"),N(r,"stroke-width","2"),N(r,"fill","none"),N(e,"width",t[1]),N(e,"height",t[2])},m(t,i){$(t,e,i),w(e,n);for(let t=0;t<u.length;t+=1)u[t].m(n,null);w(e,r),h&&h.m(e,null),w(e,o),dt(l,e,null),dt(a,e,null),d&&d.m(e,null),s=!0},p(t,[f]){if(7473&f){let e;for(c=t[0].ice.clusters,e=0;e<c.length;e+=1){const r=Ki(t,c,e);u[e]?u[e].p(r,f):(u[e]=Ji(r),u[e].c(),u[e].m(n,null))}for(;e<u.length;e+=1)u[e].d(1);u.length=c.length}(!s||1025&f&&i!==(i=t[10](t[0].ice.centered_pdp)))&&N(r,"d",i),"categorical"===t[8].kind?h?h.p(t,f):(h=Qi(t),h.c(),h.m(e,o)):h&&(h.d(1),h=null);const p={};32&f&&(p.scale=t[5]),192&f&&(p.y=t[7]-t[6].bottom),1&f&&(p.label=t[0].x_feature),256&f&&(p.integerOnly="discrete"===t[8].subkind),256&f&&(p.value_map="value_map"in t[8]?t[8].value_map:{}),l.$set(p);const g={};16&f&&(g.scale=t[4]),64&f&&(g.x=t[6].left),a.$set(g),t[3]?d?(d.p(t,f),8&f&&ot(d,1)):(d=eo(t),d.c(),ot(d,1),d.m(e,null)):d&&(rt(),lt(d,1,1,(()=>{d=null})),it()),(!s||2&f)&&N(e,"width",t[1]),(!s||4&f)&&N(e,"height",t[2])},i(t){s||(ot(l.$$.fragment,t),ot(a.$$.fragment,t),ot(d),s=!0)},o(t){lt(l.$$.fragment,t),lt(a.$$.fragment,t),lt(d),s=!1},d(t){t&&x(e),_(u,t),h&&h.d(),ft(l),ft(a),d&&d.d()}}}function oo(t,e,n){let r,i,o,l,a,s,c,u,h,d,f,g,m,v;p(t,Pn,(t=>n(17,d=t))),p(t,qn,(t=>n(18,f=t))),p(t,jn,(t=>n(19,g=t))),p(t,Bn,(t=>n(20,m=t))),p(t,Nn,(t=>n(9,v=t)));let{pd:y}=e,{width:w}=e,{height:b}=e,{scaleLocally:$}=e,{showMarginalDistribution:x}=e,{marginTop:_}=e,{marginRight:k}=e;return t.$$set=t=>{"pd"in t&&n(0,y=t.pd),"width"in t&&n(1,w=t.width),"height"in t&&n(2,b=t.height),"scaleLocally"in t&&n(13,$=t.scaleLocally),"showMarginalDistribution"in t&&n(3,x=t.showMarginalDistribution),"marginTop"in t&&n(14,_=t.marginTop),"marginRight"in t&&n(15,k=t.marginRight)},t.$$.update=()=>{513&t.$$.dirty&&n(8,r=v[y.x_feature]),49152&t.$$.dirty&&n(6,i={top:_,right:k,bottom:35,left:50}),4&t.$$.dirty&&n(7,o=b),129&t.$$.dirty&&n(16,l=o/y.ice.clusters.length),323&t.$$.dirty&&n(5,a="quantitative"===r.kind?tn().domain([y.x_values[0],y.x_values[y.x_values.length-1]]).range([i.left,w-i.right]):cr().domain(y.x_values).range([i.left,w-i.right]).padding(.5)),32&t.$$.dirty&&n(12,s="step"in a?Math.min(3,a.step()/2-1):0),2040001&t.$$.dirty&&n(4,c=_n(y,o,l,"cluster-centers",$,m,g,f,d,i)),1&t.$$.dirty&&n(11,u=bn(y.x_values.length)),49&t.$$.dirty&&n(10,h=_r().x(((t,e)=>{var n;return null!==(n=a(y.x_values[e]))&&void 0!==n?n:0})).y((t=>c(t))))},[y,w,b,x,c,a,i,o,r,v,h,u,s,$,_,k,l,d,f,g,m]}const lo=class extends gt{constructor(t){super(),pt(this,t,oo,io,h,{pd:0,width:1,height:2,scaleLocally:13,showMarginalDistribution:3,marginTop:14,marginRight:15})}};function ao(){}function so(t){return null==t?ao:function(){return this.querySelector(t)}}function co(t){return null==t?[]:Array.isArray(t)?t:Array.from(t)}function uo(){return[]}function ho(t){return null==t?uo:function(){return this.querySelectorAll(t)}}function fo(t){return function(){return this.matches(t)}}function po(t){return function(e){return e.matches(t)}}var go=Array.prototype.find;function mo(){return this.firstElementChild}var vo=Array.prototype.filter;function yo(){return Array.from(this.children)}function wo(t){return new Array(t.length)}function bo(t,e){this.ownerDocument=t.ownerDocument,this.namespaceURI=t.namespaceURI,this._next=null,this._parent=t,this.__data__=e}function $o(t){return function(){return t}}function xo(t,e,n,r,i,o){for(var l,a=0,s=e.length,c=o.length;a<c;++a)(l=e[a])?(l.__data__=o[a],r[a]=l):n[a]=new bo(t,o[a]);for(;a<s;++a)(l=e[a])&&(i[a]=l)}function _o(t,e,n,r,i,o,l){var a,s,c,u=new Map,h=e.length,d=o.length,f=new Array(h);for(a=0;a<h;++a)(s=e[a])&&(f[a]=c=l.call(s,s.__data__,a,e)+"",u.has(c)?i[a]=s:u.set(c,s));for(a=0;a<d;++a)c=l.call(t,o[a],a,o)+"",(s=u.get(c))?(r[a]=s,s.__data__=o[a],u.delete(c)):n[a]=new bo(t,o[a]);for(a=0;a<h;++a)(s=e[a])&&u.get(f[a])===s&&(i[a]=s)}function ko(t){return t.__data__}function Mo(t){return"object"==typeof t&&"length"in t?t:Array.from(t)}function Lo(t,e){return t<e?-1:t>e?1:t>=e?0:NaN}bo.prototype={constructor:bo,appendChild:function(t){return this._parent.insertBefore(t,this._next)},insertBefore:function(t,e){return this._parent.insertBefore(t,e)},querySelector:function(t){return this._parent.querySelector(t)},querySelectorAll:function(t){return this._parent.querySelectorAll(t)}};var Ao="http://www.w3.org/1999/xhtml";const zo={svg:"http://www.w3.org/2000/svg",xhtml:Ao,xlink:"http://www.w3.org/1999/xlink",xml:"http://www.w3.org/XML/1998/namespace",xmlns:"http://www.w3.org/2000/xmlns/"};function So(t){var e=t+="",n=e.indexOf(":");return n>=0&&"xmlns"!==(e=t.slice(0,n))&&(t=t.slice(n+1)),zo.hasOwnProperty(e)?{space:zo[e],local:t}:t}function No(t){return function(){this.removeAttribute(t)}}function Co(t){return function(){this.removeAttributeNS(t.space,t.local)}}function To(t,e){return function(){this.setAttribute(t,e)}}function Oo(t,e){return function(){this.setAttributeNS(t.space,t.local,e)}}function Eo(t,e){return function(){var n=e.apply(this,arguments);null==n?this.removeAttribute(t):this.setAttribute(t,n)}}function Do(t,e){return function(){var n=e.apply(this,arguments);null==n?this.removeAttributeNS(t.space,t.local):this.setAttributeNS(t.space,t.local,n)}}function Ro(t){return t.ownerDocument&&t.ownerDocument.defaultView||t.document&&t||t.defaultView}function Bo(t){return function(){this.style.removeProperty(t)}}function jo(t,e,n){return function(){this.style.setProperty(t,e,n)}}function qo(t,e,n){return function(){var r=e.apply(this,arguments);null==r?this.style.removeProperty(t):this.style.setProperty(t,r,n)}}function Po(t,e){return t.style.getPropertyValue(e)||Ro(t).getComputedStyle(t,null).getPropertyValue(e)}function Io(t){return function(){delete this[t]}}function Ho(t,e){return function(){this[t]=e}}function Fo(t,e){return function(){var n=e.apply(this,arguments);null==n?delete this[t]:this[t]=n}}function Vo(t){return t.trim().split(/^|\s+/)}function Xo(t){return t.classList||new Wo(t)}function Wo(t){this._node=t,this._names=Vo(t.getAttribute("class")||"")}function Yo(t,e){for(var n=Xo(t),r=-1,i=e.length;++r<i;)n.add(e[r])}function Ko(t,e){for(var n=Xo(t),r=-1,i=e.length;++r<i;)n.remove(e[r])}function Uo(t){return function(){Yo(this,t)}}function Go(t){return function(){Ko(this,t)}}function Zo(t,e){return function(){(e.apply(this,arguments)?Yo:Ko)(this,t)}}function Jo(){this.textContent=""}function Qo(t){return function(){this.textContent=t}}function tl(t){return function(){var e=t.apply(this,arguments);this.textContent=null==e?"":e}}function el(){this.innerHTML=""}function nl(t){return function(){this.innerHTML=t}}function rl(t){return function(){var e=t.apply(this,arguments);this.innerHTML=null==e?"":e}}function il(){this.nextSibling&&this.parentNode.appendChild(this)}function ol(){this.previousSibling&&this.parentNode.insertBefore(this,this.parentNode.firstChild)}function ll(t){return function(){var e=this.ownerDocument,n=this.namespaceURI;return n===Ao&&e.documentElement.namespaceURI===Ao?e.createElement(t):e.createElementNS(n,t)}}function al(t){return function(){return this.ownerDocument.createElementNS(t.space,t.local)}}function sl(t){var e=So(t);return(e.local?al:ll)(e)}function cl(){return null}function ul(){var t=this.parentNode;t&&t.removeChild(this)}function hl(){var t=this.cloneNode(!1),e=this.parentNode;return e?e.insertBefore(t,this.nextSibling):t}function dl(){var t=this.cloneNode(!0),e=this.parentNode;return e?e.insertBefore(t,this.nextSibling):t}function fl(t){return t.trim().split(/^|\s+/).map((function(t){var e="",n=t.indexOf(".");return n>=0&&(e=t.slice(n+1),t=t.slice(0,n)),{type:t,name:e}}))}function pl(t){return function(){var e=this.__on;if(e){for(var n,r=0,i=-1,o=e.length;r<o;++r)n=e[r],t.type&&n.type!==t.type||n.name!==t.name?e[++i]=n:this.removeEventListener(n.type,n.listener,n.options);++i?e.length=i:delete this.__on}}}function gl(t,e,n){return function(){var r,i=this.__on,o=function(t){return function(e){t.call(this,e,this.__data__)}}(e);if(i)for(var l=0,a=i.length;l<a;++l)if((r=i[l]).type===t.type&&r.name===t.name)return this.removeEventListener(r.type,r.listener,r.options),this.addEventListener(r.type,r.listener=o,r.options=n),void(r.value=e);this.addEventListener(t.type,o,n),r={type:t.type,name:t.name,value:e,listener:o,options:n},i?i.push(r):this.__on=[r]}}function ml(t,e,n){var r=Ro(t),i=r.CustomEvent;"function"==typeof i?i=new i(e,n):(i=r.document.createEvent("Event"),n?(i.initEvent(e,n.bubbles,n.cancelable),i.detail=n.detail):i.initEvent(e,!1,!1)),t.dispatchEvent(i)}function vl(t,e){return function(){return ml(this,t,e)}}function yl(t,e){return function(){return ml(this,t,e.apply(this,arguments))}}Wo.prototype={add:function(t){this._names.indexOf(t)<0&&(this._names.push(t),this._node.setAttribute("class",this._names.join(" ")))},remove:function(t){var e=this._names.indexOf(t);e>=0&&(this._names.splice(e,1),this._node.setAttribute("class",this._names.join(" ")))},contains:function(t){return this._names.indexOf(t)>=0}};var wl=[null];function bl(t,e){this._groups=t,this._parents=e}function $l(){return new bl([[document.documentElement]],wl)}bl.prototype=$l.prototype={constructor:bl,select:function(t){"function"!=typeof t&&(t=so(t));for(var e=this._groups,n=e.length,r=new Array(n),i=0;i<n;++i)for(var o,l,a=e[i],s=a.length,c=r[i]=new Array(s),u=0;u<s;++u)(o=a[u])&&(l=t.call(o,o.__data__,u,a))&&("__data__"in o&&(l.__data__=o.__data__),c[u]=l);return new bl(r,this._parents)},selectAll:function(t){t="function"==typeof t?function(t){return function(){return co(t.apply(this,arguments))}}(t):ho(t);for(var e=this._groups,n=e.length,r=[],i=[],o=0;o<n;++o)for(var l,a=e[o],s=a.length,c=0;c<s;++c)(l=a[c])&&(r.push(t.call(l,l.__data__,c,a)),i.push(l));return new bl(r,i)},selectChild:function(t){return this.select(null==t?mo:function(t){return function(){return go.call(this.children,t)}}("function"==typeof t?t:po(t)))},selectChildren:function(t){return this.selectAll(null==t?yo:function(t){return function(){return vo.call(this.children,t)}}("function"==typeof t?t:po(t)))},filter:function(t){"function"!=typeof t&&(t=fo(t));for(var e=this._groups,n=e.length,r=new Array(n),i=0;i<n;++i)for(var o,l=e[i],a=l.length,s=r[i]=[],c=0;c<a;++c)(o=l[c])&&t.call(o,o.__data__,c,l)&&s.push(o);return new bl(r,this._parents)},data:function(t,e){if(!arguments.length)return Array.from(this,ko);var n=e?_o:xo,r=this._parents,i=this._groups;"function"!=typeof t&&(t=$o(t));for(var o=i.length,l=new Array(o),a=new Array(o),s=new Array(o),c=0;c<o;++c){var u=r[c],h=i[c],d=h.length,f=Mo(t.call(u,u&&u.__data__,c,r)),p=f.length,g=a[c]=new Array(p),m=l[c]=new Array(p),v=s[c]=new Array(d);n(u,h,g,m,v,f,e);for(var y,w,b=0,$=0;b<p;++b)if(y=g[b]){for(b>=$&&($=b+1);!(w=m[$])&&++$<p;);y._next=w||null}}return(l=new bl(l,r))._enter=a,l._exit=s,l},enter:function(){return new bl(this._enter||this._groups.map(wo),this._parents)},exit:function(){return new bl(this._exit||this._groups.map(wo),this._parents)},join:function(t,e,n){var r=this.enter(),i=this,o=this.exit();return"function"==typeof t?(r=t(r))&&(r=r.selection()):r=r.append(t+""),null!=e&&(i=e(i))&&(i=i.selection()),null==n?o.remove():n(o),r&&i?r.merge(i).order():i},merge:function(t){for(var e=t.selection?t.selection():t,n=this._groups,r=e._groups,i=n.length,o=r.length,l=Math.min(i,o),a=new Array(i),s=0;s<l;++s)for(var c,u=n[s],h=r[s],d=u.length,f=a[s]=new Array(d),p=0;p<d;++p)(c=u[p]||h[p])&&(f[p]=c);for(;s<i;++s)a[s]=n[s];return new bl(a,this._parents)},selection:function(){return this},order:function(){for(var t=this._groups,e=-1,n=t.length;++e<n;)for(var r,i=t[e],o=i.length-1,l=i[o];--o>=0;)(r=i[o])&&(l&&4^r.compareDocumentPosition(l)&&l.parentNode.insertBefore(r,l),l=r);return this},sort:function(t){function e(e,n){return e&&n?t(e.__data__,n.__data__):!e-!n}t||(t=Lo);for(var n=this._groups,r=n.length,i=new Array(r),o=0;o<r;++o){for(var l,a=n[o],s=a.length,c=i[o]=new Array(s),u=0;u<s;++u)(l=a[u])&&(c[u]=l);c.sort(e)}return new bl(i,this._parents).order()},call:function(){var t=arguments[0];return arguments[0]=this,t.apply(null,arguments),this},nodes:function(){return Array.from(this)},node:function(){for(var t=this._groups,e=0,n=t.length;e<n;++e)for(var r=t[e],i=0,o=r.length;i<o;++i){var l=r[i];if(l)return l}return null},size:function(){let t=0;for(const e of this)++t;return t},empty:function(){return!this.node()},each:function(t){for(var e=this._groups,n=0,r=e.length;n<r;++n)for(var i,o=e[n],l=0,a=o.length;l<a;++l)(i=o[l])&&t.call(i,i.__data__,l,o);return this},attr:function(t,e){var n=So(t);if(arguments.length<2){var r=this.node();return n.local?r.getAttributeNS(n.space,n.local):r.getAttribute(n)}return this.each((null==e?n.local?Co:No:"function"==typeof e?n.local?Do:Eo:n.local?Oo:To)(n,e))},style:function(t,e,n){return arguments.length>1?this.each((null==e?Bo:"function"==typeof e?qo:jo)(t,e,null==n?"":n)):Po(this.node(),t)},property:function(t,e){return arguments.length>1?this.each((null==e?Io:"function"==typeof e?Fo:Ho)(t,e)):this.node()[t]},classed:function(t,e){var n=Vo(t+"");if(arguments.length<2){for(var r=Xo(this.node()),i=-1,o=n.length;++i<o;)if(!r.contains(n[i]))return!1;return!0}return this.each(("function"==typeof e?Zo:e?Uo:Go)(n,e))},text:function(t){return arguments.length?this.each(null==t?Jo:("function"==typeof t?tl:Qo)(t)):this.node().textContent},html:function(t){return arguments.length?this.each(null==t?el:("function"==typeof t?rl:nl)(t)):this.node().innerHTML},raise:function(){return this.each(il)},lower:function(){return this.each(ol)},append:function(t){var e="function"==typeof t?t:sl(t);return this.select((function(){return this.appendChild(e.apply(this,arguments))}))},insert:function(t,e){var n="function"==typeof t?t:sl(t),r=null==e?cl:"function"==typeof e?e:so(e);return this.select((function(){return this.insertBefore(n.apply(this,arguments),r.apply(this,arguments)||null)}))},remove:function(){return this.each(ul)},clone:function(t){return this.select(t?dl:hl)},datum:function(t){return arguments.length?this.property("__data__",t):this.node().__data__},on:function(t,e,n){var r,i,o=fl(t+""),l=o.length;if(!(arguments.length<2)){for(a=e?gl:pl,r=0;r<l;++r)this.each(a(o[r],e,n));return this}var a=this.node().__on;if(a)for(var s,c=0,u=a.length;c<u;++c)for(r=0,s=a[c];r<l;++r)if((i=o[r]).type===s.type&&i.name===s.name)return s.value},dispatch:function(t,e){return this.each(("function"==typeof e?yl:vl)(t,e))},[Symbol.iterator]:function*(){for(var t=this._groups,e=0,n=t.length;e<n;++e)for(var r,i=t[e],o=0,l=i.length;o<l;++o)(r=i[o])&&(yield r)}};const xl=$l;function _l(t){return"string"==typeof t?new bl([[document.querySelector(t)]],[document.documentElement]):new bl([[t]],wl)}var kl={value:()=>{}};function Ml(){for(var t,e=0,n=arguments.length,r={};e<n;++e){if(!(t=arguments[e]+"")||t in r||/[\s.]/.test(t))throw new Error("illegal type: "+t);r[t]=[]}return new Ll(r)}function Ll(t){this._=t}function Al(t,e){return t.trim().split(/^|\s+/).map((function(t){var n="",r=t.indexOf(".");if(r>=0&&(n=t.slice(r+1),t=t.slice(0,r)),t&&!e.hasOwnProperty(t))throw new Error("unknown type: "+t);return{type:t,name:n}}))}function zl(t,e){for(var n,r=0,i=t.length;r<i;++r)if((n=t[r]).name===e)return n.value}function Sl(t,e,n){for(var r=0,i=t.length;r<i;++r)if(t[r].name===e){t[r]=kl,t=t.slice(0,r).concat(t.slice(r+1));break}return null!=n&&t.push({name:e,value:n}),t}Ll.prototype=Ml.prototype={constructor:Ll,on:function(t,e){var n,r=this._,i=Al(t+"",r),o=-1,l=i.length;if(!(arguments.length<2)){if(null!=e&&"function"!=typeof e)throw new Error("invalid callback: "+e);for(;++o<l;)if(n=(t=i[o]).type)r[n]=Sl(r[n],t.name,e);else if(null==e)for(n in r)r[n]=Sl(r[n],t.name,null);return this}for(;++o<l;)if((n=(t=i[o]).type)&&(n=zl(r[n],t.name)))return n},copy:function(){var t={},e=this._;for(var n in e)t[n]=e[n].slice();return new Ll(t)},call:function(t,e){if((n=arguments.length-2)>0)for(var n,r,i=new Array(n),o=0;o<n;++o)i[o]=arguments[o+2];if(!this._.hasOwnProperty(t))throw new Error("unknown type: "+t);for(o=0,n=(r=this._[t]).length;o<n;++o)r[o].value.apply(e,i)},apply:function(t,e,n){if(!this._.hasOwnProperty(t))throw new Error("unknown type: "+t);for(var r=this._[t],i=0,o=r.length;i<o;++i)r[i].value.apply(e,n)}};const Nl=Ml,Cl={capture:!0,passive:!1};function Tl(t){t.preventDefault(),t.stopImmediatePropagation()}function Ol(t){var e=t.document.documentElement,n=_l(t).on("dragstart.drag",Tl,Cl);"onselectstart"in e?n.on("selectstart.drag",Tl,Cl):(e.__noselect=e.style.MozUserSelect,e.style.MozUserSelect="none")}function El(t,e){var n=t.document.documentElement,r=_l(t).on("dragstart.drag",null);e&&(r.on("click.drag",Tl,Cl),setTimeout((function(){r.on("click.drag",null)}),0)),"onselectstart"in n?r.on("selectstart.drag",null):(n.style.MozUserSelect=n.__noselect,delete n.__noselect)}function Dl(t,e){if(t=function(t){let e;for(;e=t.sourceEvent;)t=e;return t}(t),void 0===e&&(e=t.currentTarget),e){var n=e.ownerSVGElement||e;if(n.createSVGPoint){var r=n.createSVGPoint();return r.x=t.clientX,r.y=t.clientY,[(r=r.matrixTransform(e.getScreenCTM().inverse())).x,r.y]}if(e.getBoundingClientRect){var i=e.getBoundingClientRect();return[t.clientX-i.left-e.clientLeft,t.clientY-i.top-e.clientTop]}}return[t.pageX,t.pageY]}var Rl,Bl,jl=0,ql=0,Pl=0,Il=0,Hl=0,Fl=0,Vl="object"==typeof performance&&performance.now?performance:Date,Xl="object"==typeof window&&window.requestAnimationFrame?window.requestAnimationFrame.bind(window):function(t){setTimeout(t,17)};function Wl(){return Hl||(Xl(Yl),Hl=Vl.now()+Fl)}function Yl(){Hl=0}function Kl(){this._call=this._time=this._next=null}function Ul(t,e,n){var r=new Kl;return r.restart(t,e,n),r}function Gl(){Hl=(Il=Vl.now())+Fl,jl=ql=0;try{!function(){Wl(),++jl;for(var t,e=Rl;e;)(t=Hl-e._time)>=0&&e._call.call(void 0,t),e=e._next;--jl}()}finally{jl=0,function(){for(var t,e,n=Rl,r=1/0;n;)n._call?(r>n._time&&(r=n._time),t=n,n=n._next):(e=n._next,n._next=null,n=t?t._next=e:Rl=e);Bl=t,Jl(r)}(),Hl=0}}function Zl(){var t=Vl.now(),e=t-Il;e>1e3&&(Fl-=e,Il=t)}function Jl(t){jl||(ql&&(ql=clearTimeout(ql)),t-Hl>24?(t<1/0&&(ql=setTimeout(Gl,t-Vl.now()-Fl)),Pl&&(Pl=clearInterval(Pl))):(Pl||(Il=Vl.now(),Pl=setInterval(Zl,1e3)),jl=1,Xl(Gl)))}function Ql(t,e,n){var r=new Kl;return e=null==e?0:+e,r.restart((n=>{r.stop(),t(n+e)}),e,n),r}Kl.prototype=Ul.prototype={constructor:Kl,restart:function(t,e,n){if("function"!=typeof t)throw new TypeError("callback is not a function");n=(null==n?Wl():+n)+(null==e?0:+e),this._next||Bl===this||(Bl?Bl._next=this:Rl=this,Bl=this),this._call=t,this._time=n,Jl()},stop:function(){this._call&&(this._call=null,this._time=1/0,Jl())}};var ta=Nl("start","end","cancel","interrupt"),ea=[];function na(t,e,n,r,i,o){var l=t.__transition;if(l){if(n in l)return}else t.__transition={};!function(t,e,n){var r,i=t.__transition;function o(s){var c,u,h,d;if(1!==n.state)return a();for(c in i)if((d=i[c]).name===n.name){if(3===d.state)return Ql(o);4===d.state?(d.state=6,d.timer.stop(),d.on.call("interrupt",t,t.__data__,d.index,d.group),delete i[c]):+c<e&&(d.state=6,d.timer.stop(),d.on.call("cancel",t,t.__data__,d.index,d.group),delete i[c])}if(Ql((function(){3===n.state&&(n.state=4,n.timer.restart(l,n.delay,n.time),l(s))})),n.state=2,n.on.call("start",t,t.__data__,n.index,n.group),2===n.state){for(n.state=3,r=new Array(h=n.tween.length),c=0,u=-1;c<h;++c)(d=n.tween[c].value.call(t,t.__data__,n.index,n.group))&&(r[++u]=d);r.length=u+1}}function l(e){for(var i=e<n.duration?n.ease.call(null,e/n.duration):(n.timer.restart(a),n.state=5,1),o=-1,l=r.length;++o<l;)r[o].call(t,i);5===n.state&&(n.on.call("end",t,t.__data__,n.index,n.group),a())}function a(){for(var r in n.state=6,n.timer.stop(),delete i[e],i)return;delete t.__transition}i[e]=n,n.timer=Ul((function(t){n.state=1,n.timer.restart(o,n.delay,n.time),n.delay<=t&&o(t-n.delay)}),0,n.time)}(t,n,{name:e,index:r,group:i,on:ta,tween:ea,time:o.time,delay:o.delay,duration:o.duration,ease:o.ease,timer:null,state:0})}function ra(t,e){var n=oa(t,e);if(n.state>0)throw new Error("too late; already scheduled");return n}function ia(t,e){var n=oa(t,e);if(n.state>3)throw new Error("too late; already running");return n}function oa(t,e){var n=t.__transition;if(!n||!(n=n[e]))throw new Error("transition not found");return n}function la(t,e){var n,r,i,o=t.__transition,l=!0;if(o){for(i in e=null==e?null:e+"",o)(n=o[i]).name===e?(r=n.state>2&&n.state<5,n.state=6,n.timer.stop(),n.on.call(r?"interrupt":"cancel",t,t.__data__,n.index,n.group),delete o[i]):l=!1;l&&delete t.__transition}}var aa,sa=180/Math.PI,ca={translateX:0,translateY:0,rotate:0,skewX:0,scaleX:1,scaleY:1};function ua(t,e,n,r,i,o){var l,a,s;return(l=Math.sqrt(t*t+e*e))&&(t/=l,e/=l),(s=t*n+e*r)&&(n-=t*s,r-=e*s),(a=Math.sqrt(n*n+r*r))&&(n/=a,r/=a,s/=a),t*r<e*n&&(t=-t,e=-e,s=-s,l=-l),{translateX:i,translateY:o,rotate:Math.atan2(e,t)*sa,skewX:Math.atan(s)*sa,scaleX:l,scaleY:a}}function ha(t,e,n,r){function i(t){return t.length?t.pop()+" ":""}return function(o,l){var a=[],s=[];return o=t(o),l=t(l),function(t,r,i,o,l,a){if(t!==i||r!==o){var s=l.push("translate(",null,e,null,n);a.push({i:s-4,x:se(t,i)},{i:s-2,x:se(r,o)})}else(i||o)&&l.push("translate("+i+e+o+n)}(o.translateX,o.translateY,l.translateX,l.translateY,a,s),function(t,e,n,o){t!==e?(t-e>180?e+=360:e-t>180&&(t+=360),o.push({i:n.push(i(n)+"rotate(",null,r)-2,x:se(t,e)})):e&&n.push(i(n)+"rotate("+e+r)}(o.rotate,l.rotate,a,s),function(t,e,n,o){t!==e?o.push({i:n.push(i(n)+"skewX(",null,r)-2,x:se(t,e)}):e&&n.push(i(n)+"skewX("+e+r)}(o.skewX,l.skewX,a,s),function(t,e,n,r,o,l){if(t!==n||e!==r){var a=o.push(i(o)+"scale(",null,",",null,")");l.push({i:a-4,x:se(t,n)},{i:a-2,x:se(e,r)})}else 1===n&&1===r||o.push(i(o)+"scale("+n+","+r+")")}(o.scaleX,o.scaleY,l.scaleX,l.scaleY,a,s),o=l=null,function(t){for(var e,n=-1,r=s.length;++n<r;)a[(e=s[n]).i]=e.x(t);return a.join("")}}}var da=ha((function(t){const e=new("function"==typeof DOMMatrix?DOMMatrix:WebKitCSSMatrix)(t+"");return e.isIdentity?ca:ua(e.a,e.b,e.c,e.d,e.e,e.f)}),"px, ","px)","deg)"),fa=ha((function(t){return null==t?ca:(aa||(aa=document.createElementNS("http://www.w3.org/2000/svg","g")),aa.setAttribute("transform",t),(t=aa.transform.baseVal.consolidate())?ua((t=t.matrix).a,t.b,t.c,t.d,t.e,t.f):ca)}),", ",")",")");function pa(t,e){var n,r;return function(){var i=ia(this,t),o=i.tween;if(o!==n)for(var l=0,a=(r=n=o).length;l<a;++l)if(r[l].name===e){(r=r.slice()).splice(l,1);break}i.tween=r}}function ga(t,e,n){var r,i;if("function"!=typeof n)throw new Error;return function(){var o=ia(this,t),l=o.tween;if(l!==r){i=(r=l).slice();for(var a={name:e,value:n},s=0,c=i.length;s<c;++s)if(i[s].name===e){i[s]=a;break}s===c&&i.push(a)}o.tween=i}}function ma(t,e,n){var r=t._id;return t.each((function(){var t=ia(this,r);(t.value||(t.value={}))[e]=n.apply(this,arguments)})),function(t){return oa(t,r).value[e]}}function va(t,e){var n;return("number"==typeof e?se:e instanceof Bt?re:(n=Bt(e))?(e=n,re):de)(t,e)}function ya(t){return function(){this.removeAttribute(t)}}function wa(t){return function(){this.removeAttributeNS(t.space,t.local)}}function ba(t,e,n){var r,i,o=n+"";return function(){var l=this.getAttribute(t);return l===o?null:l===r?i:i=e(r=l,n)}}function $a(t,e,n){var r,i,o=n+"";return function(){var l=this.getAttributeNS(t.space,t.local);return l===o?null:l===r?i:i=e(r=l,n)}}function xa(t,e,n){var r,i,o;return function(){var l,a,s=n(this);if(null!=s)return(l=this.getAttribute(t))===(a=s+"")?null:l===r&&a===i?o:(i=a,o=e(r=l,s));this.removeAttribute(t)}}function _a(t,e,n){var r,i,o;return function(){var l,a,s=n(this);if(null!=s)return(l=this.getAttributeNS(t.space,t.local))===(a=s+"")?null:l===r&&a===i?o:(i=a,o=e(r=l,s));this.removeAttributeNS(t.space,t.local)}}function ka(t,e){return function(n){this.setAttribute(t,e.call(this,n))}}function Ma(t,e){return function(n){this.setAttributeNS(t.space,t.local,e.call(this,n))}}function La(t,e){var n,r;function i(){var i=e.apply(this,arguments);return i!==r&&(n=(r=i)&&Ma(t,i)),n}return i._value=e,i}function Aa(t,e){var n,r;function i(){var i=e.apply(this,arguments);return i!==r&&(n=(r=i)&&ka(t,i)),n}return i._value=e,i}function za(t,e){return function(){ra(this,t).delay=+e.apply(this,arguments)}}function Sa(t,e){return e=+e,function(){ra(this,t).delay=e}}function Na(t,e){return function(){ia(this,t).duration=+e.apply(this,arguments)}}function Ca(t,e){return e=+e,function(){ia(this,t).duration=e}}function Ta(t,e){if("function"!=typeof e)throw new Error;return function(){ia(this,t).ease=e}}function Oa(t,e,n){var r,i,o=function(t){return(t+"").trim().split(/^|\s+/).every((function(t){var e=t.indexOf(".");return e>=0&&(t=t.slice(0,e)),!t||"start"===t}))}(e)?ra:ia;return function(){var l=o(this,t),a=l.on;a!==r&&(i=(r=a).copy()).on(e,n),l.on=i}}var Ea=xl.prototype.constructor;function Da(t){return function(){this.style.removeProperty(t)}}function Ra(t,e,n){return function(r){this.style.setProperty(t,e.call(this,r),n)}}function Ba(t,e,n){var r,i;function o(){var o=e.apply(this,arguments);return o!==i&&(r=(i=o)&&Ra(t,o,n)),r}return o._value=e,o}function ja(t){return function(e){this.textContent=t.call(this,e)}}function qa(t){var e,n;function r(){var r=t.apply(this,arguments);return r!==n&&(e=(n=r)&&ja(r)),e}return r._value=t,r}var Pa=0;function Ia(t,e,n,r){this._groups=t,this._parents=e,this._name=n,this._id=r}function Ha(){return++Pa}var Fa=xl.prototype;Ia.prototype=function(t){return xl().transition(t)}.prototype={constructor:Ia,select:function(t){var e=this._name,n=this._id;"function"!=typeof t&&(t=so(t));for(var r=this._groups,i=r.length,o=new Array(i),l=0;l<i;++l)for(var a,s,c=r[l],u=c.length,h=o[l]=new Array(u),d=0;d<u;++d)(a=c[d])&&(s=t.call(a,a.__data__,d,c))&&("__data__"in a&&(s.__data__=a.__data__),h[d]=s,na(h[d],e,n,d,h,oa(a,n)));return new Ia(o,this._parents,e,n)},selectAll:function(t){var e=this._name,n=this._id;"function"!=typeof t&&(t=ho(t));for(var r=this._groups,i=r.length,o=[],l=[],a=0;a<i;++a)for(var s,c=r[a],u=c.length,h=0;h<u;++h)if(s=c[h]){for(var d,f=t.call(s,s.__data__,h,c),p=oa(s,n),g=0,m=f.length;g<m;++g)(d=f[g])&&na(d,e,n,g,f,p);o.push(f),l.push(s)}return new Ia(o,l,e,n)},selectChild:Fa.selectChild,selectChildren:Fa.selectChildren,filter:function(t){"function"!=typeof t&&(t=fo(t));for(var e=this._groups,n=e.length,r=new Array(n),i=0;i<n;++i)for(var o,l=e[i],a=l.length,s=r[i]=[],c=0;c<a;++c)(o=l[c])&&t.call(o,o.__data__,c,l)&&s.push(o);return new Ia(r,this._parents,this._name,this._id)},merge:function(t){if(t._id!==this._id)throw new Error;for(var e=this._groups,n=t._groups,r=e.length,i=n.length,o=Math.min(r,i),l=new Array(r),a=0;a<o;++a)for(var s,c=e[a],u=n[a],h=c.length,d=l[a]=new Array(h),f=0;f<h;++f)(s=c[f]||u[f])&&(d[f]=s);for(;a<r;++a)l[a]=e[a];return new Ia(l,this._parents,this._name,this._id)},selection:function(){return new Ea(this._groups,this._parents)},transition:function(){for(var t=this._name,e=this._id,n=Ha(),r=this._groups,i=r.length,o=0;o<i;++o)for(var l,a=r[o],s=a.length,c=0;c<s;++c)if(l=a[c]){var u=oa(l,e);na(l,t,n,c,a,{time:u.time+u.delay+u.duration,delay:0,duration:u.duration,ease:u.ease})}return new Ia(r,this._parents,t,n)},call:Fa.call,nodes:Fa.nodes,node:Fa.node,size:Fa.size,empty:Fa.empty,each:Fa.each,on:function(t,e){var n=this._id;return arguments.length<2?oa(this.node(),n).on.on(t):this.each(Oa(n,t,e))},attr:function(t,e){var n=So(t),r="transform"===n?fa:va;return this.attrTween(t,"function"==typeof e?(n.local?_a:xa)(n,r,ma(this,"attr."+t,e)):null==e?(n.local?wa:ya)(n):(n.local?$a:ba)(n,r,e))},attrTween:function(t,e){var n="attr."+t;if(arguments.length<2)return(n=this.tween(n))&&n._value;if(null==e)return this.tween(n,null);if("function"!=typeof e)throw new Error;var r=So(t);return this.tween(n,(r.local?La:Aa)(r,e))},style:function(t,e,n){var r="transform"==(t+="")?da:va;return null==e?this.styleTween(t,function(t,e){var n,r,i;return function(){var o=Po(this,t),l=(this.style.removeProperty(t),Po(this,t));return o===l?null:o===n&&l===r?i:i=e(n=o,r=l)}}(t,r)).on("end.style."+t,Da(t)):"function"==typeof e?this.styleTween(t,function(t,e,n){var r,i,o;return function(){var l=Po(this,t),a=n(this),s=a+"";return null==a&&(this.style.removeProperty(t),s=a=Po(this,t)),l===s?null:l===r&&s===i?o:(i=s,o=e(r=l,a))}}(t,r,ma(this,"style."+t,e))).each(function(t,e){var n,r,i,o,l="style."+e,a="end."+l;return function(){var s=ia(this,t),c=s.on,u=null==s.value[l]?o||(o=Da(e)):void 0;c===n&&i===u||(r=(n=c).copy()).on(a,i=u),s.on=r}}(this._id,t)):this.styleTween(t,function(t,e,n){var r,i,o=n+"";return function(){var l=Po(this,t);return l===o?null:l===r?i:i=e(r=l,n)}}(t,r,e),n).on("end.style."+t,null)},styleTween:function(t,e,n){var r="style."+(t+="");if(arguments.length<2)return(r=this.tween(r))&&r._value;if(null==e)return this.tween(r,null);if("function"!=typeof e)throw new Error;return this.tween(r,Ba(t,e,null==n?"":n))},text:function(t){return this.tween("text","function"==typeof t?function(t){return function(){var e=t(this);this.textContent=null==e?"":e}}(ma(this,"text",t)):function(t){return function(){this.textContent=t}}(null==t?"":t+""))},textTween:function(t){var e="text";if(arguments.length<1)return(e=this.tween(e))&&e._value;if(null==t)return this.tween(e,null);if("function"!=typeof t)throw new Error;return this.tween(e,qa(t))},remove:function(){return this.on("end.remove",function(t){return function(){var e=this.parentNode;for(var n in this.__transition)if(+n!==t)return;e&&e.removeChild(this)}}(this._id))},tween:function(t,e){var n=this._id;if(t+="",arguments.length<2){for(var r,i=oa(this.node(),n).tween,o=0,l=i.length;o<l;++o)if((r=i[o]).name===t)return r.value;return null}return this.each((null==e?pa:ga)(n,t,e))},delay:function(t){var e=this._id;return arguments.length?this.each(("function"==typeof t?za:Sa)(e,t)):oa(this.node(),e).delay},duration:function(t){var e=this._id;return arguments.length?this.each(("function"==typeof t?Na:Ca)(e,t)):oa(this.node(),e).duration},ease:function(t){var e=this._id;return arguments.length?this.each(Ta(e,t)):oa(this.node(),e).ease},easeVarying:function(t){if("function"!=typeof t)throw new Error;return this.each(function(t,e){return function(){var n=e.apply(this,arguments);if("function"!=typeof n)throw new Error;ia(this,t).ease=n}}(this._id,t))},end:function(){var t,e,n=this,r=n._id,i=n.size();return new Promise((function(o,l){var a={value:l},s={value:function(){0==--i&&o()}};n.each((function(){var n=ia(this,r),i=n.on;i!==t&&((e=(t=i).copy())._.cancel.push(a),e._.interrupt.push(a),e._.end.push(s)),n.on=e})),0===i&&o()}))},[Symbol.iterator]:Fa[Symbol.iterator]};var Va={time:null,delay:0,duration:250,ease:function(t){return((t*=2)<=1?t*t*t:(t-=2)*t*t+2)/2}};function Xa(t,e){for(var n;!(n=t.__transition)||!(n=n[e]);)if(!(t=t.parentNode))throw new Error(`transition ${e} not found`);return n}xl.prototype.interrupt=function(t){return this.each((function(){la(this,t)}))},xl.prototype.transition=function(t){var e,n;t instanceof Ia?(e=t._id,t=t._name):(e=Ha(),(n=Va).time=Wl(),t=null==t?null:t+"");for(var r=this._groups,i=r.length,o=0;o<i;++o)for(var l,a=r[o],s=a.length,c=0;c<s;++c)(l=a[c])&&na(l,t,e,c,a,n||Xa(l,e));return new Ia(r,this._parents,t,e)};const Wa=t=>()=>t;function Ya(t,{sourceEvent:e,target:n,selection:r,mode:i,dispatch:o}){Object.defineProperties(this,{type:{value:t,enumerable:!0,configurable:!0},sourceEvent:{value:e,enumerable:!0,configurable:!0},target:{value:n,enumerable:!0,configurable:!0},selection:{value:r,enumerable:!0,configurable:!0},mode:{value:i,enumerable:!0,configurable:!0},_:{value:o}})}function Ka(t){t.stopImmediatePropagation()}function Ua(t){t.preventDefault(),t.stopImmediatePropagation()}var Ga={name:"drag"},Za={name:"space"},Ja={name:"handle"},Qa={name:"center"};const{abs:ts,max:es,min:ns}=Math;function rs(t){return[+t[0],+t[1]]}function is(t){return[rs(t[0]),rs(t[1])]}var os={name:"x",handles:["w","e"].map(fs),input:function(t,e){return null==t?null:[[+t[0],e[0][1]],[+t[1],e[1][1]]]},output:function(t){return t&&[t[0][0],t[1][0]]}},ls={name:"y",handles:["n","s"].map(fs),input:function(t,e){return null==t?null:[[e[0][0],+t[0]],[e[1][0],+t[1]]]},output:function(t){return t&&[t[0][1],t[1][1]]}},as={name:"xy",handles:["n","w","e","s","nw","ne","sw","se"].map(fs),input:function(t){return null==t?null:is(t)},output:function(t){return t}},ss={overlay:"crosshair",selection:"move",n:"ns-resize",e:"ew-resize",s:"ns-resize",w:"ew-resize",nw:"nwse-resize",ne:"nesw-resize",se:"nwse-resize",sw:"nesw-resize"},cs={e:"w",w:"e",nw:"ne",ne:"nw",se:"sw",sw:"se"},us={n:"s",s:"n",nw:"sw",ne:"se",se:"ne",sw:"nw"},hs={overlay:1,selection:1,n:null,e:1,s:null,w:-1,nw:-1,ne:1,se:1,sw:-1},ds={overlay:1,selection:1,n:-1,e:null,s:1,w:null,nw:-1,ne:-1,se:1,sw:1};function fs(t){return{type:t}}function ps(t){return!t.ctrlKey&&!t.button}function gs(){var t=this.ownerSVGElement||this;return t.hasAttribute("viewBox")?[[(t=t.viewBox.baseVal).x,t.y],[t.x+t.width,t.y+t.height]]:[[0,0],[t.width.baseVal.value,t.height.baseVal.value]]}function ms(){return navigator.maxTouchPoints||"ontouchstart"in this}function vs(t){for(;!t.__brush;)if(!(t=t.parentNode))return;return t.__brush}function ys(t){return t[0][0]===t[1][0]||t[0][1]===t[1][1]}function ws(){return $s(os)}function bs(){return $s(as)}function $s(t){var e,n=gs,r=ps,i=ms,o=!0,l=Nl("start","brush","end"),a=6;function s(e){var n=e.property("__brush",g).selectAll(".overlay").data([fs("overlay")]);n.enter().append("rect").attr("class","overlay").attr("pointer-events","all").attr("cursor",ss.overlay).merge(n).each((function(){var t=vs(this).extent;_l(this).attr("x",t[0][0]).attr("y",t[0][1]).attr("width",t[1][0]-t[0][0]).attr("height",t[1][1]-t[0][1])})),e.selectAll(".selection").data([fs("selection")]).enter().append("rect").attr("class","selection").attr("cursor",ss.selection).attr("fill","#777").attr("fill-opacity",.3).attr("stroke","#fff").attr("shape-rendering","crispEdges");var r=e.selectAll(".handle").data(t.handles,(function(t){return t.type}));r.exit().remove(),r.enter().append("rect").attr("class",(function(t){return"handle handle--"+t.type})).attr("cursor",(function(t){return ss[t.type]})),e.each(c).attr("fill","none").attr("pointer-events","all").on("mousedown.brush",d).filter(i).on("touchstart.brush",d).on("touchmove.brush",f).on("touchend.brush touchcancel.brush",p).style("touch-action","none").style("-webkit-tap-highlight-color","rgba(0,0,0,0)")}function c(){var t=_l(this),e=vs(this).selection;e?(t.selectAll(".selection").style("display",null).attr("x",e[0][0]).attr("y",e[0][1]).attr("width",e[1][0]-e[0][0]).attr("height",e[1][1]-e[0][1]),t.selectAll(".handle").style("display",null).attr("x",(function(t){return"e"===t.type[t.type.length-1]?e[1][0]-a/2:e[0][0]-a/2})).attr("y",(function(t){return"s"===t.type[0]?e[1][1]-a/2:e[0][1]-a/2})).attr("width",(function(t){return"n"===t.type||"s"===t.type?e[1][0]-e[0][0]+a:a})).attr("height",(function(t){return"e"===t.type||"w"===t.type?e[1][1]-e[0][1]+a:a}))):t.selectAll(".selection,.handle").style("display","none").attr("x",null).attr("y",null).attr("width",null).attr("height",null)}function u(t,e,n){var r=t.__brush.emitter;return!r||n&&r.clean?new h(t,e,n):r}function h(t,e,n){this.that=t,this.args=e,this.state=t.__brush,this.active=0,this.clean=n}function d(n){if((!e||n.touches)&&r.apply(this,arguments)){var i,l,a,s,h,d,f,p,g,m,v,y=this,w=n.target.__data__.type,b="selection"===(o&&n.metaKey?w="overlay":w)?Ga:o&&n.altKey?Qa:Ja,$=t===ls?null:hs[w],x=t===os?null:ds[w],_=vs(y),k=_.extent,M=_.selection,L=k[0][0],A=k[0][1],z=k[1][0],S=k[1][1],N=0,C=0,T=$&&x&&o&&n.shiftKey,O=Array.from(n.touches||[n],(t=>{const e=t.identifier;return(t=Dl(t,y)).point0=t.slice(),t.identifier=e,t}));la(y);var E=u(y,arguments,!0).beforestart();if("overlay"===w){M&&(g=!0);const e=[O[0],O[1]||O[0]];_.selection=M=[[i=t===ls?L:ns(e[0][0],e[1][0]),a=t===os?A:ns(e[0][1],e[1][1])],[h=t===ls?z:es(e[0][0],e[1][0]),f=t===os?S:es(e[0][1],e[1][1])]],O.length>1&&q(n)}else i=M[0][0],a=M[0][1],h=M[1][0],f=M[1][1];l=i,s=a,d=h,p=f;var D=_l(y).attr("pointer-events","none"),R=D.selectAll(".overlay").attr("cursor",ss[w]);if(n.touches)E.moved=j,E.ended=P;else{var B=_l(n.view).on("mousemove.brush",j,!0).on("mouseup.brush",P,!0);o&&B.on("keydown.brush",I,!0).on("keyup.brush",H,!0),Ol(n.view)}c.call(y),E.start(n,b.name)}function j(t){for(const e of t.changedTouches||[t])for(const t of O)t.identifier===e.identifier&&(t.cur=Dl(e,y));if(T&&!m&&!v&&1===O.length){const t=O[0];ts(t.cur[0]-t[0])>ts(t.cur[1]-t[1])?v=!0:m=!0}for(const t of O)t.cur&&(t[0]=t.cur[0],t[1]=t.cur[1]);g=!0,Ua(t),q(t)}function q(t){const e=O[0],n=e.point0;var r;switch(N=e[0]-n[0],C=e[1]-n[1],b){case Za:case Ga:$&&(N=es(L-i,ns(z-h,N)),l=i+N,d=h+N),x&&(C=es(A-a,ns(S-f,C)),s=a+C,p=f+C);break;case Ja:O[1]?($&&(l=es(L,ns(z,O[0][0])),d=es(L,ns(z,O[1][0])),$=1),x&&(s=es(A,ns(S,O[0][1])),p=es(A,ns(S,O[1][1])),x=1)):($<0?(N=es(L-i,ns(z-i,N)),l=i+N,d=h):$>0&&(N=es(L-h,ns(z-h,N)),l=i,d=h+N),x<0?(C=es(A-a,ns(S-a,C)),s=a+C,p=f):x>0&&(C=es(A-f,ns(S-f,C)),s=a,p=f+C));break;case Qa:$&&(l=es(L,ns(z,i-N*$)),d=es(L,ns(z,h+N*$))),x&&(s=es(A,ns(S,a-C*x)),p=es(A,ns(S,f+C*x)))}d<l&&($*=-1,r=i,i=h,h=r,r=l,l=d,d=r,w in cs&&R.attr("cursor",ss[w=cs[w]])),p<s&&(x*=-1,r=a,a=f,f=r,r=s,s=p,p=r,w in us&&R.attr("cursor",ss[w=us[w]])),_.selection&&(M=_.selection),m&&(l=M[0][0],d=M[1][0]),v&&(s=M[0][1],p=M[1][1]),M[0][0]===l&&M[0][1]===s&&M[1][0]===d&&M[1][1]===p||(_.selection=[[l,s],[d,p]],c.call(y),E.brush(t,b.name))}function P(t){if(Ka(t),t.touches){if(t.touches.length)return;e&&clearTimeout(e),e=setTimeout((function(){e=null}),500)}else El(t.view,g),B.on("keydown.brush keyup.brush mousemove.brush mouseup.brush",null);D.attr("pointer-events","all"),R.attr("cursor",ss.overlay),_.selection&&(M=_.selection),ys(M)&&(_.selection=null,c.call(y)),E.end(t,b.name)}function I(t){switch(t.keyCode){case 16:T=$&&x;break;case 18:b===Ja&&($&&(h=d-N*$,i=l+N*$),x&&(f=p-C*x,a=s+C*x),b=Qa,q(t));break;case 32:b!==Ja&&b!==Qa||($<0?h=d-N:$>0&&(i=l-N),x<0?f=p-C:x>0&&(a=s-C),b=Za,R.attr("cursor",ss.selection),q(t));break;default:return}Ua(t)}function H(t){switch(t.keyCode){case 16:T&&(m=v=T=!1,q(t));break;case 18:b===Qa&&($<0?h=d:$>0&&(i=l),x<0?f=p:x>0&&(a=s),b=Ja,q(t));break;case 32:b===Za&&(t.altKey?($&&(h=d-N*$,i=l+N*$),x&&(f=p-C*x,a=s+C*x),b=Qa):($<0?h=d:$>0&&(i=l),x<0?f=p:x>0&&(a=s),b=Ja),R.attr("cursor",ss[w]),q(t));break;default:return}Ua(t)}}function f(t){u(this,arguments).moved(t)}function p(t){u(this,arguments).ended(t)}function g(){var e=this.__brush||{selection:null};return e.extent=is(n.apply(this,arguments)),e.dim=t,e}return s.move=function(e,n,r){e.tween?e.on("start.brush",(function(t){u(this,arguments).beforestart().start(t)})).on("interrupt.brush end.brush",(function(t){u(this,arguments).end(t)})).tween("brush",(function(){var e=this,r=e.__brush,i=u(e,arguments),o=r.selection,l=t.input("function"==typeof n?n.apply(this,arguments):n,r.extent),a=pe(o,l);function s(t){r.selection=1===t&&null===l?null:a(t),c.call(e),i.brush()}return null!==o&&null!==l?s:s(1)})):e.each((function(){var e=this,i=arguments,o=e.__brush,l=t.input("function"==typeof n?n.apply(e,i):n,o.extent),a=u(e,i).beforestart();la(e),o.selection=null===l?null:l,c.call(e),a.start(r).brush(r).end(r)}))},s.clear=function(t,e){s.move(t,null,e)},h.prototype={beforestart:function(){return 1==++this.active&&(this.state.emitter=this,this.starting=!0),this},start:function(t,e){return this.starting?(this.starting=!1,this.emit("start",t,e)):this.emit("brush",t),this},brush:function(t,e){return this.emit("brush",t,e),this},end:function(t,e){return 0==--this.active&&(delete this.state.emitter,this.emit("end",t,e)),this},emit:function(e,n,r){var i=_l(this.that).datum();l.call(e,this.that,new Ya(e,{sourceEvent:n,target:s,selection:t.output(this.state.selection),mode:r,dispatch:l}),i)}},s.extent=function(t){return arguments.length?(n="function"==typeof t?t:Wa(is(t)),s):n},s.filter=function(t){return arguments.length?(r="function"==typeof t?t:Wa(!!t),s):r},s.touchable=function(t){return arguments.length?(i="function"==typeof t?t:Wa(!!t),s):i},s.handleSize=function(t){return arguments.length?(a=+t,s):a},s.keyModifiers=function(t){return arguments.length?(o=!!t,s):o},s.on=function(){var t=l.on.apply(l,arguments);return t===l?s:t},s}function xs(t){b(t,"svelte-1sazhg0","div.svelte-1sazhg0{position:relative;width:100%;height:100%}svg.svelte-1sazhg0,canvas.svelte-1sazhg0{position:absolute;top:0;left:0}")}function _s(t){let e,n,r,i;const o=[Ls,Ms],l=[];function a(t,e){return"bandwidth"in t[9]?0:1}return e=a(t),n=l[e]=o[e](t),{c(){n.c(),r=z()},m(t,n){l[e].m(t,n),$(t,r,n),i=!0},p(t,i){let s=e;e=a(t),e===s?l[e].p(t,i):(rt(),lt(l[s],1,1,(()=>{l[s]=null})),it(),n=l[e],n?n.p(t,i):(n=l[e]=o[e](t),n.c()),ot(n,1),n.m(r.parentNode,r))},i(t){i||(ot(n),i=!0)},o(t){lt(n),i=!1},d(t){l[e].d(t),t&&x(r)}}}function ks(t){let e,n,r,i;const o=[zs,As],l=[];function a(t,e){return"bandwidth"in t[9]?0:1}return e=a(t),n=l[e]=o[e](t),{c(){n.c(),r=z()},m(t,n){l[e].m(t,n),$(t,r,n),i=!0},p(t,i){let s=e;e=a(t),e===s?l[e].p(t,i):(rt(),lt(l[s],1,1,(()=>{l[s]=null})),it(),n=l[e],n?n.p(t,i):(n=l[e]=o[e](t),n.c()),ot(n,1),n.m(r.parentNode,r))},i(t){i||(ot(n),i=!0)},o(t){lt(n),i=!1},d(t){l[e].d(t),t&&x(r)}}}function Ms(t){let e,n;return e=new wi({props:{data:t[11].distribution,fill:"var(--gray-3)",x:t[9],height:t[7].top,direction:"horizontal"}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};2048&n[0]&&(r.data=t[11].distribution),512&n[0]&&(r.x=t[9]),128&n[0]&&(r.height=t[7].top),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Ls(t){let e,n;return e=new zi({props:{data:t[11].distribution,fill:"var(--gray-3)",x:t[9],height:t[7].top,direction:"horizontal"}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};2048&n[0]&&(r.data=t[11].distribution),512&n[0]&&(r.x=t[9]),128&n[0]&&(r.height=t[7].top),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function As(t){let e,n;return e=new wi({props:{data:t[13],fill:"red",x:t[9],height:t[7].top,direction:"horizontal"}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};8192&n[0]&&(r.data=t[13]),512&n[0]&&(r.x=t[9]),128&n[0]&&(r.height=t[7].top),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function zs(t){let e,n;return e=new zi({props:{data:t[13],fill:"red",x:t[9],height:t[7].top,direction:"horizontal"}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};8192&n[0]&&(r.data=t[13]),512&n[0]&&(r.x=t[9]),128&n[0]&&(r.height=t[7].top),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Ss(t){let e,n,r,i,o,l,a,s,c,u;l=new Kr({props:{scale:t[9],y:t[10]-t[7].bottom,label:t[0].x_feature,integerOnly:"discrete"===t[11].subkind,value_map:"value_map"in t[11]?t[11].value_map:{}}}),a=new ui({props:{scale:t[8],x:t[7].left,label:"prediction"}});const h=[ks,_s],d=[];function f(t,e){return t[4]&&t[13]&&t[12].length>0?0:t[3]?1:-1}return~(s=f(t))&&(c=d[s]=h[s](t)),{c(){e=k("div"),n=k("canvas"),r=A(),i=M("svg"),o=M("g"),ht(l.$$.fragment),ht(a.$$.fragment),c&&c.c(),N(n,"class","svelte-1sazhg0"),N(i,"width",t[1]),N(i,"height",t[2]),N(i,"class","svelte-1sazhg0"),N(e,"class","svelte-1sazhg0")},m(c,h){$(c,e,h),w(e,n),t[33](n),w(e,r),w(e,i),w(i,o),dt(l,o,null),dt(a,o,null),~s&&d[s].m(o,null),t[34](o),u=!0},p(t,e){const n={};512&e[0]&&(n.scale=t[9]),1152&e[0]&&(n.y=t[10]-t[7].bottom),1&e[0]&&(n.label=t[0].x_feature),2048&e[0]&&(n.integerOnly="discrete"===t[11].subkind),2048&e[0]&&(n.value_map="value_map"in t[11]?t[11].value_map:{}),l.$set(n);const r={};256&e[0]&&(r.scale=t[8]),128&e[0]&&(r.x=t[7].left),a.$set(r);let p=s;s=f(t),s===p?~s&&d[s].p(t,e):(c&&(rt(),lt(d[p],1,1,(()=>{d[p]=null})),it()),~s?(c=d[s],c?c.p(t,e):(c=d[s]=h[s](t),c.c()),ot(c,1),c.m(o,null)):c=null),(!u||2&e[0])&&N(i,"width",t[1]),(!u||4&e[0])&&N(i,"height",t[2])},i(t){u||(ot(l.$$.fragment,t),ot(a.$$.fragment,t),ot(c),u=!0)},o(t){lt(l.$$.fragment,t),lt(a.$$.fragment,t),lt(c),u=!1},d(n){n&&x(e),t[33](null),ft(l),ft(a),~s&&d[s].d(),t[34](null)}}}function Ns(t,e,n){let r,i,o,l,a,s,c,u,h,d,f,g,v,y,w,b,$,x;p(t,Zn,(t=>n(26,f=t))),p(t,Yn,(t=>n(27,g=t))),p(t,Hn,(t=>n(12,v=t))),p(t,Pn,(t=>n(28,y=t))),p(t,qn,(t=>n(29,w=t))),p(t,jn,(t=>n(30,b=t))),p(t,Bn,(t=>n(31,$=t))),p(t,Nn,(t=>n(32,x=t)));let _,k,{pd:M}=e,{width:L}=e,{height:A}=e,{scaleLocally:z}=e,{showMarginalDistribution:S}=e,{marginTop:N}=e,{marginRight:C}=e,{allowBrushing:T=!1}=e;function O(t,e,n,r,i,o,l,a,s,c){var u;if(null!=e&&null!=n){if(e.save(),e.clearRect(0,0,s,c),e.lineWidth=.5,e.strokeStyle="rgb(198, 198, 198)",e.globalAlpha=.15,t.ice.ice_lines.forEach((t=>{e.beginPath(),n(t),e.stroke()})),a&&(e.strokeStyle="red",e.globalAlpha=.15,r.forEach((r=>{e.beginPath(),n(t.ice.ice_lines[r]),e.stroke()}))),e.lineWidth=2,e.strokeStyle="black",e.globalAlpha=1,e.beginPath(),n(t.mean_predictions),e.stroke(),"step"in i)for(let n=0;n<t.x_values.length;n++){const r=null!==(u=i(t.x_values[n]))&&void 0!==u?u:0,a=o(t.mean_predictions[n]);e.beginPath(),e.arc(r,a,l,0,2*Math.PI),e.fill()}e.restore()}}P((()=>{n(17,k=_.getContext("2d"))}));let E,D,R,B=!1,j=!1;function q(t){n(18,B=!0),m(Yn,g=!0,g),n(19,j=!0)}function I({selection:t}){if(!t)return void m(Hn,v=[],v);const[[e,n],[r,i]]=t,o=M.x_values.map((t=>{var e;return null!==(e=a(t))&&void 0!==e?e:0}));m(Hn,v=M.ice.ice_lines.map(((t,e)=>({lines:t,index:e}))).filter((({lines:t})=>t.some(((t,l)=>{const a=c(t),s=o[l];return s>=e&&s<=r&&a>=n&&a<=i})))).map((({index:t})=>t)),v)}function H({selection:t}){null===t&&(n(18,B=!1),m(Hn,v=[],v)),m(Yn,g=!1,g),n(19,j=!1)}return t.$$set=t=>{"pd"in t&&n(0,M=t.pd),"width"in t&&n(1,L=t.width),"height"in t&&n(2,A=t.height),"scaleLocally"in t&&n(14,z=t.scaleLocally),"showMarginalDistribution"in t&&n(3,S=t.showMarginalDistribution),"marginTop"in t&&n(15,N=t.marginTop),"marginRight"in t&&n(16,C=t.marginRight),"allowBrushing"in t&&n(4,T=t.allowBrushing)},t.$$.update=()=>{1&t.$$.dirty[0]|2&t.$$.dirty[1]&&n(11,r=x[M.x_feature]),98304&t.$$.dirty[0]&&n(7,i={top:N,right:C,bottom:35,left:50}),4&t.$$.dirty[0]&&n(10,o=A),1025&t.$$.dirty[0]&&n(25,l=o/M.ice.clusters.length),2179&t.$$.dirty[0]&&n(9,a="quantitative"===r.kind?tn().domain([M.x_values[0],M.x_values[M.x_values.length-1]]).range([i.left,L-i.right]):cr().domain(M.x_values).range([i.left,L-i.right]).padding(.5)),512&t.$$.dirty[0]&&n(23,s="step"in a?Math.min(3,a.step()/2-1):0),1912620161&t.$$.dirty[0]|1&t.$$.dirty[1]&&n(8,c=_n(M,o,l,"lines",z,$,b,w,y,i)),131841&t.$$.dirty[0]&&n(24,u=_r().x(((t,e)=>{var n;return null!==(n=a(M.x_values[e]))&&void 0!==n?n:0})).y((t=>c(t))).context(k)),4112&t.$$.dirty[0]&&n(22,h=T&&v.length>0),131110&t.$$.dirty[0]&&k&&($n(_,k,L,A),O(M,k,u,v,a,c,s,h,L,A)),29496071&t.$$.dirty[0]&&O(M,k,u,v,a,c,s,h,L,A),134&t.$$.dirty[0]&&n(21,d=bs().extent([[i.left,i.top],[L-i.right,A-i.bottom]]).on("start",q).on("brush",I).on("end",H)),3145808&t.$$.dirty[0]&&E&&T&&(n(20,D=_l(E)),D.call(d)),138149888&t.$$.dirty[0]&&g&&B&&!j&&D.call(d.clear),67108865&t.$$.dirty[0]&&n(13,R=f.get(M.x_feature))},[M,L,A,S,T,_,E,i,c,a,o,r,v,R,z,N,C,k,B,j,D,d,h,s,u,l,f,g,y,w,b,$,x,function(t){F[t?"unshift":"push"]((()=>{_=t,n(5,_)}))},function(t){F[t?"unshift":"push"]((()=>{E=t,n(6,E)}))}]}const Cs=class extends gt{constructor(t){super(),pt(this,t,Ns,Ss,h,{pd:0,width:1,height:2,scaleLocally:14,showMarginalDistribution:3,marginTop:15,marginRight:16,allowBrushing:4},xs,[-1,-1])}};function Ts(t){let e,n;return e=new Wi({props:{pd:t[0],width:t[1],height:t[2],scaleLocally:t[3],showMarginalDistribution:t[5],marginTop:t[6],marginRight:t[7],indices:t[8]}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};1&n&&(r.pd=t[0]),2&n&&(r.width=t[1]),4&n&&(r.height=t[2]),8&n&&(r.scaleLocally=t[3]),32&n&&(r.showMarginalDistribution=t[5]),64&n&&(r.marginTop=t[6]),128&n&&(r.marginRight=t[7]),256&n&&(r.indices=t[8]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Os(t){let e,n;return e=new Bi({props:{pd:t[0],width:t[1],height:t[2],scaleLocally:t[3],showMarginalDistribution:t[5],marginTop:t[6],marginRight:t[7]}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};1&n&&(r.pd=t[0]),2&n&&(r.width=t[1]),4&n&&(r.height=t[2]),8&n&&(r.scaleLocally=t[3]),32&n&&(r.showMarginalDistribution=t[5]),64&n&&(r.marginTop=t[6]),128&n&&(r.marginRight=t[7]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Es(t){let e,n;return e=new lo({props:{pd:t[0],width:t[1],height:t[2],scaleLocally:t[3],showMarginalDistribution:t[5],marginTop:t[6],marginRight:t[7]}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};1&n&&(r.pd=t[0]),2&n&&(r.width=t[1]),4&n&&(r.height=t[2]),8&n&&(r.scaleLocally=t[3]),32&n&&(r.showMarginalDistribution=t[5]),64&n&&(r.marginTop=t[6]),128&n&&(r.marginRight=t[7]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Ds(t){let e,n;return e=new Cs({props:{pd:t[0],width:t[1],height:t[2],scaleLocally:t[3],showMarginalDistribution:t[5],marginTop:t[6],marginRight:t[7],allowBrushing:t[9]}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};1&n&&(r.pd=t[0]),2&n&&(r.width=t[1]),4&n&&(r.height=t[2]),8&n&&(r.scaleLocally=t[3]),32&n&&(r.showMarginalDistribution=t[5]),64&n&&(r.marginTop=t[6]),128&n&&(r.marginRight=t[7]),512&n&&(r.allowBrushing=t[9]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Rs(t){let e,n,r,i;const o=[Ds,Es,Os,Ts],l=[];function a(t,e){return"lines"===t[4]?0:"cluster-centers"===t[4]?1:"cluster-bands"===t[4]?2:3}return e=a(t),n=l[e]=o[e](t),{c(){n.c(),r=z()},m(t,n){l[e].m(t,n),$(t,r,n),i=!0},p(t,[i]){let s=e;e=a(t),e===s?l[e].p(t,i):(rt(),lt(l[s],1,1,(()=>{l[s]=null})),it(),n=l[e],n?n.p(t,i):(n=l[e]=o[e](t),n.c()),ot(n,1),n.m(r.parentNode,r))},i(t){i||(ot(n),i=!0)},o(t){lt(n),i=!1},d(t){l[e].d(t),t&&x(r)}}}function Bs(t,e,n){let{pd:r}=e,{width:i}=e,{height:o}=e,{scaleLocally:l}=e,{iceLevel:a}=e,{showMarginalDistribution:s}=e,{marginTop:c}=e,{marginRight:u}=e,{indices:h}=e,{allowBrushing:d}=e;return t.$$set=t=>{"pd"in t&&n(0,r=t.pd),"width"in t&&n(1,i=t.width),"height"in t&&n(2,o=t.height),"scaleLocally"in t&&n(3,l=t.scaleLocally),"iceLevel"in t&&n(4,a=t.iceLevel),"showMarginalDistribution"in t&&n(5,s=t.showMarginalDistribution),"marginTop"in t&&n(6,c=t.marginTop),"marginRight"in t&&n(7,u=t.marginRight),"indices"in t&&n(8,h=t.indices),"allowBrushing"in t&&n(9,d=t.allowBrushing)},[r,i,o,l,a,s,c,u,h,d]}const js=class extends gt{constructor(t){super(),pt(this,t,Bs,Rs,h,{pd:0,width:1,height:2,scaleLocally:3,iceLevel:4,showMarginalDistribution:5,marginTop:6,marginRight:7,indices:8,allowBrushing:9})}};function qs(t,e,n,r,i,o,l,a,s,c){var u,h;e.save(),e.clearRect(0,0,n,r);for(let n=0;n<t.x_values.length;n++){const r=t.x_values[n],d=t.y_values[n],f=t.mean_predictions[n],p=t.interactions[n];e.fillStyle=l("interactions"===a?p:f);const g="bandwidth"in i?(null!==(u=i(r))&&void 0!==u?u:0)+1:i(r)-s/2,m="bandwidth"in o?(null!==(h=o(d))&&void 0!==h?h:0)+1:o(d)-c/2;e.fillRect(g,m,s,c)}e.restore()}function Ps(t){b(t,"svelte-sh84n1",".color-container.svelte-sh84n1{position:relative}svg.svelte-sh84n1{position:absolute;left:0;top:0}")}function Is(t,e,n){const r=t.slice();return r[16]=e[n],r}function Hs(t){let e,n,r,i,o,l,a,s=xn(t[16])+"";return{c(){e=M("g"),n=M("line"),i=M("text"),o=L(s),N(n,"y1",r=0),N(n,"y2",t[5]),N(n,"stroke","black"),N(i,"y",l=t[5]+Vs),N(i,"dominant-baseline","hanging"),N(i,"text-anchor","middle"),N(i,"font-size",Xs),N(e,"transform",a="translate("+t[4](t[16])+","+t[2]+")")},m(t,r){$(t,e,r),w(e,n),w(e,i),w(i,o)},p(t,r){32&r&&N(n,"y2",t[5]),64&r&&s!==(s=xn(t[16])+"")&&T(o,s),32&r&&l!==(l=t[5]+Vs)&&N(i,"y",l),84&r&&a!==(a="translate("+t[4](t[16])+","+t[2]+")")&&N(e,"transform",a)},d(t){t&&x(e)}}}function Fs(t){let e,n,r,i,o=t[6],a=[];for(let e=0;e<o.length;e+=1)a[e]=Hs(Is(t,o,e));return{c(){e=k("div"),n=k("canvas"),r=A(),i=M("svg");for(let t=0;t<a.length;t+=1)a[t].c();N(i,"width",t[0]),N(i,"height",t[1]),N(i,"class","svelte-sh84n1"),N(e,"class","color-container svelte-sh84n1"),E(e,"height",t[1]+"px")},m(o,l){$(o,e,l),w(e,n),t[14](n),w(e,r),w(e,i);for(let t=0;t<a.length;t+=1)a[t].m(i,null)},p(t,[n]){if(116&n){let e;for(o=t[6],e=0;e<o.length;e+=1){const r=Is(t,o,e);a[e]?a[e].p(r,n):(a[e]=Hs(r),a[e].c(),a[e].m(i,null))}for(;e<a.length;e+=1)a[e].d(1);a.length=o.length}1&n&&N(i,"width",t[0]),2&n&&N(i,"height",t[1]),2&n&&E(e,"height",t[1]+"px")},i:l,o:l,d(n){n&&x(e),t[14](null),_(a,n)}}}const Vs=2,Xs=10;function Ws(t,e,n){let r,i,o,l,a,s,c,{width:u}=e,{height:h}=e,{color:d}=e,{marginTop:f=0}=e,{marginRight:p=0}=e,{marginBottom:g=0}=e,{marginLeft:m=0}=e;return P((()=>{n(11,c=s.getContext("2d"))})),t.$$set=t=>{"width"in t&&n(0,u=t.width),"height"in t&&n(1,h=t.height),"color"in t&&n(7,d=t.color),"marginTop"in t&&n(2,f=t.marginTop),"marginRight"in t&&n(8,p=t.marginRight),"marginBottom"in t&&n(9,g=t.marginBottom),"marginLeft"in t&&n(10,m=t.marginLeft)},t.$$.update=()=>{1281&t.$$.dirty&&n(13,r=u-m-p),518&t.$$.dirty&&n(5,i=h-f-g-Xs-Vs),2059&t.$$.dirty&&c&&$n(s,c,u,h),11431&t.$$.dirty&&c&&function(t,e,n,r,i,o,l,a){t.clearRect(0,0,n,r);for(let n=0;n<i;n++)t.fillStyle=e(n/i),t.fillRect(n+l,a,1,o)}(c,d.interpolator(),u,h,r,i,m,f),1409&t.$$.dirty&&n(4,o=tn().domain([d.domain()[0],d.domain()[d.domain().length-1]]).range([m,u-p])),128&t.$$.dirty&&n(12,l=d.domain().length),12304&t.$$.dirty&&n(6,a=o.ticks(Math.max(r/50,l)))},[u,h,f,s,o,i,a,d,p,g,m,c,l,r,function(t){F[t?"unshift":"push"]((()=>{s=t,n(3,s)}))}]}const Ys=class extends gt{constructor(t){super(),pt(this,t,Ws,Fs,h,{width:0,height:1,color:7,marginTop:2,marginRight:8,marginBottom:9,marginLeft:10},Ps)}};function Ks(t,e=Us){const n=[];let r,i=!1;for(const o of t)i&&n.push(e(r,o)),r=o,i=!0;return n}function Us(t,e){return[t,e]}function Gs(t){b(t,"svelte-1fhirhh","div.svelte-1fhirhh{position:relative;width:100%;height:100%}svg.svelte-1fhirhh,canvas.svelte-1fhirhh{position:absolute;top:var(--top);left:0}")}function Zs(t){let e,n;return e=new Ys({props:{width:t[1],height:t[12],color:t[5],marginLeft:t[9].left,marginRight:t[9].right}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};2&n[0]&&(r.width=t[1]),4096&n[0]&&(r.height=t[12]),32&n[0]&&(r.color=t[5]),512&n[0]&&(r.marginLeft=t[9].left),512&n[0]&&(r.marginRight=t[9].right),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Js(t){let e,n,r,i,o,l,a;const s=[tc,Qs],c=[];function u(t,e){return"bandwidth"in t[7]?0:1}e=u(t),n=c[e]=s[e](t);const h=[nc,ec],d=[];function f(t,e){return"bandwidth"in t[6]?0:1}return i=f(t),o=d[i]=h[i](t),{c(){n.c(),r=z(),o.c(),l=z()},m(t,n){c[e].m(t,n),$(t,r,n),d[i].m(t,n),$(t,l,n),a=!0},p(t,a){let p=e;e=u(t),e===p?c[e].p(t,a):(rt(),lt(c[p],1,1,(()=>{c[p]=null})),it(),n=c[e],n?n.p(t,a):(n=c[e]=s[e](t),n.c()),ot(n,1),n.m(r.parentNode,r));let g=i;i=f(t),i===g?d[i].p(t,a):(rt(),lt(d[g],1,1,(()=>{d[g]=null})),it(),o=d[i],o?o.p(t,a):(o=d[i]=h[i](t),o.c()),ot(o,1),o.m(l.parentNode,l))},i(t){a||(ot(n),ot(o),a=!0)},o(t){lt(n),lt(o),a=!1},d(t){c[e].d(t),t&&x(r),d[i].d(t),t&&x(l)}}}function Qs(t){let e,n;return e=new wi({props:{data:t[11].distribution,x:t[7],height:t[9].top,direction:"horizontal"}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};2048&n[0]&&(r.data=t[11].distribution),128&n[0]&&(r.x=t[7]),512&n[0]&&(r.height=t[9].top),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function tc(t){let e,n;return e=new zi({props:{data:t[11].distribution,x:t[7],height:t[9].top,direction:"horizontal"}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};2048&n[0]&&(r.data=t[11].distribution),128&n[0]&&(r.x=t[7]),512&n[0]&&(r.height=t[9].top),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function ec(t){let e,n;return e=new wi({props:{data:t[10].distribution,x:t[6],height:t[9].top,direction:"vertical",translate:[t[1]-t[9].right,0]}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};1024&n[0]&&(r.data=t[10].distribution),64&n[0]&&(r.x=t[6]),512&n[0]&&(r.height=t[9].top),514&n[0]&&(r.translate=[t[1]-t[9].right,0]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function nc(t){let e,n;return e=new zi({props:{data:t[10].distribution,x:t[6],height:t[9].top,direction:"vertical",translate:[t[1]-t[9].right,0]}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};1024&n[0]&&(r.data=t[10].distribution),64&n[0]&&(r.x=t[6]),512&n[0]&&(r.height=t[9].top),514&n[0]&&(r.translate=[t[1]-t[9].right,0]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function rc(t){let e,n,r,i,o,l,a,s,c=t[3]&&Zs(t);l=new Kr({props:{scale:t[7],y:t[8]-t[9].bottom,label:t[0].x_feature,integerOnly:"discrete"===t[11].subkind,value_map:"value_map"in t[11]?t[11].value_map:{}}}),a=new ui({props:{scale:t[6],x:t[9].left,label:t[0].y_feature,integerOnly:"discrete"===t[10].subkind,value_map:"value_map"in t[10]?t[10].value_map:{}}});let u=t[2]&&Js(t);return{c(){e=k("div"),c&&c.c(),n=A(),r=k("canvas"),i=A(),o=M("svg"),ht(l.$$.fragment),ht(a.$$.fragment),u&&u.c(),N(r,"class","svelte-1fhirhh"),N(o,"width",t[1]),N(o,"height",t[8]),N(o,"class","svelte-1fhirhh"),N(e,"class","svelte-1fhirhh"),E(e,"--top",t[12])},m(h,d){$(h,e,d),c&&c.m(e,null),w(e,n),w(e,r),t[32](r),w(e,i),w(e,o),dt(l,o,null),dt(a,o,null),u&&u.m(o,null),s=!0},p(t,r){t[3]?c?(c.p(t,r),8&r[0]&&ot(c,1)):(c=Zs(t),c.c(),ot(c,1),c.m(e,n)):c&&(rt(),lt(c,1,1,(()=>{c=null})),it());const i={};128&r[0]&&(i.scale=t[7]),768&r[0]&&(i.y=t[8]-t[9].bottom),1&r[0]&&(i.label=t[0].x_feature),2048&r[0]&&(i.integerOnly="discrete"===t[11].subkind),2048&r[0]&&(i.value_map="value_map"in t[11]?t[11].value_map:{}),l.$set(i);const h={};64&r[0]&&(h.scale=t[6]),512&r[0]&&(h.x=t[9].left),1&r[0]&&(h.label=t[0].y_feature),1024&r[0]&&(h.integerOnly="discrete"===t[10].subkind),1024&r[0]&&(h.value_map="value_map"in t[10]?t[10].value_map:{}),a.$set(h),t[2]?u?(u.p(t,r),4&r[0]&&ot(u,1)):(u=Js(t),u.c(),ot(u,1),u.m(o,null)):u&&(rt(),lt(u,1,1,(()=>{u=null})),it()),(!s||2&r[0])&&N(o,"width",t[1]),(!s||256&r[0])&&N(o,"height",t[8]),4096&r[0]&&E(e,"--top",t[12])},i(t){s||(ot(c),ot(l.$$.fragment,t),ot(a.$$.fragment,t),ot(u),s=!0)},o(t){lt(c),lt(l.$$.fragment,t),lt(a.$$.fragment,t),lt(u),s=!1},d(n){n&&x(e),c&&c.d(),t[32](null),ft(l),ft(a),u&&u.d()}}}function ic(t,e,n){let r,i,o,l,a,s,c,u,h,d,f,g,m,v,y,w,b,$,x,_,k;p(t,Kn,(t=>n(29,x=t))),p(t,Un,(t=>n(30,_=t))),p(t,Nn,(t=>n(31,k=t)));let M,L,{pd:A}=e,{width:z}=e,{height:S}=e,{scaleLocally:N}=e,{showMarginalDistribution:C}=e,{colorShows:T}=e,{showColorLegend:O}=e,{marginTop:E=0}=e,{marginRight:D=0}=e;return P((()=>{n(18,L=M.getContext("2d"))})),t.$$set=t=>{"pd"in t&&n(0,A=t.pd),"width"in t&&n(1,z=t.width),"height"in t&&n(13,S=t.height),"scaleLocally"in t&&n(14,N=t.scaleLocally),"showMarginalDistribution"in t&&n(2,C=t.showMarginalDistribution),"colorShows"in t&&n(15,T=t.colorShows),"showColorLegend"in t&&n(3,O=t.showColorLegend),"marginTop"in t&&n(16,E=t.marginTop),"marginRight"in t&&n(17,D=t.marginRight)},t.$$.update=()=>{1&t.$$.dirty[0]|1&t.$$.dirty[1]&&n(11,r=k[A.x_feature]),1&t.$$.dirty[0]|1&t.$$.dirty[1]&&n(10,i=k[A.y_feature]),536870913&t.$$.dirty[0]&&n(27,o=x.copy().domain([A.pdp_min,A.pdp_max])),1073741825&t.$$.dirty[0]&&n(28,l=_.copy().domain([A.interaction_min,0,A.interaction_max])),2013315072&t.$$.dirty[0]&&n(5,a="interactions"===T?N?l:_:N?o:x),8&t.$$.dirty[0]&&n(12,s=O?24:0),12288&t.$$.dirty[0]&&n(8,c=S-s),196608&t.$$.dirty[0]&&n(9,u={top:E,right:D,bottom:35,left:50}),1&t.$$.dirty[0]&&n(24,h=Math.min(...Ks(A.x_axis,((t,e)=>e-t)))),1&t.$$.dirty[0]&&n(21,d=Math.min(...Ks(A.y_axis,((t,e)=>e-t)))),16777217&t.$$.dirty[0]&&n(23,f=A.x_axis[0]-h/2),16777217&t.$$.dirty[0]&&n(26,g=A.x_axis[A.x_axis.length-1]+h/2),2097153&t.$$.dirty[0]&&n(22,m=A.y_axis[0]-d/2),2097153&t.$$.dirty[0]&&n(25,v=A.y_axis[A.y_axis.length-1]+d/2),75500035&t.$$.dirty[0]&&n(7,y="quantitative"===r.kind?tn().domain([f,g]).range([u.left,z-u.right]):ar().domain(A.x_axis).range([u.left,z-u.right])),37750529&t.$$.dirty[0]&&n(6,w="quantitative"===i.kind?tn().domain([m,v]).range([c-u.bottom,u.top]):ar().domain(A.y_axis).range([c-u.bottom,u.top])),25165952&t.$$.dirty[0]&&n(20,b="bandwidth"in y?y.bandwidth()-2:y(f+h)-y(f)),6291520&t.$$.dirty[0]&&n(19,$="bandwidth"in w?w.bandwidth()-2:w(m)-w(m+d)),262418&t.$$.dirty[0]&&L&&($n(M,L,z,c),L&&null!=y&&null!=w&&qs(A,L,z,c,y,w,a,T,b,$)),1868259&t.$$.dirty[0]&&L&&null!=y&&null!=w&&qs(A,L,z,c,y,w,a,T,b,$)},[A,z,C,O,M,a,w,y,c,u,i,r,s,S,N,T,E,D,L,$,b,d,m,f,h,v,g,o,l,x,_,k,function(t){F[t?"unshift":"push"]((()=>{M=t,n(4,M)}))}]}const oc=class extends gt{constructor(t){super(),pt(this,t,ic,rc,h,{pd:0,width:1,height:13,scaleLocally:14,showMarginalDistribution:2,colorShows:15,showColorLegend:3,marginTop:16,marginRight:17},Gs,[-1,-1])}};function lc(t){let e,n,r,i;const o=[sc,ac],l=[];function a(t,e){return 1===t[0].num_features?0:2===t[0].num_features?1:-1}return~(e=a(t))&&(n=l[e]=o[e](t)),{c(){n&&n.c(),r=z()},m(t,n){~e&&l[e].m(t,n),$(t,r,n),i=!0},p(t,i){let s=e;e=a(t),e===s?~e&&l[e].p(t,i):(n&&(rt(),lt(l[s],1,1,(()=>{l[s]=null})),it()),~e?(n=l[e],n?n.p(t,i):(n=l[e]=o[e](t),n.c()),ot(n,1),n.m(r.parentNode,r)):n=null)},i(t){i||(ot(n),i=!0)},o(t){lt(n),i=!1},d(t){~e&&l[e].d(t),t&&x(r)}}}function ac(t){let e,n;return e=new oc({props:{width:t[1],height:t[2],pd:t[0],scaleLocally:t[3],colorShows:t[4],showColorLegend:t[5],marginTop:t[9],marginRight:t[10],showMarginalDistribution:t[8]}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};2&n&&(r.width=t[1]),4&n&&(r.height=t[2]),1&n&&(r.pd=t[0]),8&n&&(r.scaleLocally=t[3]),16&n&&(r.colorShows=t[4]),32&n&&(r.showColorLegend=t[5]),512&n&&(r.marginTop=t[9]),1024&n&&(r.marginRight=t[10]),256&n&&(r.showMarginalDistribution=t[8]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function sc(t){let e,n;return e=new js({props:{width:t[1],height:t[2],pd:t[0],scaleLocally:t[3],iceLevel:t[6],showMarginalDistribution:t[8],marginTop:t[9],marginRight:t[10],indices:t[7],allowBrushing:t[11]}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};2&n&&(r.width=t[1]),4&n&&(r.height=t[2]),1&n&&(r.pd=t[0]),8&n&&(r.scaleLocally=t[3]),64&n&&(r.iceLevel=t[6]),256&n&&(r.showMarginalDistribution=t[8]),512&n&&(r.marginTop=t[9]),1024&n&&(r.marginRight=t[10]),128&n&&(r.indices=t[7]),2048&n&&(r.allowBrushing=t[11]),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function cc(t){let e,n,r=t[1]>0&&t[2]>0&&lc(t);return{c(){r&&r.c(),e=z()},m(t,i){r&&r.m(t,i),$(t,e,i),n=!0},p(t,[n]){t[1]>0&&t[2]>0?r?(r.p(t,n),6&n&&ot(r,1)):(r=lc(t),r.c(),ot(r,1),r.m(e.parentNode,e)):r&&(rt(),lt(r,1,1,(()=>{r=null})),it())},i(t){n||(ot(r),n=!0)},o(t){lt(r),n=!1},d(t){r&&r.d(t),t&&x(e)}}}function uc(t,e,n){let{pd:r}=e,{width:i}=e,{height:o}=e,{scaleLocally:l}=e,{colorShows:a="predictions"}=e,{showColorLegend:s=!1}=e,{iceLevel:c}=e,{indices:u=null}=e,{showMarginalDistribution:h=!1}=e,{marginTop:d=0}=e,{marginRight:f=0}=e,{allowBrushing:p=!1}=e;return t.$$set=t=>{"pd"in t&&n(0,r=t.pd),"width"in t&&n(1,i=t.width),"height"in t&&n(2,o=t.height),"scaleLocally"in t&&n(3,l=t.scaleLocally),"colorShows"in t&&n(4,a=t.colorShows),"showColorLegend"in t&&n(5,s=t.showColorLegend),"iceLevel"in t&&n(6,c=t.iceLevel),"indices"in t&&n(7,u=t.indices),"showMarginalDistribution"in t&&n(8,h=t.showMarginalDistribution),"marginTop"in t&&n(9,d=t.marginTop),"marginRight"in t&&n(10,f=t.marginRight),"allowBrushing"in t&&n(11,p=t.allowBrushing)},[r,i,o,l,a,s,c,u,h,d,f,p]}const hc=class extends gt{constructor(t){super(),pt(this,t,uc,cc,h,{pd:0,width:1,height:2,scaleLocally:3,colorShows:4,showColorLegend:5,iceLevel:6,indices:7,showMarginalDistribution:8,marginTop:9,marginRight:10,allowBrushing:11})}};function dc(t,e){let n;if(void 0===e)for(const e of t)null!=e&&(n<e||void 0===n&&e>=e)&&(n=e);else{let r=-1;for(let i of t)null!=(i=e(i,++r,t))&&(n<i||void 0===n&&i>=i)&&(n=i)}return n}function fc(t,e,n=be){if(r=t.length){if((e=+e)<=0||r<2)return+n(t[0],0,t);if(e>=1)return+n(t[r-1],r-1,t);var r,i=(r-1)*e,o=Math.floor(i),l=+n(t[o],o,t);return l+(+n(t[o+1],o+1,t)-l)*(i-o)}}function pc(t,e){if((i=t.length)>1)for(var n,r,i,o=1,l=t[e[0]],a=l.length;o<i;++o)for(r=l,l=t[e[o]],n=0;n<a;++n)l[n][1]+=l[n][0]=isNaN(r[n][1])?r[n][0]:r[n][1]}function gc(t){for(var e=t.length,n=new Array(e);--e>=0;)n[e]=e;return n}function mc(t,e){return t[e]}function vc(t){const e=[];return e.key=t,e}function yc(t,e){if((r=t.length)>0){for(var n,r,i,o=0,l=t[0].length;o<l;++o){for(i=n=0;n<r;++n)i+=t[n][o][1]||0;if(i)for(n=0;n<r;++n)t[n][o][1]/=i}pc(t,e)}}function wc(t,e){var n,r,i=function(t){if(0===t.length)throw new Error("mean requires at least one data point");return function(t){if(0===t.length)return 0;var e,n=t[0],r=0;if("number"!=typeof n)return NaN;for(var i=1;i<t.length;i++){if("number"!=typeof t[i])return NaN;e=n+t[i],Math.abs(n)>=Math.abs(t[i])?r+=n-e+t[i]:r+=t[i]-e+n,n=e}return n+r}(t)/t.length}(t),o=0;if(2===e)for(r=0;r<t.length;r++)o+=(n=t[r]-i)*n;else for(r=0;r<t.length;r++)o+=Math.pow(t[r]-i,e);return o}function bc(t,e){var n=t.length*e;if(0===t.length)throw new Error("quantile requires at least one data point.");if(e<0||e>1)throw new Error("quantiles must be between 0 and 1");return 1===e?t[t.length-1]:0===e?t[0]:n%1!=0?t[Math.ceil(n)-1]:t.length%2==0?(t[n-1]+t[n])/2:t[n]}function $c(t,e,n,r){for(n=n||0,r=r||t.length-1;r>n;){if(r-n>600){var i=r-n+1,o=e-n+1,l=Math.log(i),a=.5*Math.exp(2*l/3),s=.5*Math.sqrt(l*a*(i-a)/i);o-i/2<0&&(s*=-1),$c(t,e,Math.max(n,Math.floor(e-o*a/i+s)),Math.min(r,Math.floor(e+(i-o)*a/i+s)))}var c=t[e],u=n,h=r;for(xc(t,n,e),t[r]>c&&xc(t,n,r);u<h;){for(xc(t,u,h),u++,h--;t[u]<c;)u++;for(;t[h]>c;)h--}t[n]===c?xc(t,n,h):xc(t,++h,r),h<=e&&(n=h+1),e<=h&&(r=h-1)}}function xc(t,e,n){var r=t[e];t[e]=t[n],t[n]=r}function _c(t,e){var n=t.slice();if(Array.isArray(e)){!function(t,e){for(var n=[0],r=0;r<e.length;r++)n.push(Lc(t.length,e[r]));n.push(t.length-1),n.sort(Mc);for(var i=[0,n.length-1];i.length;){var o=Math.ceil(i.pop()),l=Math.floor(i.pop());if(!(o-l<=1)){var a=Math.floor((l+o)/2);kc(t,n[a],Math.floor(n[l]),Math.ceil(n[o])),i.push(l,a,a,o)}}}(n,e);for(var r=[],i=0;i<e.length;i++)r[i]=bc(n,e[i]);return r}return kc(n,Lc(n.length,e),0,n.length-1),bc(n,e)}function kc(t,e,n,r){e%1==0?$c(t,e,n,r):($c(t,e=Math.floor(e),n,r),$c(t,e+1,e+1,r))}function Mc(t,e){return t-e}function Lc(t,e){var n=t*e;return 1===e?t-1:0===e?0:n%1!=0?Math.ceil(n)-1:t%2==0?n-.5:n}function Ac(t){var e=function(t){if(t.length<2)throw new Error("sampleVariance requires at least two data points");return wc(t,2)/(t.length-1)}(t);return Math.sqrt(e)}var zc=function(){this.totalCount=0,this.data={}};zc.prototype.train=function(t,e){for(var n in this.data[e]||(this.data[e]={}),t){var r=t[n];void 0===this.data[e][n]&&(this.data[e][n]={}),void 0===this.data[e][n][r]&&(this.data[e][n][r]=0),this.data[e][n][r]++}this.totalCount++},zc.prototype.score=function(t){var e,n={};for(var r in t){var i=t[r];for(e in this.data)n[e]={},this.data[e][r]?n[e][r+"_"+i]=(this.data[e][r][i]||0)/this.totalCount:n[e][r+"_"+i]=0}var o={};for(e in n)for(var l in o[e]=0,n[e])o[e]+=n[e][l];return o};var Sc=function(){this.weights=[],this.bias=0};Sc.prototype.predict=function(t){if(t.length!==this.weights.length)return null;for(var e=0,n=0;n<this.weights.length;n++)e+=this.weights[n]*t[n];return(e+=this.bias)>0?1:0},Sc.prototype.train=function(t,e){if(0!==e&&1!==e)return null;t.length!==this.weights.length&&(this.weights=t,this.bias=1);var n=this.predict(t);if("number"==typeof n&&n!==e){for(var r=e-n,i=0;i<this.weights.length;i++)this.weights[i]+=r*t[i];this.bias+=r}return this},Math.log(Math.sqrt(2*Math.PI));var Nc=Math.sqrt(2*Math.PI),Cc={gaussian:function(t){return Math.exp(-.5*t*t)/Nc}},Tc={nrd:function(t){var e=Ac(t),n=function(t){var e=_c(t,.75),n=_c(t,.25);if("number"==typeof e&&"number"==typeof n)return e-n}(t);return"number"==typeof n&&(e=Math.min(e,n/1.34)),1.06*e*Math.pow(t.length,-.2)}},Oc=Math.sqrt(2*Math.PI);function Ec(t){for(var e=t,n=t,r=1;r<15;r++)e+=n*=t*t/(2*r+1);return Math.round(1e4*(.5+e/Oc*Math.exp(-t*t/2)))/1e4}for(var Dc=[],Rc=0;Rc<=3.09;Rc+=.01)Dc.push(Ec(Rc));function Bc(t){b(t,"svelte-xk351a",".label-and-input.svelte-xk351a{display:flex;align-items:center;gap:0.25em}.controls-container.svelte-xk351a{display:flex;align-items:center;gap:1em}")}function jc(t,e,n){const r=t.slice();return r[32]=e[n],r}function qc(t,e,n){const r=t.slice();return r[41]=e[n].cluster,r[42]=e[n].box,r}function Pc(t,e,n){const r=t.slice();return r[35]=e[n],r[37]=n,r}function Ic(t,e,n){const r=t.slice();return r[38]=e[n],r}function Hc(t){let e,n,r,i,o;return{c(){e=k("label"),n=k("input"),r=L("Normalize bar charts"),N(n,"type","checkbox"),N(e,"class","label-and-input svelte-xk351a")},m(l,a){$(l,e,a),w(e,n),n.checked=t[1],w(e,r),i||(o=S(n,"change",t[26]),i=!0)},p(t,e){2&e[0]&&(n.checked=t[1])},d(t){t&&x(e),i=!1,o()}}}function Fc(t){let e,n=t[32].data,r=[];for(let e=0;e<n.length;e+=1)r[e]=Xc(qc(t,n,e));return{c(){e=M("g");for(let t=0;t<r.length;t+=1)r[t].c()},m(t,n){$(t,e,n);for(let t=0;t<r.length;t+=1)r[t].m(e,null)},p(t,i){if(38084&i[0]){let o;for(n=t[32].data,o=0;o<n.length;o+=1){const l=qc(t,n,o);r[o]?r[o].p(l,i):(r[o]=Xc(l),r[o].c(),r[o].m(e,null))}for(;o<r.length;o+=1)r[o].d(1);r.length=n.length}},i:l,o:l,d(t){t&&x(e),_(r,t)}}}function Vc(t){let e,n,r,i=t[32].data,o=[];for(let e=0;e<i.length;e+=1)o[e]=Kc(Pc(t,i,e));return n=new ui({props:{scale:t[11],x:t[14].left,label:t[1]?"percent":"count",format:t[1]?Ue("~%"):xn}}),{c(){e=M("g");for(let t=0;t<o.length;t+=1)o[t].c();ht(n.$$.fragment)},m(t,i){$(t,e,i);for(let t=0;t<o.length;t+=1)o[t].m(e,null);dt(n,t,i),r=!0},p(t,r){if(6212&r[0]){let n;for(i=t[32].data,n=0;n<i.length;n+=1){const l=Pc(t,i,n);o[n]?o[n].p(l,r):(o[n]=Kc(l),o[n].c(),o[n].m(e,null))}for(;n<o.length;n+=1)o[n].d(1);o.length=i.length}const l={};2048&r[0]&&(l.scale=t[11]),2&r[0]&&(l.label=t[1]?"percent":"count"),2&r[0]&&(l.format=t[1]?Ue("~%"):xn),n.$set(l)},i(t){r||(ot(n.$$.fragment,t),r=!0)},o(t){lt(n.$$.fragment,t),r=!1},d(t){t&&x(e),_(o,t),ft(n,t)}}}function Xc(t){let e,n,r,i,o,l,a,s,c,u,h,d,f,p,g,m,v,y,b,_,k,L,A,z;return{c(){e=M("g"),n=M("path"),o=M("rect"),c=M("line"),m=M("line"),_=M("line"),N(n,"d",r=t[15](t[6][t[32].feature],t[42].densities)),N(n,"fill",i=t[12](t[41])),N(o,"x",l=t[6][t[32].feature](t[42].q1)??0),N(o,"width",a=(t[6][t[32].feature](t[42].q3)??0)-(t[6][t[32].feature](t[42].q1)??0)),N(o,"y",s=-t[10]/2),N(o,"height",t[10]),N(o,"fill","var(--gray-1)"),N(c,"x1",u=t[6][t[32].feature](t[42].median)??0),N(c,"x2",h=t[6][t[32].feature](t[42].median)??0),N(c,"stroke-width",d=2),N(c,"y1",f=-t[10]/2),N(c,"y2",p=t[10]/2),N(c,"stroke",g="black"),N(m,"x1",v=t[6][t[32].feature](t[42].low)??0),N(m,"x2",y=t[6][t[32].feature](t[42].q1)??0),N(m,"stroke-width",b=1),N(m,"stroke","var(--gray-1)"),N(_,"x1",k=t[6][t[32].feature](t[42].q3)??0),N(_,"x2",L=t[6][t[32].feature](t[42].high)??0),N(_,"stroke-width",A=1),N(_,"stroke","var(--gray-1)"),N(e,"transform",z="translate(0,"+((t[7](t[41])??0)+t[7].bandwidth()/2)+")")},m(t,r){$(t,e,r),w(e,n),w(e,o),w(e,c),w(e,m),w(e,_)},p(t,d){68&d[0]&&r!==(r=t[15](t[6][t[32].feature],t[42].densities))&&N(n,"d",r),4100&d[0]&&i!==(i=t[12](t[41]))&&N(n,"fill",i),68&d[0]&&l!==(l=t[6][t[32].feature](t[42].q1)??0)&&N(o,"x",l),68&d[0]&&a!==(a=(t[6][t[32].feature](t[42].q3)??0)-(t[6][t[32].feature](t[42].q1)??0))&&N(o,"width",a),1024&d[0]&&s!==(s=-t[10]/2)&&N(o,"y",s),1024&d[0]&&N(o,"height",t[10]),68&d[0]&&u!==(u=t[6][t[32].feature](t[42].median)??0)&&N(c,"x1",u),68&d[0]&&h!==(h=t[6][t[32].feature](t[42].median)??0)&&N(c,"x2",h),1024&d[0]&&f!==(f=-t[10]/2)&&N(c,"y1",f),1024&d[0]&&p!==(p=t[10]/2)&&N(c,"y2",p),68&d[0]&&v!==(v=t[6][t[32].feature](t[42].low)??0)&&N(m,"x1",v),68&d[0]&&y!==(y=t[6][t[32].feature](t[42].q1)??0)&&N(m,"x2",y),68&d[0]&&k!==(k=t[6][t[32].feature](t[42].q3)??0)&&N(_,"x1",k),68&d[0]&&L!==(L=t[6][t[32].feature](t[42].high)??0)&&N(_,"x2",L),132&d[0]&&z!==(z="translate(0,"+((t[7](t[41])??0)+t[7].bandwidth()/2)+")")&&N(e,"transform",z)},d(t){t&&x(e)}}}function Wc(t){let e,n,r,i,o;return{c(){e=M("rect"),N(e,"x",n=eu(t[38].data[0],t[6][t[32].feature])+1),N(e,"width",r=tu(t[6][t[32].feature])-2),N(e,"y",i=t[11](t[38][1])),N(e,"height",o=t[11](t[38][0])-t[11](t[38][1]))},m(t,n){$(t,e,n)},p(t,l){68&l[0]&&n!==(n=eu(t[38].data[0],t[6][t[32].feature])+1)&&N(e,"x",n),68&l[0]&&r!==(r=tu(t[6][t[32].feature])-2)&&N(e,"width",r),2052&l[0]&&i!==(i=t[11](t[38][1]))&&N(e,"y",i),2052&l[0]&&o!==(o=t[11](t[38][0])-t[11](t[38][1]))&&N(e,"height",o)},d(t){t&&x(e)}}}function Yc(t){let e,n=t[38][0]!==t[38][1]&&Wc(t);return{c(){n&&n.c(),e=z()},m(t,r){n&&n.m(t,r),$(t,e,r)},p(t,r){t[38][0]!==t[38][1]?n?n.p(t,r):(n=Wc(t),n.c(),n.m(e.parentNode,e)):n&&(n.d(1),n=null)},d(t){n&&n.d(t),t&&x(e)}}}function Kc(t){let e,n,r=t[35],i=[];for(let e=0;e<r.length;e+=1)i[e]=Yc(Ic(t,r,e));return{c(){e=M("g");for(let t=0;t<i.length;t+=1)i[t].c();N(e,"fill",n=t[12](t[37]))},m(t,n){$(t,e,n);for(let t=0;t<i.length;t+=1)i[t].m(e,null)},p(t,o){if(2116&o[0]){let n;for(r=t[35],n=0;n<r.length;n+=1){const l=Ic(t,r,n);i[n]?i[n].p(l,o):(i[n]=Yc(l),i[n].c(),i[n].m(e,null))}for(;n<i.length;n+=1)i[n].d(1);i.length=r.length}4096&o[0]&&n!==(n=t[12](t[37]))&&N(e,"fill",n)},d(t){t&&x(e),_(i,t)}}}function Uc(t){let e,n,r,i,o,l,a,s;const c=[Vc,Fc],u=[];function h(t,e){return"categorical"===t[32].kind?0:1}return n=h(t),r=u[n]=c[n](t),o=new Kr({props:{scale:t[6][t[32].feature],y:t[4].bandwidth()-t[14].bottom,showBaseline:!0,baselineColor:"var(--gray-6)",tickColor:"var(--gray-6)",integerOnly:"discrete"===t[9][t[32].feature].subkind,value_map:Qc(t[9][t[32].feature]),label:t[32].feature}}),{c(){e=M("g"),r.c(),i=M("g"),ht(o.$$.fragment),N(i,"class","x-axis"),N(i,"id",l="axis-"+t[32].feature),N(e,"transform",a="translate(0,"+t[4](t[32].feature)+")")},m(t,r){$(t,e,r),u[n].m(e,null),w(e,i),dt(o,i,null),s=!0},p(t,d){let f=n;n=h(t),n===f?u[n].p(t,d):(rt(),lt(u[f],1,1,(()=>{u[f]=null})),it(),r=u[n],r?r.p(t,d):(r=u[n]=c[n](t),r.c()),ot(r,1),r.m(e,i));const p={};68&d[0]&&(p.scale=t[6][t[32].feature]),16&d[0]&&(p.y=t[4].bandwidth()-t[14].bottom),516&d[0]&&(p.integerOnly="discrete"===t[9][t[32].feature].subkind),516&d[0]&&(p.value_map=Qc(t[9][t[32].feature])),4&d[0]&&(p.label=t[32].feature),o.$set(p),(!s||4&d[0]&&l!==(l="axis-"+t[32].feature))&&N(i,"id",l),(!s||20&d[0]&&a!==(a="translate(0,"+t[4](t[32].feature)+")"))&&N(e,"transform",a)},i(t){s||(ot(r),ot(o.$$.fragment,t),s=!0)},o(t){lt(r),lt(o.$$.fragment,t),s=!1},d(t){t&&x(e),u[n].d(),ft(o)}}}function Gc(t){let e,n,r,i,o,l,a,s,c,u,h,d,f=t[5].length+"",p=1===t[5].length?"instance":"instances",g=`${Zc}px`,m=t[13].length>0&&Hc(t),v=t[2],y=[];for(let e=0;e<v.length;e+=1)y[e]=Uc(jc(t,v,e));const b=t=>lt(y[t],1,1,(()=>{y[t]=null}));return{c(){e=k("div"),n=k("div"),m&&m.c(),r=A(),i=k("div"),o=L(f),l=A(),a=L(p),s=L(" selected"),c=A(),u=M("svg"),h=M("g");for(let t=0;t<y.length;t+=1)y[t].c();N(n,"class","controls-container svelte-xk351a"),E(n,"height",g),N(u,"width",t[0]),N(u,"height",t[8])},m(f,p){$(f,e,p),w(e,n),m&&m.m(n,null),w(n,r),w(n,i),w(i,o),w(i,l),w(i,a),w(i,s),w(e,c),w(e,u),w(u,h);for(let t=0;t<y.length;t+=1)y[t].m(h,null);t[27](h),d=!0},p(t,e){if(t[13].length>0?m?m.p(t,e):(m=Hc(t),m.c(),m.m(n,r)):m&&(m.d(1),m=null),(!d||32&e[0])&&f!==(f=t[5].length+"")&&T(o,f),(!d||32&e[0])&&p!==(p=1===t[5].length?"instance":"instances")&&T(a,p),57046&e[0]){let n;for(v=t[2],n=0;n<v.length;n+=1){const r=jc(t,v,n);y[n]?(y[n].p(r,e),ot(y[n],1)):(y[n]=Uc(r),y[n].c(),ot(y[n],1),y[n].m(h,null))}for(rt(),n=v.length;n<y.length;n+=1)b(n);it()}(!d||1&e[0])&&N(u,"width",t[0]),(!d||256&e[0])&&N(u,"height",t[8])},i(t){if(!d){for(let t=0;t<v.length;t+=1)ot(y[t]);d=!0}},o(t){y=y.filter(Boolean);for(let t=0;t<y.length;t+=1)lt(y[t]);d=!1},d(n){n&&x(e),m&&m.d(),_(y,n),t[27](null)}}}const Zc=20;function Jc(t){return"categorical"===t.kind}function Qc(t){return"value_map"in t?t.value_map:{}}function tu(t){return t&&"bandwidth"in t?t.bandwidth():0}function eu(t,e){var n;return e&&null!==(n=e(t))&&void 0!==n?n:0}function nu(t,e,n){let r,i,o,l,a,s,c,u,h,d,f,g,m,v,y,w,b;p(t,Cn,(t=>n(24,y=t))),p(t,Nn,(t=>n(9,w=t))),p(t,Tn,(t=>n(25,b=t)));let{pd:$}=e,{width:x}=e,{height:_}=e,{features:k}=e;const M={top:10,right:5,bottom:40,left:50};let L=!1,A=[];const z=new Map,S=I();function N({selection:t}){const e=this.id.split("-",2)[1];if(null===t)z.delete(e);else{const[n,r]=t,i=h[e];if("bandwidth"in i){const t=i.domain().filter((t=>{var e;const o=null!==(e=i(t))&&void 0!==e?e:0,l=o+i.bandwidth();return n<=l&&r>=o}));z.set(e,{kind:"categorical",categories:t})}else{const t=i.invert(n),o=i.invert(r);z.set(e,{kind:"quantitative",left:t,right:o})}}n(5,c=s.filter((t=>Array.from(z).every((([e,n])=>{const r=w[e];if("quantitative"===n.kind&&"quantitative"===r.kind){const r=y[e][t];return r>=n.left&&r<=n.right}if("categorical"===n.kind&&"categorical"===r.kind){const r=y[e][t];return n.categories.includes(r)}return!1}))))),S("filter",c)}let C,T;return t.$$set=t=>{"pd"in t&&n(16,$=t.pd),"width"in t&&n(0,x=t.width),"height"in t&&n(17,_=t.height),"features"in t&&n(18,k=t.features)},t.$$.update=()=>{131072&t.$$.dirty[0]&&n(8,r=_-Zc),65536&t.$$.dirty[0]&&n(21,i=bn($.ice.clusters.length)),262656&t.$$.dirty[0]&&n(13,o=k.filter((t=>"categorical"===w[t].kind))),2097152&t.$$.dirty[0]&&n(12,l=lr().domain(i).range(Ln)),262400&t.$$.dirty[0]&&n(4,a=ar().domain(k).range([0,r])),33554432&t.$$.dirty[0]&&(s=bn(b)),33554432&t.$$.dirty[0]&&n(5,c=bn(b)),2097154&t.$$.dirty[0]&&n(23,u=function(){var t=yr([]),e=gc,n=pc,r=mc;function i(i){var o,l,a=Array.from(t.apply(this,arguments),vc),s=a.length,c=-1;for(const t of i)for(o=0,++c;o<s;++o)(a[o][c]=[0,+r(t,a[o].key,c,i)]).data=t;for(o=0,l=vr(e(a));o<s;++o)a[l[o]].index=o;return n(a,l),a}return i.keys=function(e){return arguments.length?(t="function"==typeof e?e:yr(Array.from(e)),i):t},i.value=function(t){return arguments.length?(r="function"==typeof t?t:yr(+t),i):r},i.order=function(t){return arguments.length?(e=null==t?gc:"function"==typeof t?t:yr(Array.from(t)),i):e},i.offset=function(t){return arguments.length?(n=null==t?pc:t,i):n},i}().keys(i).value(((t,e)=>{var n;return null!==(n=t[1].get(e))&&void 0!==n?n:0})).offset(L?yc:pc)),262657&t.$$.dirty[0]&&n(6,h=Object.fromEntries(k.map((t=>{const e=w[t];return[t,"quantitative"===e.kind?tn().domain([e.values[0],e.values[e.values.length-1]]).range([M.left,x-M.right]):ar().domain(e.values).range([M.left,x-M.right])]})))),25494048&t.$$.dirty[0]&&n(2,A=k.map((t=>{if("categorical"===w[t].kind){const e=wn(c,(t=>t.length),(e=>y[t][e]),(t=>$.ice.cluster_labels[t]));return{feature:t,kind:"categorical",data:u(Array.from(e))}}{const e=wn(c,(e=>{var n,r,i,o,l;const a=e.map((e=>y[t][e])).sort(me);let s=[];if(a.length>1){const t=function(t,e,n){var r,i;return r=Cc.gaussian,i=Tc.nrd(t),function(e){var n=0,o=0;for(n=0;n<t.length;n++)o+=r((e-t[n])/i);return o/i/t.length}}(a),e=Be(a[0],a[a.length-1],20);e[0]!==a[0]&&e.unshift(a[0]),e[e.length-1]!==a[a.length-1]&&e.push(a[a.length-1]),s=e.map((e=>({x:e,density:t(e)})))}const c=null!==(n=fc(a,.5))&&void 0!==n?n:0,u=null!==(r=fc(a,.25))&&void 0!==r?r:0,h=null!==(i=fc(a,.75))&&void 0!==i?i:0,d=h-u,f=u-1.5*d,p=h+1.5*d;return{low:null!==(o=Mr(a,(t=>t>=f?t:Number.POSITIVE_INFINITY)))&&void 0!==o?o:0,q1:u,median:c,q3:h,high:null!==(l=dc(a,(t=>t<=p?t:Number.NEGATIVE_INFINITY)))&&void 0!==l?l:0,densities:s}}),(t=>$.ice.cluster_labels[t]));return{feature:t,kind:"quantitative",data:Array.from(e,(([t,e])=>({cluster:t,box:e})))}}}))),4&t.$$.dirty[0]&&n(22,d=Math.max(...A.filter(Jc).map((t=>t.data)).flat(3))),4194322&t.$$.dirty[0]&&n(11,f=tn().domain([0,L?1:d]).range([a.bandwidth()-M.bottom,M.top])),2097168&t.$$.dirty[0]&&n(7,g=ar().domain(i).range([a.bandwidth()-M.bottom,M.top]).padding(.05)),128&t.$$.dirty[0]&&n(10,m=Math.min(5,g.bandwidth()/2)),17&t.$$.dirty[0]&&n(20,v=ws().extent([[M.left,-10+a.bandwidth()-M.bottom],[x-M.right,10+a.bandwidth()-M.bottom]]).on("start brush end",N)),1572872&t.$$.dirty[0]&&C&&(n(19,T=_l(C).selectAll(".x-axis")),T.call(v))},[x,L,A,C,a,c,h,g,r,w,m,f,l,o,M,function(t,e){var n;const r=tn().domain([0,null!==(n=dc(e,(t=>t.density)))&&void 0!==n?n:0]).range([0,g.bandwidth()/2]),i=kr().x((e=>{var n;return null!==(n=t(e.x))&&void 0!==n?n:0})).y0((t=>-r(t.density))).y1((t=>r(t.density)));return i(e)},$,_,k,T,v,i,d,u,y,b,function(){L=this.checked,n(1,L)},function(t){F[t?"unshift":"push"]((()=>{C=t,n(3,C)}))}]}const ru=class extends gt{constructor(t){super(),pt(this,t,nu,Gc,h,{pd:16,width:0,height:17,features:18},Bc,[-1,-1])}};function iu(t){b(t,"svelte-1kkri9t",".zoomed-pdp-container.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{width:100%;height:100%;display:flex;flex-direction:column}.zoomed-pdp-header.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{height:2em;display:flex;align-items:center;background-color:white;gap:1.5em;padding-left:0.5em;padding-right:0.5em;border-bottom:1px solid var(--gray-1)}.feature-selects.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{flex:0 1 auto;min-width:0;display:flex;align-items:center;gap:0.5em}.feature-selects.svelte-1kkri9t label.svelte-1kkri9t.svelte-1kkri9t{flex:0 1 auto;display:flex;align-items:center;gap:0.25em;min-width:0}.feature-selects.svelte-1kkri9t label.svelte-1kkri9t span.svelte-1kkri9t{flex:0 0 auto}.feature-selects.svelte-1kkri9t label.svelte-1kkri9t select.svelte-1kkri9t{flex:0 1 auto;min-width:0;text-overflow:ellipsis}.zoomed-pdp-content.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{flex:1;padding:0.5em}.one-way-pdp-grid.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{display:flex;width:100%;height:100%}.two-way-pdp-grid.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{display:grid;width:100%;height:100%}.label-and-input.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{flex:0 0 auto;display:flex;align-items:center;gap:0.25em}.showOneWay-true-color-both.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{grid-template-rows:1fr 1fr;grid-template-columns:1fr 1fr;grid-template-areas:'one-way-left one-way-right'\n      'two-way-interaction two-way-pdp'}.showOneWay-true-color-interactions.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{grid-template-rows:1fr 1fr;grid-template-columns:1fr 1fr;grid-template-areas:'one-way-left one-way-right'\n      'two-way-interaction two-way-interaction'}.showOneWay-true-color-predictions.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{grid-template-rows:1fr 1fr;grid-template-columns:1fr 1fr;grid-template-areas:'one-way-left one-way-right'\n      'two-way-pdp two-way-pdp'}.showOneWay-false-color-both.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{grid-template-rows:1fr 1fr;grid-template-columns:1fr 1fr;grid-template-areas:'two-way-interaction two-way-pdp'\n      'two-way-interaction two-way-pdp'}.showOneWay-false-color-interactions.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{grid-template-rows:1fr 1fr;grid-template-columns:1fr 1fr;grid-template-areas:'two-way-interaction two-way-interaction'\n      'two-way-interaction two-way-interaction'}.showOneWay-false-color-predictions.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{grid-template-rows:1fr 1fr;grid-template-columns:1fr 1fr;grid-template-areas:'two-way-pdp two-way-pdp'\n      'two-way-pdp two-way-pdp'}.detailed-plot-message-container.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{height:100%;width:100%;align-items:center;justify-content:center;display:flex}.detailed-plot-message-content.svelte-1kkri9t.svelte-1kkri9t.svelte-1kkri9t{width:40em;display:flex;flex-direction:column;justify-content:center;gap:1em}.detailed-plot-message-content.svelte-1kkri9t>button.svelte-1kkri9t.svelte-1kkri9t{margin:auto}")}function ou(t,e,n){const r=t.slice();return r[37]=e[n].value,r[38]=e[n].title,r}function lu(t,e,n){const r=t.slice();return r[41]=e[n],r}function au(t,e,n){const r=t.slice();return r[41]=e[n],r}function su(t){let e,n,r,i=t[41]+"";return{c(){e=k("option"),n=L(i),e.__value=r=t[41],e.value=e.__value},m(t,r){$(t,e,r),w(e,n)},p(t,o){262144&o[0]&&i!==(i=t[41]+"")&&T(n,i),262144&o[0]&&r!==(r=t[41])&&(e.__value=r,e.value=e.__value)},d(t){t&&x(e)}}}function cu(t){let e,n,r,i=t[41]+"";return{c(){e=k("option"),n=L(i),e.__value=r=t[41],e.value=e.__value},m(t,r){$(t,e,r),w(e,n)},p(t,o){262144&o[0]&&i!==(i=t[41]+"")&&T(n,i),262144&o[0]&&r!==(r=t[41])&&(e.__value=r,e.value=e.__value)},d(t){t&&x(e)}}}function uu(t){let e,n,r,i,o,l,a,s,u,h,d,f,p=1===t[0].num_features?"Marginal distribution":"Marginal distributions";function g(t,e){return 2===t[0].num_features?du:hu}let m=g(t),v=m(t);return{c(){e=k("label"),n=k("input"),r=A(),i=L(p),o=A(),l=k("label"),a=k("input"),s=L("Scale locally"),u=A(),v.c(),h=z(),N(n,"type","checkbox"),N(e,"class","label-and-input svelte-1kkri9t"),N(a,"type","checkbox"),N(l,"class","label-and-input svelte-1kkri9t")},m(c,p){$(c,e,p),w(e,n),n.checked=t[10],w(e,r),w(e,i),$(c,o,p),$(c,l,p),w(l,a),a.checked=t[7],w(l,s),$(c,u,p),v.m(c,p),$(c,h,p),d||(f=[S(n,"change",t[28]),S(a,"change",t[29])],d=!0)},p(t,e){1024&e[0]&&(n.checked=t[10]),1&e[0]&&p!==(p=1===t[0].num_features?"Marginal distribution":"Marginal distributions")&&T(i,p),128&e[0]&&(a.checked=t[7]),m===(m=g(t))&&v?v.p(t,e):(v.d(1),v=m(t),v&&(v.c(),v.m(h.parentNode,h)))},d(t){t&&x(e),t&&x(o),t&&x(l),t&&x(u),v.d(t),t&&x(h),d=!1,c(f)}}}function hu(t){let e,n,r,i,o,l,a,s,c=t[19],u=[];for(let e=0;e<c.length;e+=1)u[e]=fu(ou(t,c,e));let h=("cluster-bands"===t[1]||"cluster-lines"===t[1])&&pu(t);return{c(){e=k("label"),n=k("span"),n.textContent="ICE:",r=A(),i=k("select");for(let t=0;t<u.length;t+=1)u[t].c();o=A(),h&&h.c(),l=z(),N(n,"class","svelte-1kkri9t"),N(i,"class","svelte-1kkri9t"),void 0===t[1]&&K((()=>t[32].call(i))),N(e,"class","label-and-input svelte-1kkri9t")},m(c,d){$(c,e,d),w(e,n),w(e,r),w(e,i);for(let t=0;t<u.length;t+=1)u[t].m(i,null);D(i,t[1]),$(c,o,d),h&&h.m(c,d),$(c,l,d),a||(s=S(i,"change",t[32]),a=!0)},p(t,e){if(524288&e[0]){let n;for(c=t[19],n=0;n<c.length;n+=1){const r=ou(t,c,n);u[n]?u[n].p(r,e):(u[n]=fu(r),u[n].c(),u[n].m(i,null))}for(;n<u.length;n+=1)u[n].d(1);u.length=c.length}524290&e[0]&&D(i,t[1]),"cluster-bands"===t[1]||"cluster-lines"===t[1]?h?h.p(t,e):(h=pu(t),h.c(),h.m(l.parentNode,l)):h&&(h.d(1),h=null)},d(t){t&&x(e),_(u,t),t&&x(o),h&&h.d(t),t&&x(l),a=!1,s()}}}function du(t){let e,n,r,i,o,l,a,s,u,h,d,f;return{c(){e=k("label"),n=k("input"),r=L("One-way plots"),i=A(),o=k("label"),l=L("Color\n          "),a=k("select"),s=k("option"),s.textContent="both",u=k("option"),u.textContent="interactions",h=k("option"),h.textContent="predictions",N(n,"type","checkbox"),N(e,"class","label-and-input svelte-1kkri9t"),s.__value="both",s.value=s.__value,u.__value="interactions",u.value=u.__value,h.__value="predictions",h.value=h.__value,N(a,"class","svelte-1kkri9t"),void 0===t[12]&&K((()=>t[31].call(a))),N(o,"class","label-and-input svelte-1kkri9t")},m(c,p){$(c,e,p),w(e,n),n.checked=t[11],w(e,r),$(c,i,p),$(c,o,p),w(o,l),w(o,a),w(a,s),w(a,u),w(a,h),D(a,t[12]),d||(f=[S(n,"change",t[30]),S(a,"change",t[31])],d=!0)},p(t,e){2048&e[0]&&(n.checked=t[11]),4096&e[0]&&D(a,t[12])},d(t){t&&x(e),t&&x(i),t&&x(o),d=!1,c(f)}}}function fu(t){let e,n,r,i=t[38]+"";return{c(){e=k("option"),n=L(i),e.__value=r=t[37],e.value=e.__value},m(t,r){$(t,e,r),w(e,n)},p:l,d(t){t&&x(e)}}}function pu(t){let e,n,r,i,o;return{c(){e=k("label"),n=k("input"),r=L("Describe clusters"),N(n,"type","checkbox"),N(e,"class","label-and-input svelte-1kkri9t")},m(l,a){$(l,e,a),w(e,n),n.checked=t[2],w(e,r),i||(o=S(n,"change",t[33]),i=!0)},p(t,e){4&e[0]&&(n.checked=t[2])},d(t){t&&x(e),i=!1,o()}}}function gu(t){let e,n,r,i,o,l=null!==t[8]&&null!==t[9]&&t[11]&&yu(t),a=("both"===t[12]||"interactions"===t[12])&&wu(t),s=("both"===t[12]||"predictions"===t[12])&&bu(t);return{c(){e=k("div"),l&&l.c(),n=A(),a&&a.c(),r=A(),s&&s.c(),N(e,"class",i="two-way-pdp-grid showOneWay-"+(null!==t[8]&&null!==t[9]&&t[11])+"-color-"+t[12]+" svelte-1kkri9t")},m(t,i){$(t,e,i),l&&l.m(e,null),w(e,n),a&&a.m(e,null),w(e,r),s&&s.m(e,null),o=!0},p(t,c){null!==t[8]&&null!==t[9]&&t[11]?l?(l.p(t,c),2816&c[0]&&ot(l,1)):(l=yu(t),l.c(),ot(l,1),l.m(e,n)):l&&(rt(),lt(l,1,1,(()=>{l=null})),it()),"both"===t[12]||"interactions"===t[12]?a?(a.p(t,c),4096&c[0]&&ot(a,1)):(a=wu(t),a.c(),ot(a,1),a.m(e,r)):a&&(rt(),lt(a,1,1,(()=>{a=null})),it()),"both"===t[12]||"predictions"===t[12]?s?(s.p(t,c),4096&c[0]&&ot(s,1)):(s=bu(t),s.c(),ot(s,1),s.m(e,null)):s&&(rt(),lt(s,1,1,(()=>{s=null})),it()),(!o||6912&c[0]&&i!==(i="two-way-pdp-grid showOneWay-"+(null!==t[8]&&null!==t[9]&&t[11])+"-color-"+t[12]+" svelte-1kkri9t"))&&N(e,"class",i)},i(t){o||(ot(l),ot(a),ot(s),o=!0)},o(t){lt(l),lt(a),lt(s),o=!1},d(t){t&&x(e),l&&l.d(),a&&a.d(),s&&s.d()}}}function mu(t){let e,n,r,i,o;r=new hc({props:{pd:t[0],width:t[2]?t[16]:t[3],height:t[4],scaleLocally:t[7],showMarginalDistribution:t[10],marginTop:t[10]?100:10,marginRight:10,iceLevel:t[1],indices:t[14],showColorLegend:!1}});let l=t[2]&&$u(t);return{c(){e=k("div"),n=k("div"),ht(r.$$.fragment),i=A(),l&&l.c(),E(n,"flex","1"),N(e,"class","one-way-pdp-grid svelte-1kkri9t")},m(t,a){$(t,e,a),w(e,n),dt(r,n,null),w(e,i),l&&l.m(e,null),o=!0},p(t,n){const i={};1&n[0]&&(i.pd=t[0]),65548&n[0]&&(i.width=t[2]?t[16]:t[3]),16&n[0]&&(i.height=t[4]),128&n[0]&&(i.scaleLocally=t[7]),1024&n[0]&&(i.showMarginalDistribution=t[10]),1024&n[0]&&(i.marginTop=t[10]?100:10),2&n[0]&&(i.iceLevel=t[1]),16384&n[0]&&(i.indices=t[14]),r.$set(i),t[2]?l?(l.p(t,n),4&n[0]&&ot(l,1)):(l=$u(t),l.c(),ot(l,1),l.m(e,null)):l&&(rt(),lt(l,1,1,(()=>{l=null})),it())},i(t){o||(ot(r.$$.fragment,t),ot(l),o=!0)},o(t){lt(r.$$.fragment,t),lt(l),o=!1},d(t){t&&x(e),ft(r),l&&l.d()}}}function vu(t){let e,n;function r(t,e){return""===t[6]&&""===t[5]?_u:xu}let i=r(t),o=i(t);return{c(){e=k("div"),n=k("div"),o.c(),N(n,"class","detailed-plot-message-content svelte-1kkri9t"),N(e,"class","detailed-plot-message-container svelte-1kkri9t")},m(t,r){$(t,e,r),w(e,n),o.m(n,null)},p(t,e){i===(i=r(t))&&o?o.p(t,e):(o.d(1),o=i(t),o&&(o.c(),o.m(n,null)))},i:l,o:l,d(t){t&&x(e),o.d()}}}function yu(t){let e,n,r,i,o,l;return n=new hc({props:{pd:t[8],width:t[16],height:t[15],scaleLocally:t[7],showMarginalDistribution:t[10],marginTop:t[10]?100:10,marginRight:10,iceLevel:"lines"}}),o=new hc({props:{pd:t[9],width:t[16],height:t[15],scaleLocally:t[7],showMarginalDistribution:t[10],marginTop:t[10]?100:10,marginRight:10,iceLevel:"lines"}}),{c(){e=k("div"),ht(n.$$.fragment),r=A(),i=k("div"),ht(o.$$.fragment),E(e,"grid-area","one-way-left"),E(i,"grid-area","one-way-right")},m(t,a){$(t,e,a),dt(n,e,null),$(t,r,a),$(t,i,a),dt(o,i,null),l=!0},p(t,e){const r={};256&e[0]&&(r.pd=t[8]),65536&e[0]&&(r.width=t[16]),32768&e[0]&&(r.height=t[15]),128&e[0]&&(r.scaleLocally=t[7]),1024&e[0]&&(r.showMarginalDistribution=t[10]),1024&e[0]&&(r.marginTop=t[10]?100:10),n.$set(r);const i={};512&e[0]&&(i.pd=t[9]),65536&e[0]&&(i.width=t[16]),32768&e[0]&&(i.height=t[15]),128&e[0]&&(i.scaleLocally=t[7]),1024&e[0]&&(i.showMarginalDistribution=t[10]),1024&e[0]&&(i.marginTop=t[10]?100:10),o.$set(i)},i(t){l||(ot(n.$$.fragment,t),ot(o.$$.fragment,t),l=!0)},o(t){lt(n.$$.fragment,t),lt(o.$$.fragment,t),l=!1},d(t){t&&x(e),ft(n),t&&x(r),t&&x(i),ft(o)}}}function wu(t){let e,n,r;return n=new hc({props:{pd:t[0],width:"both"===t[12]?t[16]:t[3],height:null!==t[8]&&null!==t[9]&&t[11]?t[15]:t[4],scaleLocally:t[7],showMarginalDistribution:t[10],marginTop:t[10]?100:10,marginRight:t[10]?100:10,iceLevel:"lines",colorShows:"interactions",showColorLegend:!0}}),{c(){e=k("div"),ht(n.$$.fragment),E(e,"grid-area","two-way-interaction")},m(t,i){$(t,e,i),dt(n,e,null),r=!0},p(t,e){const r={};1&e[0]&&(r.pd=t[0]),69640&e[0]&&(r.width="both"===t[12]?t[16]:t[3]),35600&e[0]&&(r.height=null!==t[8]&&null!==t[9]&&t[11]?t[15]:t[4]),128&e[0]&&(r.scaleLocally=t[7]),1024&e[0]&&(r.showMarginalDistribution=t[10]),1024&e[0]&&(r.marginTop=t[10]?100:10),1024&e[0]&&(r.marginRight=t[10]?100:10),n.$set(r)},i(t){r||(ot(n.$$.fragment,t),r=!0)},o(t){lt(n.$$.fragment,t),r=!1},d(t){t&&x(e),ft(n)}}}function bu(t){let e,n,r;return n=new hc({props:{pd:t[0],width:"both"===t[12]?t[16]:t[3],height:null!==t[8]&&null!==t[9]&&t[11]?t[15]:t[4],scaleLocally:t[7],showMarginalDistribution:t[10],marginTop:t[10]?100:10,marginRight:t[10]?100:10,iceLevel:t[1],showColorLegend:!0}}),{c(){e=k("div"),ht(n.$$.fragment),E(e,"grid-area","two-way-pdp")},m(t,i){$(t,e,i),dt(n,e,null),r=!0},p(t,e){const r={};1&e[0]&&(r.pd=t[0]),69640&e[0]&&(r.width="both"===t[12]?t[16]:t[3]),35600&e[0]&&(r.height=null!==t[8]&&null!==t[9]&&t[11]?t[15]:t[4]),128&e[0]&&(r.scaleLocally=t[7]),1024&e[0]&&(r.showMarginalDistribution=t[10]),1024&e[0]&&(r.marginTop=t[10]?100:10),1024&e[0]&&(r.marginRight=t[10]?100:10),2&e[0]&&(r.iceLevel=t[1]),n.$set(r)},i(t){r||(ot(n.$$.fragment,t),r=!0)},o(t){lt(n.$$.fragment,t),r=!1},d(t){t&&x(e),ft(n)}}}function $u(t){let e,n,r;return n=new ru({props:{pd:t[0],width:t[16],height:t[4],features:t[0].ice.interacting_features}}),n.$on("filter",t[21]),{c(){e=k("div"),ht(n.$$.fragment),E(e,"flex","1")},m(t,i){$(t,e,i),dt(n,e,null),r=!0},p(t,e){const r={};1&e[0]&&(r.pd=t[0]),65536&e[0]&&(r.width=t[16]),16&e[0]&&(r.height=t[4]),1&e[0]&&(r.features=t[0].ice.interacting_features),n.$set(r)},i(t){r||(ot(n.$$.fragment,t),r=!0)},o(t){lt(n.$$.fragment,t),r=!1},d(t){t&&x(e),ft(n)}}}function xu(t){let e,n,r,i,o,l,a,s,c,u,h,d,f=2===t[17].length?"Computing...":"Compute Now";return{c(){e=k("div"),n=L("The two-way PDP between "),r=L(t[6]),i=L(" and "),o=L(t[5]),l=L("\n              was not pre-computed, since we did not detect a likely interaction\n              between the two features."),a=A(),s=k("button"),c=L(f),s.disabled=u=2===t[17].length,N(s,"class","svelte-1kkri9t")},m(u,f){$(u,e,f),w(e,n),w(e,r),w(e,i),w(e,o),w(e,l),$(u,a,f),$(u,s,f),w(s,c),h||(d=S(s,"click",t[20]),h=!0)},p(t,e){64&e[0]&&T(r,t[6]),32&e[0]&&T(o,t[5]),131072&e[0]&&f!==(f=2===t[17].length?"Computing...":"Compute Now")&&T(c,f),131072&e[0]&&u!==(u=2===t[17].length)&&(s.disabled=u)},d(t){t&&x(e),t&&x(a),t&&x(s),h=!1,d()}}}function _u(t){let e;return{c(){e=k("div"),e.textContent="Select one or two features above.",E(e,"text-align","center")},m(t,n){$(t,e,n)},p:l,d(t){t&&x(e)}}}function ku(t){let e,n,r,i,o,l,a,s,u,h,d,f,p,g,m,v,y,b,M,L,z,C,T=t[18],O=[];for(let e=0;e<T.length;e+=1)O[e]=su(au(t,T,e));let E=t[18],R=[];for(let e=0;e<E.length;e+=1)R[e]=cu(lu(t,E,e));let B=t[0]&&uu(t);const j=[vu,mu,gu],q=[];function P(t,e){return null===t[0]?0:1===t[0].num_features?1:2}return b=P(t),M=q[b]=j[b](t),{c(){e=k("div"),n=k("div"),r=k("div"),i=k("label"),o=k("span"),o.textContent="Feat. 1",l=A(),a=k("select"),s=k("option");for(let t=0;t<O.length;t+=1)O[t].c();u=A(),h=k("label"),d=k("span"),d.textContent="Feat. 2",f=A(),p=k("select"),g=k("option");for(let t=0;t<R.length;t+=1)R[t].c();m=A(),B&&B.c(),v=A(),y=k("div"),M.c(),N(o,"class","svelte-1kkri9t"),s.__value="",s.value=s.__value,N(a,"class","svelte-1kkri9t"),void 0===t[6]&&K((()=>t[26].call(a))),N(i,"class","svelte-1kkri9t"),N(d,"class","svelte-1kkri9t"),g.__value="",g.value=g.__value,N(p,"class","svelte-1kkri9t"),void 0===t[5]&&K((()=>t[27].call(p))),N(h,"class","svelte-1kkri9t"),N(r,"class","feature-selects svelte-1kkri9t"),N(n,"class","zoomed-pdp-header svelte-1kkri9t"),N(y,"class","zoomed-pdp-content svelte-1kkri9t"),N(e,"class","zoomed-pdp-container svelte-1kkri9t")},m(c,x){$(c,e,x),w(e,n),w(n,r),w(r,i),w(i,o),w(i,l),w(i,a),w(a,s);for(let t=0;t<O.length;t+=1)O[t].m(a,null);D(a,t[6]),w(r,u),w(r,h),w(h,d),w(h,f),w(h,p),w(p,g);for(let t=0;t<R.length;t+=1)R[t].m(p,null);D(p,t[5]),w(n,m),B&&B.m(n,null),w(e,v),w(e,y),q[b].m(y,null),t[34](y),L=!0,z||(C=[S(a,"change",t[26]),S(p,"change",t[27])],z=!0)},p(t,e){if(262144&e[0]){let n;for(T=t[18],n=0;n<T.length;n+=1){const r=au(t,T,n);O[n]?O[n].p(r,e):(O[n]=su(r),O[n].c(),O[n].m(a,null))}for(;n<O.length;n+=1)O[n].d(1);O.length=T.length}if(262208&e[0]&&D(a,t[6]),262144&e[0]){let n;for(E=t[18],n=0;n<E.length;n+=1){const r=lu(t,E,n);R[n]?R[n].p(r,e):(R[n]=cu(r),R[n].c(),R[n].m(p,null))}for(;n<R.length;n+=1)R[n].d(1);R.length=E.length}262176&e[0]&&D(p,t[5]),t[0]?B?B.p(t,e):(B=uu(t),B.c(),B.m(n,null)):B&&(B.d(1),B=null);let r=b;b=P(t),b===r?q[b].p(t,e):(rt(),lt(q[r],1,1,(()=>{q[r]=null})),it(),M=q[b],M?M.p(t,e):(M=q[b]=j[b](t),M.c()),ot(M,1),M.m(y,null))},i(t){L||(ot(M),L=!0)},o(t){lt(M),L=!1},d(n){n&&x(e),_(O,n),_(R,n),B&&B.d(),q[b].d(),t[34](null),z=!1,c(C)}}}function Mu(t,e,n){let r,i,o,l,a,s,c,u;var h,d;p(t,Gn,(t=>n(24,o=t))),p(t,En,(t=>n(25,l=t))),p(t,Wn,(t=>n(5,a=t))),p(t,Xn,(t=>n(6,s=t))),p(t,Fn,(t=>n(17,c=t))),p(t,Sn,(t=>n(18,u=t)));let f=null,g=!1,v="lines";const y=[{value:"lines",title:"Lines"},{value:"cluster-lines",title:"Cluster Lines"},{value:"cluster-bands",title:"Cluster Bands"},{value:"cluster-centers",title:"Cluster Centers"}];let w,b,$,x=null,_=null,k=!1,M=!1,L=!0,A="both";P((()=>{const t=new ResizeObserver((t=>{if(1!==t.length)return;const e=t[0];if(e.contentBoxSize){const t=Array.isArray(e.contentBoxSize)?e.contentBoxSize[0]:e.contentBoxSize;n(3,b=t.inlineSize),n(4,$=t.blockSize)}else n(3,b=e.contentRect.width),n(4,$=e.contentRect.height)}));return t.observe(w),()=>t.unobserve(w)}));let z=null;return t.$$.update=()=>{96&t.$$.dirty[0]&&function(){var t,e;s===a&&m(Wn,a="",a),""===s&&""!==a&&(m(Xn,s=a,s),m(Wn,a="",a)),n(0,f=""===a?null!==(t=o.get(s))&&void 0!==t?t:null:null!==(e=l.find((t=>t.x_feature===s&&t.y_feature===a||t.x_feature===a&&t.y_feature===s)))&&void 0!==e?e:null)}(),33554432&t.$$.dirty[0]&&l&&function(){const t=l.find((t=>t.x_feature===c[0]&&t.y_feature===c[1]||t.x_feature===c[1]&&t.y_feature===c[0]));t&&(2===c.length&&c[0]===s&&c[1]===a&&n(0,f=t),m(Fn,c=[],c))}(),29360129&t.$$.dirty[0]&&f&&2===f.num_features&&(n(8,x=null!==n(22,h=o.get(f.x_feature))&&void 0!==h?h:null),n(9,_=null!==n(23,d=o.get(f.y_feature))&&void 0!==d?d:null)),2&t.$$.dirty[0]&&"cluster-bands"!==v&&"cluster-lines"!==v&&n(2,k=!1),8&t.$$.dirty[0]&&n(16,r=b/2),16&t.$$.dirty[0]&&n(15,i=$/2),4&t.$$.dirty[0]&&(k||n(14,z=null))},[f,v,k,b,$,a,s,g,x,_,M,L,A,w,z,i,r,c,u,y,function(){m(Fn,c=[s,a],c)},function(t){n(14,z=t.detail)},h,d,o,l,function(){s=R(this),Xn.set(s)},function(){a=R(this),Wn.set(a)},function(){M=this.checked,n(10,M)},function(){g=this.checked,n(7,g)},function(){L=this.checked,n(11,L)},function(){A=R(this),n(12,A)},function(){v=R(this),n(1,v),n(19,y)},function(){k=this.checked,n(2,k),n(1,v)},function(t){F[t?"unshift":"push"]((()=>{w=t,n(13,w)}))}]}const Lu=class extends gt{constructor(t){super(),pt(this,t,Mu,ku,h,{},iu,[-1,-1])}};function Au(t){b(t,"svelte-kiv6ja",".controls-features.svelte-kiv6ja.svelte-kiv6ja{display:flex;flex-direction:column;max-height:100%;row-gap:0.25em}ul.svelte-kiv6ja.svelte-kiv6ja{list-style:none}.fs-row.svelte-kiv6ja.svelte-kiv6ja{display:flex;align-items:center;column-gap:0.25em}input.svelte-kiv6ja.svelte-kiv6ja{min-width:0}.fs-row.svelte-kiv6ja label.svelte-kiv6ja{flex:1}.individual-features.svelte-kiv6ja.svelte-kiv6ja{flex:0 1 auto;overflow-y:scroll;min-height:0}.hidden.svelte-kiv6ja.svelte-kiv6ja{display:none}")}function zu(t,e,n){const r=t.slice();return r[19]=e[n].feature,r[20]=e[n].hidden,r[21]=e[n].disabled,r}function Su(t,e){let n,r,i,o,l,a,s,u,h,d,f,p,g,m=e[19]+"";function v(){return e[14](e[19])}return{key:t,first:null,c(){n=k("li"),r=k("input"),a=A(),s=k("label"),u=L(m),f=A(),N(r,"id",i=e[19]+"-checkbox"),N(r,"type","checkbox"),N(r,"name","features"),r.__value=o=e[19],r.value=r.__value,r.disabled=l=e[21],N(r,"class","svelte-kiv6ja"),e[13][0].push(r),N(s,"class","cutoff svelte-kiv6ja"),N(s,"for",h=e[19]+"-checkbox"),N(s,"title",d=e[19]),N(n,"class","fs-row svelte-kiv6ja"),B(n,"hidden",e[20]),this.first=n},m(t,i){$(t,n,i),w(n,r),r.checked=~e[1].indexOf(r.__value),w(n,a),w(n,s),w(s,u),w(n,f),p||(g=[S(r,"change",e[12]),S(r,"change",v)],p=!0)},p(t,a){e=t,16&a&&i!==(i=e[19]+"-checkbox")&&N(r,"id",i),16&a&&o!==(o=e[19])&&(r.__value=o,r.value=r.__value),16&a&&l!==(l=e[21])&&(r.disabled=l),2&a&&(r.checked=~e[1].indexOf(r.__value)),16&a&&m!==(m=e[19]+"")&&T(u,m),16&a&&h!==(h=e[19]+"-checkbox")&&N(s,"for",h),16&a&&d!==(d=e[19])&&N(s,"title",d),16&a&&B(n,"hidden",e[20])},d(t){t&&x(n),e[13][0].splice(e[13][0].indexOf(r),1),p=!1,c(g)}}}function Nu(t){let e,n,r,i,o,a,s,u,h,d,f,p,g,m,v,y=[],b=new Map,_=t[4];const M=t=>t[19];for(let e=0;e<_.length;e+=1){let n=zu(t,_,e),r=M(n);b.set(r,y[e]=Su(r,n))}return{c(){e=k("div"),n=k("ul"),r=k("li"),i=k("input"),a=A(),s=k("label"),s.textContent="All features",u=A(),h=k("label"),d=L("Search\n    "),f=k("input"),p=A(),g=k("ul");for(let t=0;t<y.length;t+=1)y[t].c();N(i,"id","features-checkbox"),N(i,"type","checkbox"),i.indeterminate=t[3],i.disabled=o=""!==t[0]||!t[5],N(i,"class","svelte-kiv6ja"),N(s,"for","features-checkbox"),N(s,"class","svelte-kiv6ja"),N(r,"class","fs-row svelte-kiv6ja"),N(n,"class","svelte-kiv6ja"),N(f,"class","svelte-kiv6ja"),N(h,"class","fs-row svelte-kiv6ja"),N(g,"class","individual-features svelte-kiv6ja"),N(e,"class","controls-features svelte-kiv6ja")},m(o,l){$(o,e,l),w(e,n),w(n,r),w(r,i),i.checked=t[2],w(r,a),w(r,s),w(e,u),w(e,h),w(h,d),w(h,f),O(f,t[0]),w(e,p),w(e,g);for(let t=0;t<y.length;t+=1)y[t].m(g,null);m||(v=[S(i,"change",t[10]),S(i,"change",t[6]),S(f,"input",t[11])],m=!0)},p(t,[e]){8&e&&(i.indeterminate=t[3]),33&e&&o!==(o=""!==t[0]||!t[5])&&(i.disabled=o),4&e&&(i.checked=t[2]),1&e&&f.value!==t[0]&&O(f,t[0]),146&e&&(_=t[4],y=ct(y,e,M,1,t,_,b,g,at,Su,null,zu))},i:l,o:l,d(t){t&&x(e);for(let t=0;t<y.length;t+=1)y[t].d();m=!1,c(v)}}}function Cu(t,e,n){let r,i,o;p(t,Sn,(t=>n(9,o=t)));let{enabledFeatures:l}=e;const a=I();let s=!0,c=!1,u="",h=o,d=new Set;function f(){0===h.length?(n(2,s=!1),n(3,c=!1)):h.length===o.length?(n(2,s=!0),n(3,c=!1)):h.length>0&&h.length<o.length&&(n(2,s=!0),n(3,c=!0))}function g(t){h.includes(t)?d.delete(t):d.add(t)}const m=[[]];return t.$$set=t=>{"enabledFeatures"in t&&n(8,l=t.enabledFeatures)},t.$$.update=()=>{256&t.$$.dirty&&function(t){n(1,h=o.filter((e=>t.includes(e)&&!d.has(e)))),f(),a("changeNameFilters",h)}(l),768&t.$$.dirty&&n(5,r=l.length===o.length),769&t.$$.dirty&&n(4,i=o.map((t=>({feature:t,hidden:!t.includes(u),disabled:!l.includes(t)})))),2&t.$$.dirty&&(f(),a("changeNameFilters",h))},[u,h,s,c,i,r,function(){s?(n(1,h=o),n(3,c=!1)):(n(1,h=[]),n(3,c=!1)),d=new Set},g,l,o,function(){s=this.checked,n(2,s)},function(){u=this.value,n(0,u)},function(){h=C(m[0],this.__value,this.checked),n(1,h)},m,t=>g(t)]}const Tu=class extends gt{constructor(t){super(),pt(this,t,Cu,Nu,h,{enabledFeatures:8},Au)}};function Ou(t){b(t,"svelte-zyfurg","ul.svelte-zyfurg.svelte-zyfurg{list-style:none}.label-and-input.svelte-zyfurg.svelte-zyfurg{display:flex;align-items:center;gap:0.25em}ul.svelte-zyfurg ul.svelte-zyfurg{margin-left:1em}")}function Eu(t){let e,n,r,i,o,a,s,u,h,d,f,p,g,m,v,y,b,_,M,L,z,C,T,O,E,D,R,B;return{c(){e=k("div"),n=k("ul"),r=k("li"),i=k("label"),o=k("input"),s=k("span"),s.textContent="Ordered",u=A(),h=k("ul"),d=k("li"),f=k("label"),p=k("input"),g=k("span"),g.textContent="Increasing",m=A(),v=k("label"),y=k("input"),b=k("span"),b.textContent="Decreasing",_=A(),M=k("label"),L=k("input"),z=k("span"),z.textContent="Mixed",C=A(),T=k("li"),O=k("label"),E=k("input"),D=k("span"),D.textContent="Nominal",N(o,"type","checkbox"),o.indeterminate=a=t[0].ordered.shapes.length>0&&t[0].ordered.shapes.length<t[1].length,N(i,"class","label-and-input svelte-zyfurg"),N(p,"type","checkbox"),p.__value="increasing",p.value=p.__value,t[6][0].push(p),N(f,"class","label-and-input svelte-zyfurg"),N(y,"type","checkbox"),y.__value="decreasing",y.value=y.__value,t[6][0].push(y),N(v,"class","label-and-input svelte-zyfurg"),N(L,"type","checkbox"),L.__value="mixed",L.value=L.__value,t[6][0].push(L),N(M,"class","label-and-input svelte-zyfurg"),N(h,"class","svelte-zyfurg"),N(E,"type","checkbox"),N(O,"class","label-and-input svelte-zyfurg"),N(n,"class","svelte-zyfurg")},m(l,a){$(l,e,a),w(e,n),w(n,r),w(r,i),w(i,o),o.checked=t[0].ordered.checked,w(i,s),w(r,u),w(r,h),w(h,d),w(d,f),w(f,p),p.checked=~t[0].ordered.shapes.indexOf(p.__value),w(f,g),w(d,m),w(d,v),w(v,y),y.checked=~t[0].ordered.shapes.indexOf(y.__value),w(v,b),w(d,_),w(d,M),w(M,L),L.checked=~t[0].ordered.shapes.indexOf(L.__value),w(M,z),w(n,C),w(n,T),w(T,O),w(O,E),E.checked=t[0].nominal.checked,w(O,D),R||(B=[S(o,"change",t[4]),S(o,"change",t[2]),S(p,"change",t[5]),S(p,"change",t[3]),S(y,"change",t[7]),S(y,"change",t[3]),S(L,"change",t[8]),S(L,"change",t[3]),S(E,"change",t[9])],R=!0)},p(t,[e]){1&e&&a!==(a=t[0].ordered.shapes.length>0&&t[0].ordered.shapes.length<t[1].length)&&(o.indeterminate=a),1&e&&(o.checked=t[0].ordered.checked),1&e&&(p.checked=~t[0].ordered.shapes.indexOf(p.__value)),1&e&&(y.checked=~t[0].ordered.shapes.indexOf(y.__value)),1&e&&(L.checked=~t[0].ordered.shapes.indexOf(L.__value)),1&e&&(E.checked=t[0].nominal.checked)},i:l,o:l,d(n){n&&x(e),t[6][0].splice(t[6][0].indexOf(p),1),t[6][0].splice(t[6][0].indexOf(y),1),t[6][0].splice(t[6][0].indexOf(L),1),R=!1,c(B)}}}function Du(t,e,n){let r=["increasing","decreasing","mixed"],i={ordered:{checked:!0,shapes:r},nominal:{checked:!0}};const o=I();P((()=>{o("changeKindFilters",i)}));const l=[[]];return t.$$.update=()=>{1&t.$$.dirty&&o("changeKindFilters",i)},[i,r,function(){i.ordered.checked?n(0,i.ordered.shapes=r,i):n(0,i.ordered.shapes=[],i)},function(){n(0,i.ordered.checked=0!==i.ordered.shapes.length,i)},function(){i.ordered.checked=this.checked,n(0,i)},function(){i.ordered.shapes=C(l[0],this.__value,this.checked),n(0,i)},l,function(){i.ordered.shapes=C(l[0],this.__value,this.checked),n(0,i)},function(){i.ordered.shapes=C(l[0],this.__value,this.checked),n(0,i)},function(){i.nominal.checked=this.checked,n(0,i)}]}const Ru=class extends gt{constructor(t){super(),pt(this,t,Du,Eu,h,{},Ou)}};function Bu(t){b(t,"svelte-2uqume",".toggle-and-title.svelte-2uqume.svelte-2uqume{display:flex;align-items:center;gap:0.25em}.icon-tabler-chevron-down.svelte-2uqume polyline.svelte-2uqume{transition:transform 150ms}.rotate-polyline.svelte-2uqume.svelte-2uqume{transform-origin:50% 50%;transform:rotate(-90deg)}")}function ju(t){let e,n,r,i,o,a,s,c,u,h,d,f=`${qu}px`,p=`${qu}px`;return{c(){e=k("div"),n=k("button"),r=M("svg"),i=M("path"),o=M("polyline"),s=A(),c=k("div"),u=L(t[1]),N(i,"stroke","none"),N(i,"d","M0 0h24v24H0z"),N(i,"fill","none"),N(o,"points",a="2 12 12 22 22 12"),N(o,"class","svelte-2uqume"),B(o,"rotate-polyline",!t[0]),N(r,"xmlns","http://www.w3.org/2000/svg"),N(r,"class","icon-tabler icon-tabler-chevron-down svelte-2uqume"),N(r,"width",qu),N(r,"height",qu),N(r,"viewBox","0 0 24 24"),N(r,"stroke-width","4"),N(r,"stroke","currentColor"),N(r,"fill","none"),N(r,"stroke-linecap","round"),N(r,"stroke-linejoin","round"),E(n,"border","none"),E(n,"width",f),E(n,"height",p),E(n,"padding","0"),N(c,"class","group-title"),N(e,"class","toggle-and-title svelte-2uqume")},m(l,a){$(l,e,a),w(e,n),w(n,r),w(r,i),w(r,o),w(e,s),w(e,c),w(c,u),h||(d=S(n,"click",t[2]),h=!0)},p(t,[e]){1&e&&B(o,"rotate-polyline",!t[0]),2&e&&T(u,t[1])},i:l,o:l,d(t){t&&x(e),h=!1,d()}}}const qu=8;function Pu(t,e,n){let{expanded:r=!1}=e,{title:i}=e;return t.$$set=t=>{"expanded"in t&&n(0,r=t.expanded),"title"in t&&n(1,i=t.title)},[r,i,()=>n(0,r=!r)]}const Iu=class extends gt{constructor(t){super(),pt(this,t,Pu,ju,h,{expanded:0,title:1},Bu)}};function Hu(t){b(t,"svelte-1mkvanr",".controls-container.svelte-1mkvanr.svelte-1mkvanr{height:100%;flex:0 0 200px;min-width:200px;max-width:200px;padding:0.25em;border-right:1px solid var(--gray-1);display:flex;flex-direction:column;gap:0.5em}.feature-selector-wrapper-outer.svelte-1mkvanr.svelte-1mkvanr{flex:0 1 auto;min-height:0;display:flex;flex-direction:column}.feature-selector-wrapper-inner.svelte-1mkvanr.svelte-1mkvanr{flex:1;min-height:0}.filter-header.svelte-1mkvanr+.filter-content.svelte-1mkvanr{margin-top:0.25em}.filter-content.svelte-1mkvanr.svelte-1mkvanr{margin-left:0.75em}")}function Fu(t){let e,n,r,i,o,l,a,s,c,u,h,d,f,p,g,m,v,y,b;function _(e){t[8](e)}let M={title:"Type"};function L(e){t[9](e)}void 0!==t[0]&&(M.expanded=t[0]),l=new Iu({props:M}),F.push((()=>ut(l,"expanded",_,t[0]))),u=new Ru({}),u.$on("changeKindFilters",t[3]);let z={title:"Name"};return void 0!==t[1]&&(z.expanded=t[1]),p=new Iu({props:z}),F.push((()=>ut(p,"expanded",L,t[1]))),y=new Tu({props:{enabledFeatures:t[2]}}),y.$on("changeNameFilters",t[4]),{c(){e=k("div"),n=k("div"),n.textContent="Feature Filters",r=A(),i=k("div"),o=k("div"),ht(l.$$.fragment),s=A(),c=k("div"),ht(u.$$.fragment),h=A(),d=k("div"),f=k("div"),ht(p.$$.fragment),m=A(),v=k("div"),ht(y.$$.fragment),N(n,"class","bold"),N(o,"class","filter-header svelte-1mkvanr"),N(c,"class","filter-content svelte-1mkvanr"),B(c,"pdp-hide",!t[0]),N(f,"class","filter-header svelte-1mkvanr"),N(v,"class","filter-content feature-selector-wrapper-inner svelte-1mkvanr"),B(v,"pdp-hide",!t[1]),N(d,"class","filter-container feature-selector-wrapper-outer svelte-1mkvanr"),N(e,"class","controls-container svelte-1mkvanr")},m(t,a){$(t,e,a),w(e,n),w(e,r),w(e,i),w(i,o),dt(l,o,null),w(i,s),w(i,c),dt(u,c,null),w(e,h),w(e,d),w(d,f),dt(p,f,null),w(d,m),w(d,v),dt(y,v,null),b=!0},p(t,[e]){const n={};!a&&1&e&&(a=!0,n.expanded=t[0],U((()=>a=!1))),l.$set(n),(!b||1&e)&&B(c,"pdp-hide",!t[0]);const r={};!g&&2&e&&(g=!0,r.expanded=t[1],U((()=>g=!1))),p.$set(r);const i={};4&e&&(i.enabledFeatures=t[2]),y.$set(i),(!b||2&e)&&B(v,"pdp-hide",!t[1])},i(t){b||(ot(l.$$.fragment,t),ot(u.$$.fragment,t),ot(p.$$.fragment,t),ot(y.$$.fragment,t),b=!0)},o(t){lt(l.$$.fragment,t),lt(u.$$.fragment,t),lt(p.$$.fragment,t),lt(y.$$.fragment,t),b=!1},d(t){t&&x(e),ft(l),ft(u),ft(p),ft(y)}}}function Vu(t,e,n){let r,i,o;p(t,Gn,(t=>n(6,i=t))),p(t,Sn,(t=>n(7,o=t)));const l=I();let a,s=!1,c=!1;return t.$$.update=()=>{224&t.$$.dirty&&n(2,r=o.filter((t=>{const e=i.get(t);return!(!e||!a)&&(e.ordered?a.ordered.shapes.includes(e.shape):a.nominal.checked)})))},[s,c,r,function(t){n(5,a=t.detail)},function(t){l("changeFilters",t.detail)},a,i,o,function(t){s=t,n(0,s)},function(t){c=t,n(1,c)}]}const Xu=class extends gt{constructor(t){super(),pt(this,t,Vu,Fu,h,{},Hu)}};function Wu(t){return 0===t.length||1===t[0].num_features}function Yu(t){b(t,"svelte-19snser",".tooltip-container.svelte-19snser{position:relative;display:flex;align-items:center}.tooltip-content.svelte-19snser{position:absolute;padding:5px;border-radius:5px;max-width:30em;border:1px solid black;color:black;background-color:white;z-index:1;pointer-events:none}")}function Ku(t){let e,n,r,i,o,a,s;return{c(){e=M("svg"),n=M("path"),r=M("circle"),i=M("line"),o=M("path"),N(n,"stroke","none"),N(n,"d","M0 0h24v24H0z"),N(r,"cx","12"),N(r,"cy","12"),N(r,"r","9"),N(i,"x1","12"),N(i,"y1","17"),N(i,"x2","12"),N(i,"y2","17.01"),N(o,"d","M12 13.5a1.5 1.5 0 0 1 1 -1.5a2.6 2.6 0 1 0 -3 -4"),N(e,"xmlns","http://www.w3.org/2000/svg"),N(e,"class","icon icon-tabler icon-tabler-help"),N(e,"width","24"),N(e,"height","24"),N(e,"viewBox","0 0 24 24"),N(e,"stroke-width","2"),N(e,"stroke","currentColor"),N(e,"fill","none"),N(e,"stroke-linecap","round"),N(e,"stroke-linejoin","round")},m(l,c){$(l,e,c),w(e,n),w(e,r),w(e,i),w(e,o),a||(s=[S(e,"mouseenter",t[15]),S(e,"mouseleave",t[16])],a=!0)},p:l,d(t){t&&x(e),a=!1,c(s)}}}function Uu(t){let e,n,r,i,o,a,s;return{c(){e=M("svg"),n=M("path"),r=M("circle"),i=M("line"),o=M("line"),N(n,"stroke","none"),N(n,"d","M0 0h24v24H0z"),N(n,"fill","none"),N(r,"cx","12"),N(r,"cy","12"),N(r,"r","9"),N(i,"x1","12"),N(i,"y1","8"),N(i,"x2","12"),N(i,"y2","12"),N(o,"x1","12"),N(o,"y1","16"),N(o,"x2","12.01"),N(o,"y2","16"),N(e,"xmlns","http://www.w3.org/2000/svg"),N(e,"class","icon icon-tabler icon-tabler-alert-circle"),N(e,"width","24"),N(e,"height","24"),N(e,"viewBox","0 0 24 24"),N(e,"stroke-width","2"),N(e,"stroke","currentColor"),N(e,"fill","none"),N(e,"stroke-linecap","round"),N(e,"stroke-linejoin","round")},m(l,c){$(l,e,c),w(e,n),w(e,r),w(e,i),w(e,o),a||(s=[S(e,"mouseenter",t[13]),S(e,"mouseleave",t[14])],a=!0)},p:l,d(t){t&&x(e),a=!1,c(s)}}}function Gu(t){let e,n,r=`${t[5]}\n      ${t[6]}\n      ${t[7]}\n      ${t[8]}`;const i=t[12].default,o=function(t,e,n,r){if(t){const r=g(t,e,n,null);return t[0](r)}}(i,t,t[11]);return{c(){e=k("div"),o&&o.c(),N(e,"class","tooltip-content small svelte-19snser"),E(e,"top",t[1]),E(e,"right",t[3]),E(e,"bottom",t[4]),E(e,"left",t[2]),E(e,"margin",r),E(e,"width",t[9])},m(t,r){$(t,e,r),o&&o.m(e,null),n=!0},p(t,l){o&&o.p&&(!n||2048&l)&&function(t,e,n,r,i,o){if(i){const l=g(e,n,r,o);t.p(l,i)}}(o,i,t,t[11],n?function(t,e,n,r){if(t[2]&&r){const i=t[2](r(n));if(void 0===e.dirty)return i;if("object"==typeof i){const t=[],n=Math.max(e.dirty.length,i.length);for(let r=0;r<n;r+=1)t[r]=e.dirty[r]|i[r];return t}return e.dirty|i}return e.dirty}(i,t[11],l,null):function(t){if(t.ctx.length>32){const e=[],n=t.ctx.length/32;for(let t=0;t<n;t++)e[t]=-1;return e}return-1}(t[11]),null),2&l&&E(e,"top",t[1]),8&l&&E(e,"right",t[3]),16&l&&E(e,"bottom",t[4]),4&l&&E(e,"left",t[2]),480&l&&r!==(r=`${t[5]}\n      ${t[6]}\n      ${t[7]}\n      ${t[8]}`)&&E(e,"margin",r),512&l&&E(e,"width",t[9])},i(t){n||(ot(o,t),n=!0)},o(t){lt(o,t),n=!1},d(t){t&&x(e),o&&o.d(t)}}}function Zu(t){let e,n,r;function i(t,e){return"alert"===t[0]?Uu:Ku}let o=i(t),l=o(t),a=t[10]&&Gu(t);return{c(){e=k("div"),l.c(),n=A(),a&&a.c(),N(e,"class","tooltip-container svelte-19snser")},m(t,i){$(t,e,i),l.m(e,null),w(e,n),a&&a.m(e,null),r=!0},p(t,[r]){o===(o=i(t))&&l?l.p(t,r):(l.d(1),l=o(t),l&&(l.c(),l.m(e,n))),t[10]?a?(a.p(t,r),1024&r&&ot(a,1)):(a=Gu(t),a.c(),ot(a,1),a.m(e,null)):a&&(rt(),lt(a,1,1,(()=>{a=null})),it())},i(t){r||(ot(a),r=!0)},o(t){lt(a),r=!1},d(t){t&&x(e),l.d(),a&&a.d()}}}function Ju(t,e,n){let{$$slots:r={},$$scope:i}=e,{kind:o="help"}=e,{top:l="auto"}=e,{left:a="auto"}=e,{right:s="auto"}=e,{bottom:c="auto"}=e,{marginTop:u="0"}=e,{marginRight:h="0"}=e,{marginBottom:d="0"}=e,{marginLeft:f="0"}=e,{width:p="30em"}=e,g=!1;return t.$$set=t=>{"kind"in t&&n(0,o=t.kind),"top"in t&&n(1,l=t.top),"left"in t&&n(2,a=t.left),"right"in t&&n(3,s=t.right),"bottom"in t&&n(4,c=t.bottom),"marginTop"in t&&n(5,u=t.marginTop),"marginRight"in t&&n(6,h=t.marginRight),"marginBottom"in t&&n(7,d=t.marginBottom),"marginLeft"in t&&n(8,f=t.marginLeft),"width"in t&&n(9,p=t.width),"$$scope"in t&&n(11,i=t.$$scope)},[o,l,a,s,c,u,h,d,f,p,g,i,r,()=>n(10,g=!0),()=>n(10,g=!1),()=>n(10,g=!0),()=>n(10,g=!1)]}const Qu=class extends gt{constructor(t){super(),pt(this,t,Ju,Zu,h,{kind:0,top:1,left:2,right:3,bottom:4,marginTop:5,marginRight:6,marginBottom:7,marginLeft:8,width:9},Yu)}};function th(t){b(t,"svelte-d2fg2p",".group-container.svelte-d2fg2p.svelte-d2fg2p{height:100%;width:100%;display:flex;flex-direction:column;min-height:2em}.pdp-grid-container.svelte-d2fg2p.svelte-d2fg2p{flex:1;min-height:0}.pdp-grid.svelte-d2fg2p.svelte-d2fg2p{height:100%;display:grid}.group-header.svelte-d2fg2p.svelte-d2fg2p{height:2em;display:flex;align-items:center;gap:1em;border-bottom:1px solid var(--gray-1);padding-left:0.5em;padding-right:0.5em}.two-way-color-container.svelte-d2fg2p.svelte-d2fg2p{flex:1;margin-left:auto;display:flex;align-items:center}.two-way-color-legend.svelte-d2fg2p.svelte-d2fg2p{flex:1}.page-change.svelte-d2fg2p.svelte-d2fg2p{display:flex;align-items:center}.current-page-number.svelte-d2fg2p.svelte-d2fg2p{width:2em;text-align:center}.label-and-input.svelte-d2fg2p.svelte-d2fg2p{display:flex;align-items:center;gap:0.25em}.pdp-grid-element.svelte-d2fg2p.svelte-d2fg2p{position:relative}.pdp-grid-element.svelte-d2fg2p:hover .expand-pdp-button.svelte-d2fg2p{display:block}.expand-pdp-button.svelte-d2fg2p.svelte-d2fg2p{position:absolute;display:none;bottom:2px;left:2px}.dont-shrink.svelte-d2fg2p.svelte-d2fg2p{flex:0 0 auto}.dont-show.svelte-d2fg2p.svelte-d2fg2p{display:none}")}function eh(t,e,n){const r=t.slice();return r[46]=e[n],r}function nh(t,e,n){const r=t.slice();return r[49]=e[n],r}function rh(t){let e,n,r,i=t[49].name+"";return{c(){e=k("option"),n=L(i),e.__value=r=t[49],e.value=e.__value},m(t,r){$(t,e,r),w(e,n)},p(t,o){2&o[0]&&i!==(i=t[49].name+"")&&T(n,i),2&o[0]&&r!==(r=t[49])&&(e.__value=r,e.value=e.__value)},d(t){t&&x(e)}}}function ih(t){let e,n,r,i,o,l,a,s;return{c(){e=k("button"),n=M("svg"),r=M("path"),i=M("path"),o=M("path"),N(r,"stroke","none"),N(r,"d","M0 0h24v24H0z"),N(r,"fill","none"),N(i,"d","M20 11a8.1 8.1 0 0 0 -15.5 -2m-.5 -4v4h4"),N(o,"d","M4 13a8.1 8.1 0 0 0 15.5 2m.5 4v-4h-4"),N(n,"xmlns","http://www.w3.org/2000/svg"),N(n,"class","icon icon-tabler icon-tabler-refresh"),N(n,"width","24"),N(n,"height","24"),N(n,"viewBox","0 0 24 24"),N(n,"stroke-width","2"),N(n,"stroke","currentColor"),N(n,"fill","none"),N(n,"stroke-linecap","round"),N(n,"stroke-linejoin","round"),N(e,"title","Update sorting"),e.disabled=l=!t[13]},m(l,c){$(l,e,c),w(e,n),w(n,r),w(n,i),w(n,o),a||(s=S(e,"click",t[32]),a=!0)},p(t,n){8192&n[0]&&l!==(l=!t[13])&&(e.disabled=l)},d(t){t&&x(e),a=!1,s()}}}function oh(t){let e,n,r,i,o,l,a,s,u;return{c(){e=k("label"),n=k("input"),r=k("span"),r.textContent="Cluster lines",i=A(),o=k("label"),l=k("input"),a=k("span"),a.textContent="Distributions",N(n,"type","checkbox"),N(e,"class","label-and-input svelte-d2fg2p"),N(l,"type","checkbox"),N(o,"class","label-and-input svelte-d2fg2p")},m(c,h){$(c,e,h),w(e,n),n.checked=t[6],w(e,r),$(c,i,h),$(c,o,h),w(o,l),l.checked=t[8],w(o,a),s||(u=[S(n,"change",t[34]),S(l,"change",t[35])],s=!0)},p(t,e){64&e[0]&&(n.checked=t[6]),256&e[0]&&(l.checked=t[8])},d(t){t&&x(e),t&&x(i),t&&x(o),s=!1,c(u)}}}function lh(t){let e,n,r,i,o,l,a;return{c(){e=k("label"),n=L("Color\n          "),r=k("select"),i=k("option"),i.textContent="interactions",o=k("option"),o.textContent="predictions",i.__value="interactions",i.value=i.__value,o.__value="predictions",o.value=o.__value,void 0===t[7]&&K((()=>t[36].call(r))),N(e,"class","label-and-input dont-shrink svelte-d2fg2p")},m(s,c){$(s,e,c),w(e,n),w(e,r),w(r,i),w(r,o),D(r,t[7]),l||(a=S(r,"change",t[36]),l=!0)},p(t,e){128&e[0]&&D(r,t[7])},d(t){t&&x(e),l=!1,a()}}}function ah(t){let e,n;return e=new Qu({props:{kind:"help",right:"0",top:"0",marginRight:"1em",marginTop:"1.5em",width:"30em",$$slots:{default:[uh]},$$scope:{ctx:t}}}),{c(){ht(e.$$.fragment)},m(t,r){dt(e,t,r),n=!0},p(t,n){const r={};524416&n[0]|2097152&n[1]&&(r.$$scope={dirty:n,ctx:t}),e.$set(r)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function sh(t){let e;return{c(){e=L("This color scale is for a standard two-way PDP. The color of a\n              cell represents the model's average prediction when setting the\n              instances to have the given values for pair of features.")},m(t,n){$(t,e,n)},p:l,d(t){t&&x(e)}}}function ch(t){let e,n,r,i,o;return{c(){e=L("This color scale shows the difference between the value in a\n              two-way PDP and the expected value if there was no interaction\n              between the pair of features. It indicates whether the interaction\n              between the two features makes the model's average prediction for\n              the given values "),n=k("span"),n.textContent="lower",r=L("\n              or\n              "),i=k("span"),i.textContent="higher",o=L(". The units are the same as your target variable."),E(n,"background",t[19].interpolator()(.1)),E(n,"border-radius","4px"),E(n,"padding","0.125em 0.25em"),E(n,"color","white"),E(i,"background",t[19].interpolator()(.9)),E(i,"border-radius","4px"),E(i,"padding","0.125em 0.25em"),E(i,"color","white")},m(t,l){$(t,e,l),$(t,n,l),$(t,r,l),$(t,i,l),$(t,o,l)},p(t,e){524288&e[0]&&E(n,"background",t[19].interpolator()(.1)),524288&e[0]&&E(i,"background",t[19].interpolator()(.9))},d(t){t&&x(e),t&&x(n),t&&x(r),t&&x(i),t&&x(o)}}}function uh(t){let e;function n(t,e){return"interactions"===t[7]?ch:sh}let r=n(t),i=r(t);return{c(){e=k("div"),i.c()},m(t,n){$(t,e,n),i.m(e,null)},p(t,o){r===(r=n(t))&&i?i.p(t,o):(i.d(1),i=r(t),i&&(i.c(),i.m(e,null)))},d(t){t&&x(e),i.d()}}}function hh(t,e){let n,r,i,o,l,a,s,c,u=`${e[11]}px`,h=`${e[12]}px`;function d(){return e[38](e[46])}return r=new hc({props:{pd:e[46],width:e[11],height:e[12],scaleLocally:e[15],colorShows:e[7],showMarginalDistribution:e[8],marginTop:10,marginRight:10,showColorLegend:e[15],iceLevel:e[6]?"cluster-centers":"lines",allowBrushing:1===e[18]}}),{key:t,first:null,c(){n=k("div"),ht(r.$$.fragment),i=A(),o=k("button"),o.innerHTML='<svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-arrows-maximize" width="24" height="24" viewBox="0 0 24 24" stroke-width="2" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"></path><path d="M16 4l4 0l0 4m-6 2l6 -6m-12 16l-4 0l0 -4m0 4l6 -6m6 6l4 0l0 -4m-6 -2l6 6m-12 -16l-4 0l0 4m0 -4l6 6"></path></svg>',l=A(),N(o,"class","expand-pdp-button svelte-d2fg2p"),N(n,"class","pdp-grid-element svelte-d2fg2p"),E(n,"max-width",u),E(n,"max-height",h),this.first=n},m(t,e){$(t,n,e),dt(r,n,null),w(n,i),w(n,o),w(n,l),a=!0,s||(c=S(o,"click",d),s=!0)},p(t,i){e=t;const o={};131072&i[0]&&(o.pd=e[46]),2048&i[0]&&(o.width=e[11]),4096&i[0]&&(o.height=e[12]),32768&i[0]&&(o.scaleLocally=e[15]),128&i[0]&&(o.colorShows=e[7]),256&i[0]&&(o.showMarginalDistribution=e[8]),32768&i[0]&&(o.showColorLegend=e[15]),64&i[0]&&(o.iceLevel=e[6]?"cluster-centers":"lines"),262144&i[0]&&(o.allowBrushing=1===e[18]),r.$set(o),2048&i[0]&&u!==(u=`${e[11]}px`)&&E(n,"max-width",u),4096&i[0]&&h!==(h=`${e[12]}px`)&&E(n,"max-height",h)},i(t){a||(ot(r.$$.fragment,t),a=!0)},o(t){lt(r.$$.fragment,t),a=!1},d(t){t&&x(n),ft(r),s=!1,c()}}}function dh(t){let e,n,r,i,o,l,a,s,u,h,d,f,p,g,m,v,y,b,z,C,O,R,j,q,P,I,H,F,V,X,W,Y,U,G,Z,J,Q,tt,et,nt,at,ut,pt,gt=[],mt=new Map,vt=`repeat(${t[5]}, minmax(0,${t[11]}px))`,yt=`repeat(${t[4]}, minmax(0,${t[12]}px))`,wt=t[1],bt=[];for(let e=0;e<wt.length;e+=1)bt[e]=rh(nh(t,wt,e));let $t=1===t[18]&&t[2].forBrushing&&ih(t),xt=1===t[18]&&oh(t),_t=2===t[18]&&lh(t);J=new Ys({props:{width:t[14],height:fh,color:"interactions"===t[7]?t[19]:t[20],marginLeft:15,marginRight:15}});let kt=2===t[18]&&ah(t),Mt=t[17];const Lt=t=>t[46].id;for(let e=0;e<Mt.length;e+=1){let n=eh(t,Mt,e),r=Lt(n);mt.set(r,gt[e]=hh(r,n))}return{c(){e=k("div"),n=k("div"),r=k("div"),i=k("button"),o=M("svg"),l=M("path"),a=M("line"),s=M("line"),u=M("line"),d=A(),f=k("div"),p=L(t[3]),g=A(),m=k("button"),v=M("svg"),y=M("path"),b=M("line"),z=M("line"),C=M("line"),R=A(),j=k("label"),q=L("Sort by\n      "),P=k("select");for(let t=0;t<bt.length;t+=1)bt[t].c();I=A(),$t&&$t.c(),H=A(),F=k("label"),V=k("input"),X=k("span"),X.textContent="Scale locally",W=A(),xt&&xt.c(),Y=A(),U=k("div"),_t&&_t.c(),G=A(),Z=k("div"),ht(J.$$.fragment),Q=A(),kt&&kt.c(),tt=A(),et=k("div"),nt=k("div");for(let t=0;t<gt.length;t+=1)gt[t].c();N(l,"stroke","none"),N(l,"d"," M0 0h24v24H0z"),N(l,"fill","none"),N(a,"x1","5"),N(a,"y1","12"),N(a,"x2","19"),N(a,"y2","12"),N(s,"x1","5"),N(s,"y1","12"),N(s,"x2","11"),N(s,"y2","18"),N(u,"x1","5"),N(u,"y1","12"),N(u,"x2","11"),N(u,"y2","6"),N(o,"xmlns","http://www.w3.org/2000/svg"),N(o,"class","icon icon-tabler icon-tabler-arrow-left"),N(o,"width","24"),N(o,"height","24"),N(o,"viewBox","0 0 24 24"),N(o,"stroke-width","2"),N(o,"stroke","currentColor"),N(o,"fill","none"),N(o,"stroke-linecap","round"),N(o,"stroke-linejoin","round"),i.disabled=h=t[3]<=1,N(i,"title","Previous page"),N(f,"class","current-page-number svelte-d2fg2p"),N(y,"stroke","none"),N(y,"d","M0 0h24v24H0z"),N(y,"fill","none"),N(b,"x1","5"),N(b,"y1","12"),N(b,"x2","19"),N(b,"y2","12"),N(z,"x1","13"),N(z,"y1","18"),N(z,"x2","19"),N(z,"y2","12"),N(C,"x1","13"),N(C,"y1","6"),N(C,"x2","19"),N(C,"y2","12"),N(v,"xmlns","http://www.w3.org/2000/svg"),N(v,"class","icon icon-tabler icon-tabler-arrow-right"),N(v,"width","24"),N(v,"height","24"),N(v,"viewBox","0 0 24 24"),N(v,"stroke-width","2"),N(v,"stroke","currentColor"),N(v,"fill","none"),N(v,"stroke-linecap","round"),N(v,"stroke-linejoin","round"),m.disabled=O=t[3]>=t[16],N(m,"title","Next page"),N(r,"class","page-change dont-shrink svelte-d2fg2p"),void 0===t[2]&&K((()=>t[31].call(P))),N(j,"class","label-and-input dont-shrink svelte-d2fg2p"),N(V,"type","checkbox"),N(F,"class","label-and-input dont-shrink svelte-d2fg2p"),N(Z,"class","two-way-color-legend svelte-d2fg2p"),B(Z,"dont-show",1===t[18]||t[15]),N(U,"class","two-way-color-container svelte-d2fg2p"),N(n,"class","group-header svelte-d2fg2p"),N(nt,"class","pdp-grid svelte-d2fg2p"),E(nt,"grid-template-columns",vt),E(nt,"grid-template-rows",yt),N(et,"class","pdp-grid-container svelte-d2fg2p"),N(e,"class","group-container svelte-d2fg2p")},m(c,h){$(c,e,h),w(e,n),w(n,r),w(r,i),w(i,o),w(o,l),w(o,a),w(o,s),w(o,u),w(r,d),w(r,f),w(f,p),w(r,g),w(r,m),w(m,v),w(v,y),w(v,b),w(v,z),w(v,C),w(n,R),w(n,j),w(j,q),w(j,P);for(let t=0;t<bt.length;t+=1)bt[t].m(P,null);D(P,t[2]),w(n,I),$t&&$t.m(n,null),w(n,H),w(n,F),w(F,V),V.checked=t[15],w(F,X),w(n,W),xt&&xt.m(n,null),w(n,Y),w(n,U),_t&&_t.m(U,null),w(U,G),w(U,Z),dt(J,Z,null),t[37](Z),w(U,Q),kt&&kt.m(U,null),w(e,tt),w(e,et),w(et,nt);for(let t=0;t<gt.length;t+=1)gt[t].m(nt,null);t[39](et),at=!0,ut||(pt=[S(i,"click",t[29]),S(m,"click",t[30]),S(P,"change",t[31]),S(V,"change",t[33])],ut=!0)},p(t,e){if((!at||8&e[0]&&h!==(h=t[3]<=1))&&(i.disabled=h),(!at||8&e[0])&&T(p,t[3]),(!at||65544&e[0]&&O!==(O=t[3]>=t[16]))&&(m.disabled=O),2&e[0]){let n;for(wt=t[1],n=0;n<wt.length;n+=1){const r=nh(t,wt,n);bt[n]?bt[n].p(r,e):(bt[n]=rh(r),bt[n].c(),bt[n].m(P,null))}for(;n<bt.length;n+=1)bt[n].d(1);bt.length=wt.length}6&e[0]&&D(P,t[2]),1===t[18]&&t[2].forBrushing?$t?$t.p(t,e):($t=ih(t),$t.c(),$t.m(n,H)):$t&&($t.d(1),$t=null),32768&e[0]&&(V.checked=t[15]),1===t[18]?xt?xt.p(t,e):(xt=oh(t),xt.c(),xt.m(n,Y)):xt&&(xt.d(1),xt=null),2===t[18]?_t?_t.p(t,e):(_t=lh(t),_t.c(),_t.m(U,G)):_t&&(_t.d(1),_t=null);const r={};16384&e[0]&&(r.width=t[14]),1572992&e[0]&&(r.color="interactions"===t[7]?t[19]:t[20]),J.$set(r),(!at||294912&e[0])&&B(Z,"dont-show",1===t[18]||t[15]),2===t[18]?kt?(kt.p(t,e),262144&e[0]&&ot(kt,1)):(kt=ah(t),kt.c(),ot(kt,1),kt.m(U,null)):kt&&(rt(),lt(kt,1,1,(()=>{kt=null})),it()),8821184&e[0]&&(Mt=t[17],rt(),gt=ct(gt,e,Lt,1,t,Mt,mt,nt,st,hh,null,eh),it()),2080&e[0]&&vt!==(vt=`repeat(${t[5]}, minmax(0,${t[11]}px))`)&&E(nt,"grid-template-columns",vt),4112&e[0]&&yt!==(yt=`repeat(${t[4]}, minmax(0,${t[12]}px))`)&&E(nt,"grid-template-rows",yt)},i(t){if(!at){ot(J.$$.fragment,t),ot(kt);for(let t=0;t<Mt.length;t+=1)ot(gt[t]);at=!0}},o(t){lt(J.$$.fragment,t),lt(kt);for(let t=0;t<gt.length;t+=1)lt(gt[t]);at=!1},d(n){n&&x(e),_(bt,n),$t&&$t.d(),xt&&xt.d(),_t&&_t.d(),ft(J),t[37](null),kt&&kt.d();for(let t=0;t<gt.length;t+=1)gt[t].d();t[39](null),ut=!1,c(pt)}}}const fh=24;function ph(t,e,n){let r,i,o,l,a,s,c,u,h,d,f,g,v,y,w;p(t,Vn,(t=>n(40,c=t))),p(t,Wn,(t=>n(41,u=t))),p(t,Xn,(t=>n(42,h=t))),p(t,Yn,(t=>n(28,d=t))),p(t,Nn,(t=>n(43,f=t))),p(t,Zn,(t=>n(44,g=t))),p(t,Hn,(t=>n(45,v=t))),p(t,Un,(t=>n(19,y=t))),p(t,Kn,(t=>n(20,w=t)));let b,$,x,_,k,M,L,{data:A}=e,{sortingOptions:z}=e,S=!1,N="interactions",C=!1;P((()=>{const t=new ResizeObserver((t=>{if(1!==t.length)return;const e=t[0];if(e.contentBoxSize){const t=Array.isArray(e.contentBoxSize)?e.contentBoxSize[0]:e.contentBoxSize;n(25,_=t.inlineSize),n(26,k=t.blockSize)}else n(25,_=e.contentRect.width),n(26,k=e.contentRect.height)}));t.observe($);const e=new ResizeObserver((t=>{if(1!==t.length)return;const e=t[0];if(e.contentBoxSize){const t=Array.isArray(e.contentBoxSize)?e.contentBoxSize[0]:e.contentBoxSize;n(14,O=t.inlineSize)}else n(14,O=e.contentRect.width)}));return e.observe(x),()=>{t.unobserve($),e.unobserve($)}}));let T=!1,O=140,E=z[0];function D(t){n(13,T=!1),n(24,b=E.sort(t,{highlightedIndices:v,highlightedDistributions:g,featureInfo:f}))}let B=1;function j(t){t<1||t>a||n(3,B=t)}let q=!1;function I(t){m(Xn,h=t.x_feature,h),m(Wn,u=2===t.num_features?t.y_feature:"",u),m(Vn,c="detailed-plot",c)}return t.$$set=t=>{"data"in t&&n(0,A=t.data),"sortingOptions"in t&&n(1,z=t.sortingOptions)},t.$$.update=()=>{1&t.$$.dirty[0]&&n(18,r=Wu(A)?1:2),1&t.$$.dirty[0]&&n(27,i=Math.min(A.length,12)),134217728&t.$$.dirty[0]&&n(4,o=Math.ceil(Math.sqrt(i))),134217744&t.$$.dirty[0]&&n(5,l=Math.ceil(i/o)),33554464&t.$$.dirty[0]&&n(11,M=Math.floor(_/l)),67108880&t.$$.dirty[0]&&n(12,L=Math.floor(k/o)),5&t.$$.dirty[0]&&(E.forBrushing||n(24,b=E.sort(A))),5&t.$$.dirty[0]&&E.forBrushing&&D(A),268435456&t.$$.dirty[0]&&d&&n(13,T=!0),134217729&t.$$.dirty[0]&&n(16,a=Math.ceil(A.length/i)),150994952&t.$$.dirty[0]&&n(17,s=b.slice((B-1)*i,B*i)),1&t.$$.dirty[0]&&j(1)},[A,z,E,B,o,l,S,N,C,$,x,M,L,T,O,q,a,s,r,y,w,D,j,I,b,_,k,i,d,()=>j(B-1),()=>j(B+1),function(){E=R(this),n(2,E),n(1,z)},()=>D(A),function(){q=this.checked,n(15,q)},function(){S=this.checked,n(6,S)},function(){C=this.checked,n(8,C)},function(){N=R(this),n(7,N)},function(t){F[t?"unshift":"push"]((()=>{x=t,n(10,x)}))},t=>I(t),function(t){F[t?"unshift":"push"]((()=>{$=t,n(9,$)}))}]}const gh=class extends gt{constructor(t){super(),pt(this,t,ph,dh,h,{data:0,sortingOptions:1},th,[-1,-1])}};function mh(t,e){let n=0,r=0;if(void 0===e)for(let e of t)null!=e&&(e=+e)>=e&&(++n,r+=e);else{let i=-1;for(let o of t)null!=(o=e(o,++i,t))&&(o=+o)>=o&&(++n,r+=o)}if(n)return r/n}function vh(t){const e=function(t,e){let n=0;for(let e of t)(e=+e)&&(n+=e);return n}(t);return t.map((t=>t/e))}const yh=[{name:"variance",forBrushing:!1,sort:function(t){return 0!==t.length&&Wu(t)?t.sort(((t,e)=>ve(t.deviation,e.deviation))):t}},{name:"cluster difference",forBrushing:!1,sort:function(t){return 0!==t.length&&Wu(t)?t.sort(((t,e)=>ve(t.ice.cluster_distance,e.ice.cluster_distance))):t}},{name:"complexity",forBrushing:!1,sort:function(t){return 0!==t.length&&Wu(t)?(t.sort(((t,e)=>t.ordered?e.ordered?t.knots_good_fit===e.knots_good_fit?ve(t.nrmse_good_fit,e.nrmse_good_fit):ve(t.knots_good_fit,e.knots_good_fit):-1:1)),t):t}},{name:"highlighted similarity",forBrushing:!0,sort:function(t,e){if(0===t.length||!Wu(t)||!e||!e.highlightedIndices||e.highlightedIndices.length<=1)return t;const n=e.highlightedIndices,r=Object.fromEntries(t.map((t=>{var e;const r=n.map((e=>t.ice.ice_lines[e])),i=Lr(r).map((t=>{var e;return null!==(e=mh(t))&&void 0!==e?e:0})),o=function(t,e){return t.map((t=>{let n=0;for(let r=0;r<t.length;r++)n+=Math.abs(t[r]-e[r]);return n/e.length}))}(r,i);return[t.x_feature,null!==(e=mh(o))&&void 0!==e?e:0]})));return t.sort(((t,e)=>me(r[t.x_feature],r[e.x_feature])))}},{name:"highlighted distribution",forBrushing:!0,sort:function(t,e){if(!(0!==t.length&&Wu(t)&&e&&e.highlightedDistributions&&e.featureInfo))return t;const n=e.highlightedDistributions,r=e.featureInfo,i=Object.fromEntries(t.map((t=>{const e=n.get(t.x_feature);if(!e)return[t.x_feature,0];const i=vh(r[t.x_feature].distribution.counts),o=vh(e.counts);let l=0;for(let t=0;t<i.length;t++)l+=Math.abs(o[t]-i[t]);return[t.x_feature,l]})));return t.sort(((t,e)=>ve(i[t.x_feature],i[e.x_feature])))}}],wh=[{name:"interaction",forBrushing:!1,sort:function(t){return 0===t.length||Wu(t)?t:t.sort(((t,e)=>ve(t.H,e.H)))}},{name:"variance",forBrushing:!1,sort:function(t){return 0===t.length||Wu(t)?t:t.sort(((t,e)=>ve(t.deviation,e.deviation)))}}];function bh(t){b(t,"svelte-cuqal2",".one-way-grid-container.svelte-cuqal2{height:100%;display:flex}.pdp-grid-wrapper.svelte-cuqal2{flex:1;min-width:0}")}function $h(t){let e,n,r,i,o,l,a;return r=new Xu({}),r.$on("changeFilters",t[1]),l=new gh({props:{data:t[0],sortingOptions:yh}}),{c(){e=k("div"),n=k("div"),ht(r.$$.fragment),i=A(),o=k("div"),ht(l.$$.fragment),N(o,"class","pdp-grid-wrapper svelte-cuqal2"),N(e,"class","one-way-grid-container svelte-cuqal2")},m(t,s){$(t,e,s),w(e,n),dt(r,n,null),w(e,i),w(e,o),dt(l,o,null),a=!0},p(t,[e]){const n={};1&e&&(n.data=t[0]),l.$set(n)},i(t){a||(ot(r.$$.fragment,t),ot(l.$$.fragment,t),a=!0)},o(t){lt(r.$$.fragment,t),lt(l.$$.fragment,t),a=!1},d(t){t&&x(e),ft(r),ft(l)}}}function xh(t,e,n){let r,i,o;p(t,On,(t=>n(3,i=t))),p(t,Sn,(t=>n(4,o=t)));let l=o;return t.$$.update=()=>{12&t.$$.dirty&&n(0,r=i.filter((t=>l.includes(t.x_feature))))},[r,function(t){n(2,l=t.detail)},l,i]}const _h=class extends gt{constructor(t){super(),pt(this,t,xh,$h,h,{},bh)}};function kh(t){b(t,"svelte-1akrxps",".two-way-grid-container.svelte-1akrxps{height:100%;display:flex}.pdp-grid-wrapper.svelte-1akrxps{flex:1;min-width:0}")}function Mh(t){let e,n,r,i,o,l,a;return r=new Xu({}),r.$on("changeFilters",t[1]),l=new gh({props:{data:t[0],sortingOptions:wh}}),{c(){e=k("div"),n=k("div"),ht(r.$$.fragment),i=A(),o=k("div"),ht(l.$$.fragment),N(o,"class","pdp-grid-wrapper svelte-1akrxps"),N(e,"class","two-way-grid-container svelte-1akrxps")},m(t,s){$(t,e,s),w(e,n),dt(r,n,null),w(e,i),w(e,o),dt(l,o,null),a=!0},p(t,[e]){const n={};1&e&&(n.data=t[0]),l.$set(n)},i(t){a||(ot(r.$$.fragment,t),ot(l.$$.fragment,t),a=!0)},o(t){lt(r.$$.fragment,t),lt(l.$$.fragment,t),a=!1},d(t){t&&x(e),ft(r),ft(l)}}}function Lh(t,e,n){let r,i,o;p(t,En,(t=>n(3,i=t))),p(t,Sn,(t=>n(4,o=t)));let l=o;return t.$$.update=()=>{12&t.$$.dirty&&n(0,r=i.filter((t=>l.includes(t.x_feature)&&l.includes(t.y_feature))))},[r,function(t){n(2,l=t.detail)},l,i]}const Ah=class extends gt{constructor(t){super(),pt(this,t,Lh,Mh,h,{},kh)}};function zh(t){b(t,"svelte-o065mc",".pdpilot-widget-container.svelte-o065mc{box-sizing:border-box;width:100%;display:flex;flex-direction:column;font-size:16px;border:1px solid var(--gray-1);background-color:white;color:black;--magenta:rgb(121, 35, 103);--blue:rgb(0, 95, 204);--gray-0:rgb(247, 247, 247);--gray-1:rgb(226, 226, 226);--gray-2:rgb(198, 198, 198);--gray-3:rgb(171, 171, 171);--gray-4:rgb(145, 145, 145);--gray-5:rgb(119, 119, 119);--gray-6:rgb(94, 94, 94);--gray-7:rgb(71, 71, 71);--gray-8:rgb(48, 48, 48);--gray-9:rgb(27, 27, 27);--black:black;--red:#d62728}.pdp-tab-content.svelte-o065mc{flex:1;min-height:0}.pdpilot-widget-container.svelte-o065mc .pdp-hide{display:none}.pdpilot-widget-container.svelte-o065mc canvas,.pdpilot-widget-container.svelte-o065mc svg{display:block}.pdpilot-widget-container.svelte-o065mc *{box-sizing:border-box;margin:0;padding:0;line-height:1.2}.pdpilot-widget-container.svelte-o065mc button{color:black;background-color:white;border:1px solid black;border-radius:0.25em;text-align:center;cursor:pointer;font-size:1em;padding:0.0625em 0.0625em;font-family:inherit}.pdpilot-widget-container.svelte-o065mc button:hover:enabled{background-color:var(--gray-0)}.pdpilot-widget-container.svelte-o065mc button:active:enabled{background-color:var(--gray-1)}.pdpilot-widget-container.svelte-o065mc button:disabled{cursor:not-allowed;background-color:transparent;color:var(--gray-4);border-color:var(--gray-4)}.pdpilot-widget-container.svelte-o065mc h1{font-size:1.125em;font-weight:500}.pdpilot-widget-container.svelte-o065mc h2{font-size:1.0625em;font-weight:500}.pdpilot-widget-container.svelte-o065mc .large{font-size:1.125em}.pdpilot-widget-container.svelte-o065mc .small{font-size:0.875em}.pdpilot-widget-container.svelte-o065mc .bold{font-weight:500}.pdpilot-widget-container.svelte-o065mc .icon{width:1em;height:1em}.pdpilot-widget-container.svelte-o065mc .cutoff{overflow:hidden;white-space:nowrap;text-overflow:ellipsis}.pdpilot-widget-container.svelte-o065mc .icon-tabler{-webkit-transform:translate(0px, 0px);transform:translate(0px, 0px)}")}function Sh(t){let e,n,r,i,o,l,a,s,c,u,h,d,f=`${t[0]}px`;return n=new ir({}),o=new _h({}),s=new Ah({}),h=new Lu({}),{c(){e=k("div"),ht(n.$$.fragment),r=A(),i=k("div"),ht(o.$$.fragment),l=A(),a=k("div"),ht(s.$$.fragment),c=A(),u=k("div"),ht(h.$$.fragment),N(i,"class","pdp-tab-content svelte-o065mc"),B(i,"pdp-hide","one-way-plots"!==t[1]),N(a,"class","pdp-tab-content svelte-o065mc"),B(a,"pdp-hide","two-way-plots"!==t[1]),N(u,"class","pdp-tab-content svelte-o065mc"),B(u,"pdp-hide","detailed-plot"!==t[1]),N(e,"class","pdpilot-widget-container svelte-o065mc"),E(e,"height",f)},m(t,f){$(t,e,f),dt(n,e,null),w(e,r),w(e,i),dt(o,i,null),w(e,l),w(e,a),dt(s,a,null),w(e,c),w(e,u),dt(h,u,null),d=!0},p(t,[n]){(!d||2&n)&&B(i,"pdp-hide","one-way-plots"!==t[1]),(!d||2&n)&&B(a,"pdp-hide","two-way-plots"!==t[1]),(!d||2&n)&&B(u,"pdp-hide","detailed-plot"!==t[1]),1&n&&f!==(f=`${t[0]}px`)&&E(e,"height",f)},i(t){d||(ot(n.$$.fragment,t),ot(o.$$.fragment,t),ot(s.$$.fragment,t),ot(h.$$.fragment,t),d=!0)},o(t){lt(n.$$.fragment,t),lt(o.$$.fragment,t),lt(s.$$.fragment,t),lt(h.$$.fragment,t),d=!1},d(t){t&&x(e),ft(n),ft(o),ft(s),ft(h)}}}function Nh(t,e,n){let r,i;return p(t,In,(t=>n(0,r=t))),p(t,Vn,(t=>n(1,i=t))),[r,i]}const Ch=class extends gt{constructor(t){super(),pt(this,t,Nh,Sh,h,{},zh)}};class Th extends o.DOMWidgetModel{defaults(){return Object.assign(Object.assign({},super.defaults()),{_model_name:Th.model_name,_model_module:Th.model_module,_model_module_version:Th.model_module_version,_view_name:Th.view_name,_view_module:Th.view_module,_view_module_version:Th.view_module_version,feature_names:[],feature_info:{},dataset:{},num_instances:0,one_way_pds:[],two_way_pds:[],two_way_pdp_extent:[0,0],two_way_interaction_extent:[0,0],ice_line_extent:[0,0],ice_cluster_center_extent:[0,0],ice_cluster_band_extent:[0,0],ice_cluster_line_extent:[0,0],height:600,highlighted_indices:[],two_way_to_calculate:[]})}}Th.serializers=Object.assign({},o.DOMWidgetModel.serializers),Th.model_name="PDPilotModel",Th.model_module=n,Th.model_module_version=e,Th.view_name="PDPilotView",Th.view_module=n,Th.view_module_version=e;class Oh extends o.DOMWidgetView{render(){Jn(this.model),new Ch({target:this.el})}}window.__webpack_public_path__=document.querySelector("body").getAttribute("data-base-url")+"nbextensions/pdpilot"})(),i})()));